/* valaclass.c generated by valac, the Vala compiler
 * generated from valaclass.vala, do not modify */

/* valaclass.vala
 *
 * Copyright (C) 2006-2012  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include "vala.h"
#include <glib.h>
#include <valagee.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>

#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_map_unref0(var) ((var == NULL) ? NULL : (var = (vala_map_unref (var), NULL)))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))

struct _ValaClassPrivate {
	ValaClass* _base_class;
	gboolean _is_abstract;
	gboolean _is_sealed;
	gboolean _has_private_fields;
	gboolean _has_class_private_fields;
	gboolean* _is_compact;
	gboolean* _is_opaque;
	gboolean* _is_immutable;
	gboolean* _is_singleton;
	ValaList* base_types;
	ValaHashMap* implicit_implementations;
	ValaCreationMethod* _default_construction_method;
	ValaConstructor* _constructor;
	ValaConstructor* _class_constructor;
	ValaConstructor* _static_constructor;
	ValaDestructor* _destructor;
	ValaDestructor* _class_destructor;
	ValaDestructor* _static_destructor;
};

static gint ValaClass_private_offset;
static gpointer vala_class_parent_class = NULL;

static gboolean* _bool_dup (gboolean* self);
static void vala_class_set_has_class_private_fields (ValaClass* self,
                                              gboolean value);
static guint _vala_symbol_hash_func_ghash_func (gconstpointer key);
static gboolean _vala_symbol_equal_func_gequal_func (gconstpointer a,
                                              gconstpointer b);
static void vala_class_set_default_construction_method (ValaClass* self,
                                                 ValaCreationMethod* value);
static void vala_class_set_constructor (ValaClass* self,
                                 ValaConstructor* value);
static void vala_class_set_class_constructor (ValaClass* self,
                                       ValaConstructor* value);
static void vala_class_set_static_constructor (ValaClass* self,
                                        ValaConstructor* value);
static void vala_class_set_destructor (ValaClass* self,
                                ValaDestructor* value);
static void vala_class_set_static_destructor (ValaClass* self,
                                       ValaDestructor* value);
static void vala_class_set_class_destructor (ValaClass* self,
                                      ValaDestructor* value);
static void vala_class_real_add_field (ValaSymbol* base,
                                ValaField* f);
static void vala_class_real_add_method (ValaSymbol* base,
                                 ValaMethod* m);
static void vala_class_real_add_property (ValaSymbol* base,
                                   ValaProperty* prop);
static void vala_class_real_add_constructor (ValaSymbol* base,
                                      ValaConstructor* c);
static void vala_class_real_add_destructor (ValaSymbol* base,
                                     ValaDestructor* d);
static void vala_class_real_accept (ValaCodeNode* base,
                             ValaCodeVisitor* visitor);
static void vala_class_real_accept_children (ValaCodeNode* base,
                                      ValaCodeVisitor* visitor);
static gboolean vala_class_real_is_reference_type (ValaTypeSymbol* base);
static gboolean vala_class_real_is_subtype_of (ValaTypeSymbol* base,
                                        ValaTypeSymbol* t);
static void vala_class_real_replace_type (ValaCodeNode* base,
                                   ValaDataType* old_type,
                                   ValaDataType* new_type);
static void vala_class_get_all_prerequisites (ValaClass* self,
                                       ValaInterface* iface,
                                       ValaList* list);
static gboolean vala_class_real_check (ValaCodeNode* base,
                                ValaCodeContext* context);
static void vala_class_finalize (ValaCodeNode * obj);
static GType vala_class_get_type_once (void);

static inline gpointer
vala_class_get_instance_private (ValaClass* self)
{
	return G_STRUCT_MEMBER_P (self, ValaClass_private_offset);
}

ValaClass*
vala_class_get_base_class (ValaClass* self)
{
	ValaClass* result;
	ValaClass* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_base_class;
	result = _tmp0_;
	return result;
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

void
vala_class_set_base_class (ValaClass* self,
                           ValaClass* value)
{
	ValaClass* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_base_class);
	self->priv->_base_class = _tmp0_;
}

gboolean
vala_class_get_is_abstract (ValaClass* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_abstract;
	return result;
}

void
vala_class_set_is_abstract (ValaClass* self,
                            gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_abstract = value;
}

gboolean
vala_class_get_is_sealed (ValaClass* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_sealed;
	return result;
}

void
vala_class_set_is_sealed (ValaClass* self,
                          gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_sealed = value;
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
	dup = g_new0 (gboolean, 1);
	memcpy (dup, self, sizeof (gboolean));
	return dup;
}

static gpointer
__bool_dup0 (gpointer self)
{
	return self ? _bool_dup (self) : NULL;
}

gboolean
vala_class_get_is_compact (ValaClass* self)
{
	gboolean result;
	gboolean* _tmp0_;
	gboolean* _tmp11_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_compact;
	if (_tmp0_ == NULL) {
		gboolean _tmp1_ = FALSE;
		ValaClass* _tmp2_;
		_tmp2_ = self->priv->_base_class;
		if (_tmp2_ != NULL) {
			ValaClass* _tmp3_;
			_tmp3_ = self->priv->_base_class;
			_tmp1_ = !vala_typesymbol_is_subtype_of ((ValaTypeSymbol*) _tmp3_, (ValaTypeSymbol*) self);
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			ValaClass* _tmp4_;
			gboolean _tmp5_;
			gboolean _tmp6_;
			gboolean* _tmp7_;
			_tmp4_ = self->priv->_base_class;
			_tmp5_ = vala_class_get_is_compact (_tmp4_);
			_tmp6_ = _tmp5_;
			_tmp7_ = __bool_dup0 (&_tmp6_);
			_g_free0 (self->priv->_is_compact);
			self->priv->_is_compact = _tmp7_;
		} else {
			ValaAttribute* _tmp8_;
			gboolean _tmp9_;
			gboolean* _tmp10_;
			_tmp8_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "Compact");
			_tmp9_ = _tmp8_ != NULL;
			_tmp10_ = __bool_dup0 (&_tmp9_);
			_g_free0 (self->priv->_is_compact);
			self->priv->_is_compact = _tmp10_;
		}
	}
	_tmp11_ = self->priv->_is_compact;
	result = *_tmp11_;
	return result;
}

gboolean
vala_class_get_is_opaque (ValaClass* self)
{
	gboolean result;
	gboolean* _tmp0_;
	gboolean* _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_opaque;
	if (_tmp0_ == NULL) {
		gboolean _tmp1_;
		gboolean* _tmp2_;
		_tmp1_ = vala_code_node_get_attribute_bool ((ValaCodeNode*) self, "Compact", "opaque", FALSE);
		_tmp2_ = __bool_dup0 (&_tmp1_);
		_g_free0 (self->priv->_is_opaque);
		self->priv->_is_opaque = _tmp2_;
	}
	_tmp3_ = self->priv->_is_opaque;
	result = *_tmp3_;
	return result;
}

gboolean
vala_class_get_is_immutable (ValaClass* self)
{
	gboolean result;
	gboolean* _tmp0_;
	gboolean* _tmp11_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_immutable;
	if (_tmp0_ == NULL) {
		gboolean _tmp1_ = FALSE;
		ValaClass* _tmp2_;
		_tmp2_ = self->priv->_base_class;
		if (_tmp2_ != NULL) {
			ValaClass* _tmp3_;
			_tmp3_ = self->priv->_base_class;
			_tmp1_ = !vala_typesymbol_is_subtype_of ((ValaTypeSymbol*) _tmp3_, (ValaTypeSymbol*) self);
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			ValaClass* _tmp4_;
			gboolean _tmp5_;
			gboolean _tmp6_;
			gboolean* _tmp7_;
			_tmp4_ = self->priv->_base_class;
			_tmp5_ = vala_class_get_is_immutable (_tmp4_);
			_tmp6_ = _tmp5_;
			_tmp7_ = __bool_dup0 (&_tmp6_);
			_g_free0 (self->priv->_is_immutable);
			self->priv->_is_immutable = _tmp7_;
		} else {
			ValaAttribute* _tmp8_;
			gboolean _tmp9_;
			gboolean* _tmp10_;
			_tmp8_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "Immutable");
			_tmp9_ = _tmp8_ != NULL;
			_tmp10_ = __bool_dup0 (&_tmp9_);
			_g_free0 (self->priv->_is_immutable);
			self->priv->_is_immutable = _tmp10_;
		}
	}
	_tmp11_ = self->priv->_is_immutable;
	result = *_tmp11_;
	return result;
}

gboolean
vala_class_get_is_singleton (ValaClass* self)
{
	gboolean result;
	gboolean* _tmp0_;
	gboolean* _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_singleton;
	if (_tmp0_ == NULL) {
		ValaAttribute* _tmp1_;
		gboolean _tmp2_;
		gboolean* _tmp3_;
		_tmp1_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "SingleInstance");
		_tmp2_ = _tmp1_ != NULL;
		_tmp3_ = __bool_dup0 (&_tmp2_);
		_g_free0 (self->priv->_is_singleton);
		self->priv->_is_singleton = _tmp3_;
	}
	_tmp4_ = self->priv->_is_singleton;
	result = *_tmp4_;
	return result;
}

gboolean
vala_class_get_has_private_fields (ValaClass* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_private_fields;
	return result;
}

void
vala_class_set_has_private_fields (ValaClass* self,
                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_has_private_fields = value;
}

gboolean
vala_class_get_has_class_private_fields (ValaClass* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_class_private_fields;
	return result;
}

static void
vala_class_set_has_class_private_fields (ValaClass* self,
                                         gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_has_class_private_fields = value;
}

static guint
_vala_symbol_hash_func_ghash_func (gconstpointer key)
{
	guint result;
	result = vala_symbol_hash_func ((ValaSymbol*) key);
	return result;
}

static gboolean
_vala_symbol_equal_func_gequal_func (gconstpointer a,
                                     gconstpointer b)
{
	gboolean result;
	result = vala_symbol_equal_func ((ValaSymbol*) a, (ValaSymbol*) b);
	return result;
}

ValaCreationMethod*
vala_class_get_default_construction_method (ValaClass* self)
{
	ValaCreationMethod* result;
	ValaCreationMethod* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_construction_method;
	result = _tmp0_;
	return result;
}

static void
vala_class_set_default_construction_method (ValaClass* self,
                                            ValaCreationMethod* value)
{
	ValaCreationMethod* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_default_construction_method);
	self->priv->_default_construction_method = _tmp0_;
}

ValaConstructor*
vala_class_get_constructor (ValaClass* self)
{
	ValaConstructor* result;
	ValaConstructor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_constructor;
	result = _tmp0_;
	return result;
}

static void
vala_class_set_constructor (ValaClass* self,
                            ValaConstructor* value)
{
	ValaConstructor* _tmp0_;
	ValaConstructor* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_constructor);
	self->priv->_constructor = _tmp0_;
	_tmp1_ = self->priv->_constructor;
	if (_tmp1_ != NULL) {
		ValaConstructor* _tmp2_;
		ValaScope* _tmp3_;
		ValaScope* _tmp4_;
		_tmp2_ = self->priv->_constructor;
		_tmp3_ = vala_symbol_get_scope ((ValaSymbol*) self);
		_tmp4_ = _tmp3_;
		vala_symbol_set_owner ((ValaSymbol*) _tmp2_, _tmp4_);
	}
}

ValaConstructor*
vala_class_get_class_constructor (ValaClass* self)
{
	ValaConstructor* result;
	ValaConstructor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_class_constructor;
	result = _tmp0_;
	return result;
}

static void
vala_class_set_class_constructor (ValaClass* self,
                                  ValaConstructor* value)
{
	ValaConstructor* _tmp0_;
	ValaConstructor* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_class_constructor);
	self->priv->_class_constructor = _tmp0_;
	_tmp1_ = self->priv->_class_constructor;
	if (_tmp1_ != NULL) {
		ValaConstructor* _tmp2_;
		ValaScope* _tmp3_;
		ValaScope* _tmp4_;
		_tmp2_ = self->priv->_class_constructor;
		_tmp3_ = vala_symbol_get_scope ((ValaSymbol*) self);
		_tmp4_ = _tmp3_;
		vala_symbol_set_owner ((ValaSymbol*) _tmp2_, _tmp4_);
	}
}

ValaConstructor*
vala_class_get_static_constructor (ValaClass* self)
{
	ValaConstructor* result;
	ValaConstructor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_static_constructor;
	result = _tmp0_;
	return result;
}

static void
vala_class_set_static_constructor (ValaClass* self,
                                   ValaConstructor* value)
{
	ValaConstructor* _tmp0_;
	ValaConstructor* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_static_constructor);
	self->priv->_static_constructor = _tmp0_;
	_tmp1_ = self->priv->_static_constructor;
	if (_tmp1_ != NULL) {
		ValaConstructor* _tmp2_;
		ValaScope* _tmp3_;
		ValaScope* _tmp4_;
		_tmp2_ = self->priv->_static_constructor;
		_tmp3_ = vala_symbol_get_scope ((ValaSymbol*) self);
		_tmp4_ = _tmp3_;
		vala_symbol_set_owner ((ValaSymbol*) _tmp2_, _tmp4_);
	}
}

ValaDestructor*
vala_class_get_destructor (ValaClass* self)
{
	ValaDestructor* result;
	ValaDestructor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_destructor;
	result = _tmp0_;
	return result;
}

static void
vala_class_set_destructor (ValaClass* self,
                           ValaDestructor* value)
{
	ValaDestructor* _tmp0_;
	ValaDestructor* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_destructor);
	self->priv->_destructor = _tmp0_;
	_tmp1_ = self->priv->_destructor;
	if (_tmp1_ != NULL) {
		ValaDestructor* _tmp2_;
		ValaScope* _tmp3_;
		ValaScope* _tmp4_;
		_tmp2_ = self->priv->_destructor;
		_tmp3_ = vala_symbol_get_scope ((ValaSymbol*) self);
		_tmp4_ = _tmp3_;
		vala_symbol_set_owner ((ValaSymbol*) _tmp2_, _tmp4_);
	}
}

ValaDestructor*
vala_class_get_static_destructor (ValaClass* self)
{
	ValaDestructor* result;
	ValaDestructor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_static_destructor;
	result = _tmp0_;
	return result;
}

static void
vala_class_set_static_destructor (ValaClass* self,
                                  ValaDestructor* value)
{
	ValaDestructor* _tmp0_;
	ValaDestructor* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_static_destructor);
	self->priv->_static_destructor = _tmp0_;
	_tmp1_ = self->priv->_static_destructor;
	if (_tmp1_ != NULL) {
		ValaDestructor* _tmp2_;
		ValaScope* _tmp3_;
		ValaScope* _tmp4_;
		_tmp2_ = self->priv->_static_destructor;
		_tmp3_ = vala_symbol_get_scope ((ValaSymbol*) self);
		_tmp4_ = _tmp3_;
		vala_symbol_set_owner ((ValaSymbol*) _tmp2_, _tmp4_);
	}
}

ValaDestructor*
vala_class_get_class_destructor (ValaClass* self)
{
	ValaDestructor* result;
	ValaDestructor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_class_destructor;
	result = _tmp0_;
	return result;
}

static void
vala_class_set_class_destructor (ValaClass* self,
                                 ValaDestructor* value)
{
	ValaDestructor* _tmp0_;
	ValaDestructor* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _vala_code_node_ref0 (value);
	_vala_code_node_unref0 (self->priv->_class_destructor);
	self->priv->_class_destructor = _tmp0_;
	_tmp1_ = self->priv->_class_destructor;
	if (_tmp1_ != NULL) {
		ValaDestructor* _tmp2_;
		ValaScope* _tmp3_;
		ValaScope* _tmp4_;
		_tmp2_ = self->priv->_class_destructor;
		_tmp3_ = vala_symbol_get_scope ((ValaSymbol*) self);
		_tmp4_ = _tmp3_;
		vala_symbol_set_owner ((ValaSymbol*) _tmp2_, _tmp4_);
	}
}

gboolean
vala_class_get_is_error_base (ValaClass* self)
{
	gboolean result;
	ValaAttribute* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = vala_code_node_get_attribute ((ValaCodeNode*) self, "ErrorBase");
	result = _tmp0_ != NULL;
	return result;
}

/**
 * Creates a new class.
 *
 * @param name             type name
 * @param source_reference reference to source code
 * @param comment          class documentation
 * @return                 newly created class
 */
ValaClass*
vala_class_construct (GType object_type,
                      const gchar* name,
                      ValaSourceReference* source_reference,
                      ValaComment* comment)
{
	ValaClass* self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (ValaClass*) vala_object_type_symbol_construct (object_type, name, source_reference, comment);
	return self;
}

ValaClass*
vala_class_new (const gchar* name,
                ValaSourceReference* source_reference,
                ValaComment* comment)
{
	return vala_class_construct (VALA_TYPE_CLASS, name, source_reference, comment);
}

/**
 * Adds the specified class or interface to the list of base types of
 * this class.
 *
 * @param type a class or interface reference
 */
void
vala_class_add_base_type (ValaClass* self,
                          ValaDataType* type)
{
	ValaList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (type != NULL);
	_tmp0_ = self->priv->base_types;
	vala_collection_add ((ValaCollection*) _tmp0_, type);
	vala_code_node_set_parent_node ((ValaCodeNode*) type, (ValaCodeNode*) self);
}

/**
 * Returns the base type list.
 *
 * @return list of base types
 */
ValaList*
vala_class_get_base_types (ValaClass* self)
{
	ValaList* _tmp0_;
	ValaList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->base_types;
	result = _tmp0_;
	return result;
}

/**
 * Adds the specified field as a member to this class.
 *
 * @param f a field
 */
static void
vala_class_real_add_field (ValaSymbol* base,
                           ValaField* f)
{
	ValaClass * self;
	gboolean _tmp0_ = FALSE;
	ValaSymbolAccessibility _tmp1_;
	ValaSymbolAccessibility _tmp2_;
	self = (ValaClass*) base;
	g_return_if_fail (f != NULL);
	VALA_SYMBOL_CLASS (vala_class_parent_class)->add_field ((ValaSymbol*) G_TYPE_CHECK_INSTANCE_CAST (self, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol), f);
	_tmp1_ = vala_symbol_get_access ((ValaSymbol*) f);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == VALA_SYMBOL_ACCESSIBILITY_PRIVATE) {
		ValaMemberBinding _tmp3_;
		ValaMemberBinding _tmp4_;
		_tmp3_ = vala_field_get_binding (f);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ == VALA_MEMBER_BINDING_INSTANCE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		vala_class_set_has_private_fields (self, TRUE);
	} else {
		gboolean _tmp5_ = FALSE;
		ValaSymbolAccessibility _tmp6_;
		ValaSymbolAccessibility _tmp7_;
		_tmp6_ = vala_symbol_get_access ((ValaSymbol*) f);
		_tmp7_ = _tmp6_;
		if (_tmp7_ == VALA_SYMBOL_ACCESSIBILITY_PRIVATE) {
			ValaMemberBinding _tmp8_;
			ValaMemberBinding _tmp9_;
			_tmp8_ = vala_field_get_binding (f);
			_tmp9_ = _tmp8_;
			_tmp5_ = _tmp9_ == VALA_MEMBER_BINDING_CLASS;
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			vala_class_set_has_class_private_fields (self, TRUE);
		}
	}
}

/**
 * Adds the specified method as a member to this class.
 *
 * @param m a method
 */
static void
vala_class_real_add_method (ValaSymbol* base,
                            ValaMethod* m)
{
	ValaClass * self;
	gboolean _tmp0_ = FALSE;
	ValaMemberBinding _tmp1_;
	ValaMemberBinding _tmp2_;
	gboolean _tmp23_ = FALSE;
	ValaDataType* _tmp24_;
	ValaDataType* _tmp25_;
	self = (ValaClass*) base;
	g_return_if_fail (m != NULL);
	_tmp1_ = vala_method_get_binding (m);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != VALA_MEMBER_BINDING_STATIC) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = VALA_IS_CREATION_METHOD (m);
	}
	if (_tmp0_) {
		ValaParameter* _tmp3_;
		ValaParameter* _tmp4_;
		ValaDataType* _tmp11_;
		ValaDataType* _tmp12_;
		ValaParameter* _tmp13_;
		ValaParameter* _tmp14_;
		ValaScope* _tmp15_;
		ValaScope* _tmp16_;
		ValaParameter* _tmp17_;
		ValaParameter* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		ValaParameter* _tmp21_;
		ValaParameter* _tmp22_;
		_tmp3_ = vala_method_get_this_parameter (m);
		_tmp4_ = _tmp3_;
		if (_tmp4_ != NULL) {
			ValaScope* _tmp5_;
			ValaScope* _tmp6_;
			ValaParameter* _tmp7_;
			ValaParameter* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			_tmp5_ = vala_symbol_get_scope ((ValaSymbol*) m);
			_tmp6_ = _tmp5_;
			_tmp7_ = vala_method_get_this_parameter (m);
			_tmp8_ = _tmp7_;
			_tmp9_ = vala_symbol_get_name ((ValaSymbol*) _tmp8_);
			_tmp10_ = _tmp9_;
			vala_scope_remove (_tmp6_, _tmp10_);
		}
		_tmp11_ = vala_semantic_analyzer_get_this_type ((ValaSymbol*) m, (ValaTypeSymbol*) self);
		_tmp12_ = _tmp11_;
		_tmp13_ = vala_parameter_new ("this", _tmp12_, NULL);
		_tmp14_ = _tmp13_;
		vala_method_set_this_parameter (m, _tmp14_);
		_vala_code_node_unref0 (_tmp14_);
		_vala_code_node_unref0 (_tmp12_);
		_tmp15_ = vala_symbol_get_scope ((ValaSymbol*) m);
		_tmp16_ = _tmp15_;
		_tmp17_ = vala_method_get_this_parameter (m);
		_tmp18_ = _tmp17_;
		_tmp19_ = vala_symbol_get_name ((ValaSymbol*) _tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = vala_method_get_this_parameter (m);
		_tmp22_ = _tmp21_;
		vala_scope_add (_tmp16_, _tmp20_, (ValaSymbol*) _tmp22_);
	}
	_tmp24_ = vala_callable_get_return_type ((ValaCallable*) m);
	_tmp25_ = _tmp24_;
	if (!VALA_IS_VOID_TYPE (_tmp25_)) {
		ValaList* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
		_tmp26_ = vala_method_get_postconditions (m);
		_tmp27_ = vala_collection_get_size ((ValaCollection*) _tmp26_);
		_tmp28_ = _tmp27_;
		_tmp23_ = _tmp28_ > 0;
	} else {
		_tmp23_ = FALSE;
	}
	if (_tmp23_) {
		ValaLocalVariable* _tmp29_;
		ValaLocalVariable* _tmp30_;
		ValaDataType* _tmp37_;
		ValaDataType* _tmp38_;
		ValaDataType* _tmp39_;
		ValaDataType* _tmp40_;
		ValaSourceReference* _tmp41_;
		ValaSourceReference* _tmp42_;
		ValaLocalVariable* _tmp43_;
		ValaLocalVariable* _tmp44_;
		ValaLocalVariable* _tmp45_;
		ValaLocalVariable* _tmp46_;
		_tmp29_ = vala_subroutine_get_result_var ((ValaSubroutine*) m);
		_tmp30_ = _tmp29_;
		if (_tmp30_ != NULL) {
			ValaScope* _tmp31_;
			ValaScope* _tmp32_;
			ValaLocalVariable* _tmp33_;
			ValaLocalVariable* _tmp34_;
			const gchar* _tmp35_;
			const gchar* _tmp36_;
			_tmp31_ = vala_symbol_get_scope ((ValaSymbol*) m);
			_tmp32_ = _tmp31_;
			_tmp33_ = vala_subroutine_get_result_var ((ValaSubroutine*) m);
			_tmp34_ = _tmp33_;
			_tmp35_ = vala_symbol_get_name ((ValaSymbol*) _tmp34_);
			_tmp36_ = _tmp35_;
			vala_scope_remove (_tmp32_, _tmp36_);
		}
		_tmp37_ = vala_callable_get_return_type ((ValaCallable*) m);
		_tmp38_ = _tmp37_;
		_tmp39_ = vala_data_type_copy (_tmp38_);
		_tmp40_ = _tmp39_;
		_tmp41_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp42_ = _tmp41_;
		_tmp43_ = vala_local_variable_new (_tmp40_, "result", NULL, _tmp42_);
		_tmp44_ = _tmp43_;
		vala_subroutine_set_result_var ((ValaSubroutine*) m, _tmp44_);
		_vala_code_node_unref0 (_tmp44_);
		_vala_code_node_unref0 (_tmp40_);
		_tmp45_ = vala_subroutine_get_result_var ((ValaSubroutine*) m);
		_tmp46_ = _tmp45_;
		vala_local_variable_set_is_result (_tmp46_, TRUE);
	}
	if (VALA_IS_CREATION_METHOD (m)) {
		const gchar* _tmp47_;
		const gchar* _tmp48_;
		ValaCreationMethod* cm = NULL;
		gboolean _tmp49_ = FALSE;
		ValaCreationMethod* _tmp50_;
		const gchar* _tmp51_;
		const gchar* _tmp52_;
		gboolean _tmp65_ = FALSE;
		gboolean _tmp66_;
		_tmp47_ = vala_symbol_get_name ((ValaSymbol*) m);
		_tmp48_ = _tmp47_;
		if (_tmp48_ == NULL) {
			vala_class_set_default_construction_method (self, G_TYPE_CHECK_INSTANCE_CAST (m, VALA_TYPE_CREATION_METHOD, ValaCreationMethod));
			vala_symbol_set_name ((ValaSymbol*) m, ".new");
		}
		cm = G_TYPE_CHECK_INSTANCE_CAST (m, VALA_TYPE_CREATION_METHOD, ValaCreationMethod);
		_tmp50_ = cm;
		_tmp51_ = vala_creation_method_get_class_name (_tmp50_);
		_tmp52_ = _tmp51_;
		if (_tmp52_ != NULL) {
			ValaCreationMethod* _tmp53_;
			const gchar* _tmp54_;
			const gchar* _tmp55_;
			const gchar* _tmp56_;
			const gchar* _tmp57_;
			_tmp53_ = cm;
			_tmp54_ = vala_creation_method_get_class_name (_tmp53_);
			_tmp55_ = _tmp54_;
			_tmp56_ = vala_symbol_get_name ((ValaSymbol*) self);
			_tmp57_ = _tmp56_;
			_tmp49_ = g_strcmp0 (_tmp55_, _tmp57_) != 0;
		} else {
			_tmp49_ = FALSE;
		}
		if (_tmp49_) {
			ValaSourceReference* _tmp58_;
			ValaSourceReference* _tmp59_;
			gchar* _tmp60_;
			gchar* _tmp61_;
			ValaCreationMethod* _tmp62_;
			const gchar* _tmp63_;
			const gchar* _tmp64_;
			_tmp58_ = vala_code_node_get_source_reference ((ValaCodeNode*) m);
			_tmp59_ = _tmp58_;
			_tmp60_ = vala_symbol_get_full_name ((ValaSymbol*) self);
			_tmp61_ = _tmp60_;
			_tmp62_ = cm;
			_tmp63_ = vala_creation_method_get_class_name (_tmp62_);
			_tmp64_ = _tmp63_;
			vala_report_error (_tmp59_, "missing return type in method `%s.%s´", _tmp61_, _tmp64_);
			_g_free0 (_tmp61_);
			vala_code_node_set_error ((ValaCodeNode*) m, TRUE);
			return;
		}
		_tmp66_ = self->priv->_is_abstract;
		if (_tmp66_) {
			ValaCreationMethod* _tmp67_;
			ValaSymbolAccessibility _tmp68_;
			ValaSymbolAccessibility _tmp69_;
			_tmp67_ = cm;
			_tmp68_ = vala_symbol_get_access ((ValaSymbol*) _tmp67_);
			_tmp69_ = _tmp68_;
			_tmp65_ = _tmp69_ == VALA_SYMBOL_ACCESSIBILITY_PUBLIC;
		} else {
			_tmp65_ = FALSE;
		}
		if (_tmp65_) {
			gboolean _tmp70_;
			gboolean _tmp71_;
			_tmp70_ = vala_symbol_get_external_package ((ValaSymbol*) self);
			_tmp71_ = _tmp70_;
			if (_tmp71_) {
				ValaSourceReference* _tmp72_;
				ValaSourceReference* _tmp73_;
				_tmp72_ = vala_code_node_get_source_reference ((ValaCodeNode*) m);
				_tmp73_ = _tmp72_;
				vala_report_warning (_tmp73_, "Creation method of abstract class cannot be public.");
			} else {
				ValaSourceReference* _tmp74_;
				ValaSourceReference* _tmp75_;
				_tmp74_ = vala_code_node_get_source_reference ((ValaCodeNode*) m);
				_tmp75_ = _tmp74_;
				vala_report_error (_tmp75_, "Creation method of abstract class cannot be public.");
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				return;
			}
		}
	}
	VALA_SYMBOL_CLASS (vala_class_parent_class)->add_method ((ValaSymbol*) G_TYPE_CHECK_INSTANCE_CAST (self, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol), m);
}

static gpointer
_vala_map_ref0 (gpointer self)
{
	return self ? vala_map_ref (self) : NULL;
}

ValaHashMap*
vala_class_get_implicit_implementations (ValaClass* self)
{
	ValaHashMap* _tmp0_;
	ValaHashMap* _tmp1_;
	ValaHashMap* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->implicit_implementations;
	_tmp1_ = _vala_map_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

/**
 * Adds the specified property as a member to this class.
 *
 * @param prop a property
 */
static void
vala_class_real_add_property (ValaSymbol* base,
                              ValaProperty* prop)
{
	ValaClass * self;
	ValaMemberBinding _tmp0_;
	ValaMemberBinding _tmp1_;
	ValaField* _tmp14_;
	ValaField* _tmp15_;
	self = (ValaClass*) base;
	g_return_if_fail (prop != NULL);
	VALA_SYMBOL_CLASS (vala_class_parent_class)->add_property ((ValaSymbol*) G_TYPE_CHECK_INSTANCE_CAST (self, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol), prop);
	_tmp0_ = vala_property_get_binding (prop);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != VALA_MEMBER_BINDING_STATIC) {
		ValaDataType* _tmp2_;
		ValaDataType* _tmp3_;
		ValaParameter* _tmp4_;
		ValaParameter* _tmp5_;
		ValaScope* _tmp6_;
		ValaScope* _tmp7_;
		ValaParameter* _tmp8_;
		ValaParameter* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		ValaParameter* _tmp12_;
		ValaParameter* _tmp13_;
		_tmp2_ = vala_semantic_analyzer_get_this_type ((ValaSymbol*) prop, (ValaTypeSymbol*) self);
		_tmp3_ = _tmp2_;
		_tmp4_ = vala_parameter_new ("this", _tmp3_, NULL);
		_tmp5_ = _tmp4_;
		vala_property_set_this_parameter (prop, _tmp5_);
		_vala_code_node_unref0 (_tmp5_);
		_vala_code_node_unref0 (_tmp3_);
		_tmp6_ = vala_symbol_get_scope ((ValaSymbol*) prop);
		_tmp7_ = _tmp6_;
		_tmp8_ = vala_property_get_this_parameter (prop);
		_tmp9_ = _tmp8_;
		_tmp10_ = vala_symbol_get_name ((ValaSymbol*) _tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = vala_property_get_this_parameter (prop);
		_tmp13_ = _tmp12_;
		vala_scope_add (_tmp7_, _tmp11_, (ValaSymbol*) _tmp13_);
	}
	_tmp14_ = vala_property_get_field (prop);
	_tmp15_ = _tmp14_;
	if (_tmp15_ != NULL) {
		ValaField* _tmp16_;
		ValaField* _tmp17_;
		_tmp16_ = vala_property_get_field (prop);
		_tmp17_ = _tmp16_;
		vala_symbol_add_field ((ValaSymbol*) self, _tmp17_);
	}
}

static void
vala_class_real_add_constructor (ValaSymbol* base,
                                 ValaConstructor* c)
{
	ValaClass * self;
	ValaMemberBinding _tmp0_;
	ValaMemberBinding _tmp1_;
	ValaMemberBinding _tmp14_;
	ValaMemberBinding _tmp15_;
	self = (ValaClass*) base;
	g_return_if_fail (c != NULL);
	_tmp0_ = vala_constructor_get_binding (c);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case VALA_MEMBER_BINDING_INSTANCE:
		{
			ValaConstructor* _tmp2_;
			ValaConstructor* _tmp3_;
			_tmp2_ = vala_class_get_constructor (self);
			_tmp3_ = _tmp2_;
			if (_tmp3_ != NULL) {
				ValaSourceReference* _tmp4_;
				ValaSourceReference* _tmp5_;
				_tmp4_ = vala_code_node_get_source_reference ((ValaCodeNode*) c);
				_tmp5_ = _tmp4_;
				vala_report_error (_tmp5_, "class already contains a constructor");
			}
			vala_class_set_constructor (self, c);
			break;
		}
		case VALA_MEMBER_BINDING_CLASS:
		{
			ValaConstructor* _tmp6_;
			ValaConstructor* _tmp7_;
			_tmp6_ = vala_class_get_class_constructor (self);
			_tmp7_ = _tmp6_;
			if (_tmp7_ != NULL) {
				ValaSourceReference* _tmp8_;
				ValaSourceReference* _tmp9_;
				_tmp8_ = vala_code_node_get_source_reference ((ValaCodeNode*) c);
				_tmp9_ = _tmp8_;
				vala_report_error (_tmp9_, "class already contains a class constructor");
			}
			vala_class_set_class_constructor (self, c);
			break;
		}
		case VALA_MEMBER_BINDING_STATIC:
		{
			ValaConstructor* _tmp10_;
			ValaConstructor* _tmp11_;
			_tmp10_ = vala_class_get_static_constructor (self);
			_tmp11_ = _tmp10_;
			if (_tmp11_ != NULL) {
				ValaSourceReference* _tmp12_;
				ValaSourceReference* _tmp13_;
				_tmp12_ = vala_code_node_get_source_reference ((ValaCodeNode*) c);
				_tmp13_ = _tmp12_;
				vala_report_error (_tmp13_, "class already contains a static constructor");
			}
			vala_class_set_static_constructor (self, c);
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	_tmp14_ = vala_constructor_get_binding (c);
	_tmp15_ = _tmp14_;
	if (_tmp15_ != VALA_MEMBER_BINDING_STATIC) {
		ValaParameter* _tmp16_;
		ValaParameter* _tmp17_;
		ValaDataType* _tmp24_;
		ValaDataType* _tmp25_;
		ValaParameter* _tmp26_;
		ValaParameter* _tmp27_;
		ValaScope* _tmp28_;
		ValaScope* _tmp29_;
		ValaParameter* _tmp30_;
		ValaParameter* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		ValaParameter* _tmp34_;
		ValaParameter* _tmp35_;
		_tmp16_ = vala_constructor_get_this_parameter (c);
		_tmp17_ = _tmp16_;
		if (_tmp17_ != NULL) {
			ValaScope* _tmp18_;
			ValaScope* _tmp19_;
			ValaParameter* _tmp20_;
			ValaParameter* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp23_;
			_tmp18_ = vala_symbol_get_scope ((ValaSymbol*) c);
			_tmp19_ = _tmp18_;
			_tmp20_ = vala_constructor_get_this_parameter (c);
			_tmp21_ = _tmp20_;
			_tmp22_ = vala_symbol_get_name ((ValaSymbol*) _tmp21_);
			_tmp23_ = _tmp22_;
			vala_scope_remove (_tmp19_, _tmp23_);
		}
		_tmp24_ = vala_semantic_analyzer_get_this_type ((ValaSymbol*) c, (ValaTypeSymbol*) self);
		_tmp25_ = _tmp24_;
		_tmp26_ = vala_parameter_new ("this", _tmp25_, NULL);
		_tmp27_ = _tmp26_;
		vala_constructor_set_this_parameter (c, _tmp27_);
		_vala_code_node_unref0 (_tmp27_);
		_vala_code_node_unref0 (_tmp25_);
		_tmp28_ = vala_symbol_get_scope ((ValaSymbol*) c);
		_tmp29_ = _tmp28_;
		_tmp30_ = vala_constructor_get_this_parameter (c);
		_tmp31_ = _tmp30_;
		_tmp32_ = vala_symbol_get_name ((ValaSymbol*) _tmp31_);
		_tmp33_ = _tmp32_;
		_tmp34_ = vala_constructor_get_this_parameter (c);
		_tmp35_ = _tmp34_;
		vala_scope_add (_tmp29_, _tmp33_, (ValaSymbol*) _tmp35_);
	}
}

static void
vala_class_real_add_destructor (ValaSymbol* base,
                                ValaDestructor* d)
{
	ValaClass * self;
	ValaMemberBinding _tmp0_;
	ValaMemberBinding _tmp1_;
	ValaMemberBinding _tmp14_;
	ValaMemberBinding _tmp15_;
	self = (ValaClass*) base;
	g_return_if_fail (d != NULL);
	_tmp0_ = vala_destructor_get_binding (d);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case VALA_MEMBER_BINDING_INSTANCE:
		{
			ValaDestructor* _tmp2_;
			ValaDestructor* _tmp3_;
			_tmp2_ = vala_class_get_destructor (self);
			_tmp3_ = _tmp2_;
			if (_tmp3_ != NULL) {
				ValaSourceReference* _tmp4_;
				ValaSourceReference* _tmp5_;
				_tmp4_ = vala_code_node_get_source_reference ((ValaCodeNode*) d);
				_tmp5_ = _tmp4_;
				vala_report_error (_tmp5_, "class already contains a destructor");
			}
			vala_class_set_destructor (self, d);
			break;
		}
		case VALA_MEMBER_BINDING_CLASS:
		{
			ValaDestructor* _tmp6_;
			ValaDestructor* _tmp7_;
			_tmp6_ = vala_class_get_class_destructor (self);
			_tmp7_ = _tmp6_;
			if (_tmp7_ != NULL) {
				ValaSourceReference* _tmp8_;
				ValaSourceReference* _tmp9_;
				_tmp8_ = vala_code_node_get_source_reference ((ValaCodeNode*) d);
				_tmp9_ = _tmp8_;
				vala_report_error (_tmp9_, "class already contains a class destructor");
			}
			vala_class_set_class_destructor (self, d);
			break;
		}
		case VALA_MEMBER_BINDING_STATIC:
		{
			ValaDestructor* _tmp10_;
			ValaDestructor* _tmp11_;
			_tmp10_ = vala_class_get_static_destructor (self);
			_tmp11_ = _tmp10_;
			if (_tmp11_ != NULL) {
				ValaSourceReference* _tmp12_;
				ValaSourceReference* _tmp13_;
				_tmp12_ = vala_code_node_get_source_reference ((ValaCodeNode*) d);
				_tmp13_ = _tmp12_;
				vala_report_error (_tmp13_, "class already contains a static destructor");
			}
			vala_class_set_static_destructor (self, d);
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	_tmp14_ = vala_destructor_get_binding (d);
	_tmp15_ = _tmp14_;
	if (_tmp15_ != VALA_MEMBER_BINDING_STATIC) {
		ValaParameter* _tmp16_;
		ValaParameter* _tmp17_;
		ValaDataType* _tmp24_;
		ValaDataType* _tmp25_;
		ValaParameter* _tmp26_;
		ValaParameter* _tmp27_;
		ValaScope* _tmp28_;
		ValaScope* _tmp29_;
		ValaParameter* _tmp30_;
		ValaParameter* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		ValaParameter* _tmp34_;
		ValaParameter* _tmp35_;
		_tmp16_ = vala_destructor_get_this_parameter (d);
		_tmp17_ = _tmp16_;
		if (_tmp17_ != NULL) {
			ValaScope* _tmp18_;
			ValaScope* _tmp19_;
			ValaParameter* _tmp20_;
			ValaParameter* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp23_;
			_tmp18_ = vala_symbol_get_scope ((ValaSymbol*) d);
			_tmp19_ = _tmp18_;
			_tmp20_ = vala_destructor_get_this_parameter (d);
			_tmp21_ = _tmp20_;
			_tmp22_ = vala_symbol_get_name ((ValaSymbol*) _tmp21_);
			_tmp23_ = _tmp22_;
			vala_scope_remove (_tmp19_, _tmp23_);
		}
		_tmp24_ = vala_semantic_analyzer_get_this_type ((ValaSymbol*) d, (ValaTypeSymbol*) self);
		_tmp25_ = _tmp24_;
		_tmp26_ = vala_parameter_new ("this", _tmp25_, NULL);
		_tmp27_ = _tmp26_;
		vala_destructor_set_this_parameter (d, _tmp27_);
		_vala_code_node_unref0 (_tmp27_);
		_vala_code_node_unref0 (_tmp25_);
		_tmp28_ = vala_symbol_get_scope ((ValaSymbol*) d);
		_tmp29_ = _tmp28_;
		_tmp30_ = vala_destructor_get_this_parameter (d);
		_tmp31_ = _tmp30_;
		_tmp32_ = vala_symbol_get_name ((ValaSymbol*) _tmp31_);
		_tmp33_ = _tmp32_;
		_tmp34_ = vala_destructor_get_this_parameter (d);
		_tmp35_ = _tmp34_;
		vala_scope_add (_tmp29_, _tmp33_, (ValaSymbol*) _tmp35_);
	}
}

static void
vala_class_real_accept (ValaCodeNode* base,
                        ValaCodeVisitor* visitor)
{
	ValaClass * self;
	self = (ValaClass*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_class (visitor, self);
}

static void
vala_class_real_accept_children (ValaCodeNode* base,
                                 ValaCodeVisitor* visitor)
{
	ValaClass * self;
	ValaConstructor* _tmp9_;
	ValaConstructor* _tmp10_;
	ValaConstructor* _tmp13_;
	ValaConstructor* _tmp14_;
	ValaConstructor* _tmp17_;
	ValaConstructor* _tmp18_;
	ValaDestructor* _tmp21_;
	ValaDestructor* _tmp22_;
	ValaDestructor* _tmp25_;
	ValaDestructor* _tmp26_;
	ValaDestructor* _tmp29_;
	ValaDestructor* _tmp30_;
	self = (ValaClass*) base;
	g_return_if_fail (visitor != NULL);
	{
		ValaList* _type_list = NULL;
		ValaList* _tmp0_;
		gint _type_size = 0;
		ValaList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _type_index = 0;
		_tmp0_ = self->priv->base_types;
		_type_list = _tmp0_;
		_tmp1_ = _type_list;
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_type_size = _tmp3_;
		_type_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			ValaDataType* type = NULL;
			ValaList* _tmp6_;
			gpointer _tmp7_;
			ValaDataType* _tmp8_;
			_type_index = _type_index + 1;
			_tmp4_ = _type_index;
			_tmp5_ = _type_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _type_list;
			_tmp7_ = vala_list_get (_tmp6_, _type_index);
			type = (ValaDataType*) _tmp7_;
			_tmp8_ = type;
			vala_code_node_accept ((ValaCodeNode*) _tmp8_, visitor);
			_vala_code_node_unref0 (type);
		}
	}
	VALA_CODE_NODE_CLASS (vala_class_parent_class)->accept_children ((ValaCodeNode*) G_TYPE_CHECK_INSTANCE_CAST (self, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol), visitor);
	_tmp9_ = vala_class_get_constructor (self);
	_tmp10_ = _tmp9_;
	if (_tmp10_ != NULL) {
		ValaConstructor* _tmp11_;
		ValaConstructor* _tmp12_;
		_tmp11_ = vala_class_get_constructor (self);
		_tmp12_ = _tmp11_;
		vala_code_node_accept ((ValaCodeNode*) _tmp12_, visitor);
	}
	_tmp13_ = vala_class_get_class_constructor (self);
	_tmp14_ = _tmp13_;
	if (_tmp14_ != NULL) {
		ValaConstructor* _tmp15_;
		ValaConstructor* _tmp16_;
		_tmp15_ = vala_class_get_class_constructor (self);
		_tmp16_ = _tmp15_;
		vala_code_node_accept ((ValaCodeNode*) _tmp16_, visitor);
	}
	_tmp17_ = vala_class_get_static_constructor (self);
	_tmp18_ = _tmp17_;
	if (_tmp18_ != NULL) {
		ValaConstructor* _tmp19_;
		ValaConstructor* _tmp20_;
		_tmp19_ = vala_class_get_static_constructor (self);
		_tmp20_ = _tmp19_;
		vala_code_node_accept ((ValaCodeNode*) _tmp20_, visitor);
	}
	_tmp21_ = vala_class_get_destructor (self);
	_tmp22_ = _tmp21_;
	if (_tmp22_ != NULL) {
		ValaDestructor* _tmp23_;
		ValaDestructor* _tmp24_;
		_tmp23_ = vala_class_get_destructor (self);
		_tmp24_ = _tmp23_;
		vala_code_node_accept ((ValaCodeNode*) _tmp24_, visitor);
	}
	_tmp25_ = vala_class_get_static_destructor (self);
	_tmp26_ = _tmp25_;
	if (_tmp26_ != NULL) {
		ValaDestructor* _tmp27_;
		ValaDestructor* _tmp28_;
		_tmp27_ = vala_class_get_static_destructor (self);
		_tmp28_ = _tmp27_;
		vala_code_node_accept ((ValaCodeNode*) _tmp28_, visitor);
	}
	_tmp29_ = vala_class_get_class_destructor (self);
	_tmp30_ = _tmp29_;
	if (_tmp30_ != NULL) {
		ValaDestructor* _tmp31_;
		ValaDestructor* _tmp32_;
		_tmp31_ = vala_class_get_class_destructor (self);
		_tmp32_ = _tmp31_;
		vala_code_node_accept ((ValaCodeNode*) _tmp32_, visitor);
	}
}

static gboolean
vala_class_real_is_reference_type (ValaTypeSymbol* base)
{
	ValaClass * self;
	gboolean result = FALSE;
	self = (ValaClass*) base;
	result = TRUE;
	return result;
}

gboolean
vala_class_is_fundamental (ValaClass* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = vala_class_get_is_compact (self);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		ValaClass* _tmp3_;
		_tmp3_ = self->priv->_base_class;
		_tmp0_ = _tmp3_ == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static gboolean
vala_class_real_is_subtype_of (ValaTypeSymbol* base,
                               ValaTypeSymbol* t)
{
	ValaClass * self;
	gboolean result = FALSE;
	self = (ValaClass*) base;
	g_return_val_if_fail (t != NULL, FALSE);
	if (G_TYPE_CHECK_INSTANCE_CAST (self, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol) == t) {
		result = TRUE;
		return result;
	}
	{
		ValaList* _base_type_list = NULL;
		ValaList* _tmp0_;
		gint _base_type_size = 0;
		ValaList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _base_type_index = 0;
		_tmp0_ = self->priv->base_types;
		_base_type_list = _tmp0_;
		_tmp1_ = _base_type_list;
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_base_type_size = _tmp3_;
		_base_type_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			ValaDataType* base_type = NULL;
			ValaList* _tmp6_;
			gpointer _tmp7_;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
			ValaDataType* _tmp10_;
			ValaTypeSymbol* _tmp11_;
			ValaTypeSymbol* _tmp12_;
			_base_type_index = _base_type_index + 1;
			_tmp4_ = _base_type_index;
			_tmp5_ = _base_type_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _base_type_list;
			_tmp7_ = vala_list_get (_tmp6_, _base_type_index);
			base_type = (ValaDataType*) _tmp7_;
			_tmp10_ = base_type;
			_tmp11_ = vala_data_type_get_type_symbol (_tmp10_);
			_tmp12_ = _tmp11_;
			if (_tmp12_ != NULL) {
				ValaDataType* _tmp13_;
				ValaTypeSymbol* _tmp14_;
				ValaTypeSymbol* _tmp15_;
				_tmp13_ = base_type;
				_tmp14_ = vala_data_type_get_type_symbol (_tmp13_);
				_tmp15_ = _tmp14_;
				_tmp9_ = _tmp15_ != G_TYPE_CHECK_INSTANCE_CAST (self, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol);
			} else {
				_tmp9_ = FALSE;
			}
			if (_tmp9_) {
				ValaDataType* _tmp16_;
				ValaTypeSymbol* _tmp17_;
				ValaTypeSymbol* _tmp18_;
				_tmp16_ = base_type;
				_tmp17_ = vala_data_type_get_type_symbol (_tmp16_);
				_tmp18_ = _tmp17_;
				_tmp8_ = vala_typesymbol_is_subtype_of (_tmp18_, t);
			} else {
				_tmp8_ = FALSE;
			}
			if (_tmp8_) {
				result = TRUE;
				_vala_code_node_unref0 (base_type);
				return result;
			}
			_vala_code_node_unref0 (base_type);
		}
	}
	result = FALSE;
	return result;
}

static void
vala_class_real_replace_type (ValaCodeNode* base,
                              ValaDataType* old_type,
                              ValaDataType* new_type)
{
	ValaClass * self;
	self = (ValaClass*) base;
	g_return_if_fail (old_type != NULL);
	g_return_if_fail (new_type != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				ValaList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				ValaList* _tmp5_;
				gpointer _tmp6_;
				ValaDataType* _tmp7_;
				gboolean _tmp8_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->base_types;
				_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
				_tmp4_ = _tmp3_;
				if (!(i < _tmp4_)) {
					break;
				}
				_tmp5_ = self->priv->base_types;
				_tmp6_ = vala_list_get (_tmp5_, i);
				_tmp7_ = (ValaDataType*) _tmp6_;
				_tmp8_ = _tmp7_ == old_type;
				_vala_code_node_unref0 (_tmp7_);
				if (_tmp8_) {
					ValaList* _tmp9_;
					_tmp9_ = self->priv->base_types;
					vala_list_set (_tmp9_, i, new_type);
					vala_code_node_set_parent_node ((ValaCodeNode*) new_type, (ValaCodeNode*) self);
					return;
				}
			}
		}
	}
}

static void
vala_class_get_all_prerequisites (ValaClass* self,
                                  ValaInterface* iface,
                                  ValaList* list)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (iface != NULL);
	g_return_if_fail (list != NULL);
	{
		ValaList* _prereq_list = NULL;
		ValaList* _tmp0_;
		gint _prereq_size = 0;
		ValaList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _prereq_index = 0;
		_tmp0_ = vala_interface_get_prerequisites (iface);
		_prereq_list = _tmp0_;
		_tmp1_ = _prereq_list;
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_prereq_size = _tmp3_;
		_prereq_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			ValaDataType* prereq = NULL;
			ValaList* _tmp6_;
			gpointer _tmp7_;
			ValaTypeSymbol* type = NULL;
			ValaDataType* _tmp8_;
			ValaTypeSymbol* _tmp9_;
			ValaTypeSymbol* _tmp10_;
			ValaTypeSymbol* _tmp11_;
			ValaTypeSymbol* _tmp12_;
			ValaTypeSymbol* _tmp13_;
			ValaTypeSymbol* _tmp14_;
			_prereq_index = _prereq_index + 1;
			_tmp4_ = _prereq_index;
			_tmp5_ = _prereq_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _prereq_list;
			_tmp7_ = vala_list_get (_tmp6_, _prereq_index);
			prereq = (ValaDataType*) _tmp7_;
			_tmp8_ = prereq;
			_tmp9_ = vala_data_type_get_type_symbol (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = _vala_code_node_ref0 (_tmp10_);
			type = _tmp11_;
			_tmp12_ = type;
			if (_tmp12_ == NULL) {
				_vala_code_node_unref0 (type);
				_vala_code_node_unref0 (prereq);
				continue;
			}
			_tmp13_ = type;
			vala_collection_add ((ValaCollection*) list, _tmp13_);
			_tmp14_ = type;
			if (VALA_IS_INTERFACE (_tmp14_)) {
				ValaTypeSymbol* _tmp15_;
				_tmp15_ = type;
				vala_class_get_all_prerequisites (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, VALA_TYPE_INTERFACE, ValaInterface), list);
			}
			_vala_code_node_unref0 (type);
			_vala_code_node_unref0 (prereq);
		}
	}
}

gboolean
vala_class_is_a (ValaClass* self,
                 ValaObjectTypeSymbol* t)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (t != NULL, FALSE);
	if (G_TYPE_CHECK_INSTANCE_CAST (self, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol) == t) {
		result = TRUE;
		return result;
	}
	{
		ValaList* _base_type_list = NULL;
		ValaList* _tmp0_;
		gint _base_type_size = 0;
		ValaList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _base_type_index = 0;
		_tmp0_ = vala_class_get_base_types (self);
		_base_type_list = _tmp0_;
		_tmp1_ = _base_type_list;
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_base_type_size = _tmp3_;
		_base_type_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			ValaDataType* base_type = NULL;
			ValaList* _tmp6_;
			gpointer _tmp7_;
			ValaDataType* _tmp8_;
			ValaTypeSymbol* _tmp9_;
			ValaTypeSymbol* _tmp10_;
			_base_type_index = _base_type_index + 1;
			_tmp4_ = _base_type_index;
			_tmp5_ = _base_type_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _base_type_list;
			_tmp7_ = vala_list_get (_tmp6_, _base_type_index);
			base_type = (ValaDataType*) _tmp7_;
			_tmp8_ = base_type;
			_tmp9_ = vala_data_type_get_type_symbol (_tmp8_);
			_tmp10_ = _tmp9_;
			if (VALA_IS_CLASS (_tmp10_)) {
				ValaDataType* _tmp11_;
				ValaTypeSymbol* _tmp12_;
				ValaTypeSymbol* _tmp13_;
				_tmp11_ = base_type;
				_tmp12_ = vala_data_type_get_type_symbol (_tmp11_);
				_tmp13_ = _tmp12_;
				if (vala_class_is_a (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, VALA_TYPE_CLASS, ValaClass), t)) {
					result = TRUE;
					_vala_code_node_unref0 (base_type);
					return result;
				}
			} else {
				ValaDataType* _tmp14_;
				ValaTypeSymbol* _tmp15_;
				ValaTypeSymbol* _tmp16_;
				_tmp14_ = base_type;
				_tmp15_ = vala_data_type_get_type_symbol (_tmp14_);
				_tmp16_ = _tmp15_;
				if (_tmp16_ == G_TYPE_CHECK_INSTANCE_CAST (t, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol)) {
					result = TRUE;
					_vala_code_node_unref0 (base_type);
					return result;
				}
			}
			_vala_code_node_unref0 (base_type);
		}
	}
	result = FALSE;
	return result;
}

gboolean
vala_class_implements (ValaClass* self,
                       ValaInterface* i)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (i != NULL, FALSE);
	{
		ValaList* _base_type_list = NULL;
		ValaList* _tmp0_;
		gint _base_type_size = 0;
		ValaList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _base_type_index = 0;
		_tmp0_ = vala_class_get_base_types (self);
		_base_type_list = _tmp0_;
		_tmp1_ = _base_type_list;
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_base_type_size = _tmp3_;
		_base_type_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			ValaDataType* base_type = NULL;
			ValaList* _tmp6_;
			gpointer _tmp7_;
			ValaDataType* _tmp8_;
			ValaTypeSymbol* _tmp9_;
			ValaTypeSymbol* _tmp10_;
			_base_type_index = _base_type_index + 1;
			_tmp4_ = _base_type_index;
			_tmp5_ = _base_type_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _base_type_list;
			_tmp7_ = vala_list_get (_tmp6_, _base_type_index);
			base_type = (ValaDataType*) _tmp7_;
			_tmp8_ = base_type;
			_tmp9_ = vala_data_type_get_type_symbol (_tmp8_);
			_tmp10_ = _tmp9_;
			if (_tmp10_ == G_TYPE_CHECK_INSTANCE_CAST (i, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol)) {
				result = TRUE;
				_vala_code_node_unref0 (base_type);
				return result;
			}
			_vala_code_node_unref0 (base_type);
		}
	}
	result = FALSE;
	return result;
}

static gpointer
_vala_source_file_ref0 (gpointer self)
{
	return self ? vala_source_file_ref (self) : NULL;
}

static gboolean
vala_class_real_check (ValaCodeNode* base,
                       ValaCodeContext* context)
{
	ValaClass * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaSourceFile* old_source_file = NULL;
	ValaSemanticAnalyzer* _tmp4_;
	ValaSemanticAnalyzer* _tmp5_;
	ValaSourceFile* _tmp6_;
	ValaSourceFile* _tmp7_;
	ValaSourceFile* _tmp8_;
	ValaSymbol* old_symbol = NULL;
	ValaSemanticAnalyzer* _tmp9_;
	ValaSemanticAnalyzer* _tmp10_;
	ValaSymbol* _tmp11_;
	ValaSymbol* _tmp12_;
	ValaSymbol* _tmp13_;
	ValaSourceReference* _tmp14_;
	ValaSourceReference* _tmp15_;
	ValaSemanticAnalyzer* _tmp22_;
	ValaSemanticAnalyzer* _tmp23_;
	gboolean _tmp85_ = FALSE;
	ValaClass* _tmp86_;
	gboolean _tmp97_ = FALSE;
	gboolean _tmp98_;
	gboolean _tmp99_;
	gboolean _tmp107_ = FALSE;
	gboolean _tmp108_;
	gboolean _tmp109_;
	gboolean _tmp121_ = FALSE;
	ValaClass* _tmp122_;
	gboolean _tmp132_;
	ValaConstructor* _tmp251_;
	ValaConstructor* _tmp252_;
	ValaConstructor* _tmp255_;
	ValaConstructor* _tmp256_;
	ValaConstructor* _tmp259_;
	ValaConstructor* _tmp260_;
	ValaDestructor* _tmp263_;
	ValaDestructor* _tmp264_;
	ValaDestructor* _tmp267_;
	ValaDestructor* _tmp268_;
	ValaDestructor* _tmp271_;
	ValaDestructor* _tmp272_;
	gboolean _tmp311_;
	gboolean _tmp312_;
	ValaList* prerequisites = NULL;
	GEqualFunc _tmp353_;
	ValaArrayList* _tmp354_;
	ValaList* missing_prereqs = NULL;
	GEqualFunc _tmp370_;
	ValaArrayList* _tmp371_;
	ValaList* _tmp385_;
	gint _tmp386_;
	gint _tmp387_;
	ValaSourceFileType _tmp411_;
	ValaSourceFileType _tmp412_;
	ValaSemanticAnalyzer* _tmp629_;
	ValaSemanticAnalyzer* _tmp630_;
	ValaSourceFile* _tmp631_;
	ValaSemanticAnalyzer* _tmp632_;
	ValaSemanticAnalyzer* _tmp633_;
	ValaSymbol* _tmp634_;
	gboolean _tmp635_;
	gboolean _tmp636_;
	gboolean result = FALSE;
	self = (ValaClass*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	if (!VALA_CODE_NODE_CLASS (vala_class_parent_class)->check ((ValaCodeNode*) G_TYPE_CHECK_INSTANCE_CAST (self, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol), context)) {
		result = FALSE;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_code_context_get_analyzer (context);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_semantic_analyzer_get_current_source_file (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _vala_source_file_ref0 (_tmp7_);
	old_source_file = _tmp8_;
	_tmp9_ = vala_code_context_get_analyzer (context);
	_tmp10_ = _tmp9_;
	_tmp11_ = vala_semantic_analyzer_get_current_symbol (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = _vala_code_node_ref0 (_tmp12_);
	old_symbol = _tmp13_;
	_tmp14_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
	_tmp15_ = _tmp14_;
	if (_tmp15_ != NULL) {
		ValaSemanticAnalyzer* _tmp16_;
		ValaSemanticAnalyzer* _tmp17_;
		ValaSourceReference* _tmp18_;
		ValaSourceReference* _tmp19_;
		ValaSourceFile* _tmp20_;
		ValaSourceFile* _tmp21_;
		_tmp16_ = vala_code_context_get_analyzer (context);
		_tmp17_ = _tmp16_;
		_tmp18_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp19_ = _tmp18_;
		_tmp20_ = vala_source_reference_get_file (_tmp19_);
		_tmp21_ = _tmp20_;
		vala_semantic_analyzer_set_current_source_file (_tmp17_, _tmp21_);
	}
	_tmp22_ = vala_code_context_get_analyzer (context);
	_tmp23_ = _tmp22_;
	vala_semantic_analyzer_set_current_symbol (_tmp23_, (ValaSymbol*) self);
	{
		ValaList* _base_type_reference_list = NULL;
		ValaList* _tmp24_;
		gint _base_type_reference_size = 0;
		ValaList* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gint _base_type_reference_index = 0;
		_tmp24_ = vala_class_get_base_types (self);
		_base_type_reference_list = _tmp24_;
		_tmp25_ = _base_type_reference_list;
		_tmp26_ = vala_collection_get_size ((ValaCollection*) _tmp25_);
		_tmp27_ = _tmp26_;
		_base_type_reference_size = _tmp27_;
		_base_type_reference_index = -1;
		while (TRUE) {
			gint _tmp28_;
			gint _tmp29_;
			ValaDataType* base_type_reference = NULL;
			ValaList* _tmp30_;
			gpointer _tmp31_;
			ValaDataType* _tmp32_;
			ValaDataType* _tmp33_;
			ValaSemanticAnalyzer* _tmp41_;
			ValaSemanticAnalyzer* _tmp42_;
			ValaDataType* _tmp43_;
			gint n_type_args = 0;
			ValaDataType* _tmp51_;
			ValaList* _tmp52_;
			gint _tmp53_;
			gint _tmp54_;
			gint n_type_params = 0;
			ValaDataType* _tmp55_;
			ValaTypeSymbol* _tmp56_;
			ValaTypeSymbol* _tmp57_;
			ValaList* _tmp58_;
			gint _tmp59_;
			gint _tmp60_;
			_base_type_reference_index = _base_type_reference_index + 1;
			_tmp28_ = _base_type_reference_index;
			_tmp29_ = _base_type_reference_size;
			if (!(_tmp28_ < _tmp29_)) {
				break;
			}
			_tmp30_ = _base_type_reference_list;
			_tmp31_ = vala_list_get (_tmp30_, _base_type_reference_index);
			base_type_reference = (ValaDataType*) _tmp31_;
			_tmp32_ = base_type_reference;
			if (!vala_code_node_check ((ValaCodeNode*) _tmp32_, context)) {
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				result = FALSE;
				_vala_code_node_unref0 (base_type_reference);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
			_tmp33_ = base_type_reference;
			if (!VALA_IS_OBJECT_TYPE (_tmp33_)) {
				ValaSourceReference* _tmp34_;
				ValaSourceReference* _tmp35_;
				ValaDataType* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp34_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp35_ = _tmp34_;
				_tmp36_ = base_type_reference;
				_tmp37_ = vala_code_node_to_string ((ValaCodeNode*) _tmp36_);
				_tmp38_ = _tmp37_;
				_tmp39_ = vala_symbol_get_full_name ((ValaSymbol*) self);
				_tmp40_ = _tmp39_;
				vala_report_error (_tmp35_, "base type `%s' of class `%s' is not an object type", _tmp38_, _tmp40_);
				_g_free0 (_tmp40_);
				_g_free0 (_tmp38_);
				result = FALSE;
				_vala_code_node_unref0 (base_type_reference);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
			_tmp41_ = vala_code_context_get_analyzer (context);
			_tmp42_ = _tmp41_;
			_tmp43_ = base_type_reference;
			if (!vala_semantic_analyzer_is_type_accessible (_tmp42_, (ValaSymbol*) self, _tmp43_)) {
				ValaSourceReference* _tmp44_;
				ValaSourceReference* _tmp45_;
				ValaDataType* _tmp46_;
				gchar* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp44_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp45_ = _tmp44_;
				_tmp46_ = base_type_reference;
				_tmp47_ = vala_code_node_to_string ((ValaCodeNode*) _tmp46_);
				_tmp48_ = _tmp47_;
				_tmp49_ = vala_symbol_get_full_name ((ValaSymbol*) self);
				_tmp50_ = _tmp49_;
				vala_report_error (_tmp45_, "base type `%s' is less accessible than class `%s'", _tmp48_, _tmp50_);
				_g_free0 (_tmp50_);
				_g_free0 (_tmp48_);
				result = FALSE;
				_vala_code_node_unref0 (base_type_reference);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
			_tmp51_ = base_type_reference;
			_tmp52_ = vala_data_type_get_type_arguments (_tmp51_);
			_tmp53_ = vala_collection_get_size ((ValaCollection*) _tmp52_);
			_tmp54_ = _tmp53_;
			n_type_args = _tmp54_;
			_tmp55_ = base_type_reference;
			_tmp56_ = vala_data_type_get_type_symbol (_tmp55_);
			_tmp57_ = _tmp56_;
			_tmp58_ = vala_object_type_symbol_get_type_parameters (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol));
			_tmp59_ = vala_collection_get_size ((ValaCollection*) _tmp58_);
			_tmp60_ = _tmp59_;
			n_type_params = _tmp60_;
			if (n_type_args < n_type_params) {
				ValaDataType* _tmp61_;
				ValaSourceReference* _tmp62_;
				ValaSourceReference* _tmp63_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp61_ = base_type_reference;
				_tmp62_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp61_);
				_tmp63_ = _tmp62_;
				vala_report_error (_tmp63_, "too few type arguments");
				result = FALSE;
				_vala_code_node_unref0 (base_type_reference);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			} else {
				if (n_type_args > n_type_params) {
					ValaDataType* _tmp64_;
					ValaSourceReference* _tmp65_;
					ValaSourceReference* _tmp66_;
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					_tmp64_ = base_type_reference;
					_tmp65_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp64_);
					_tmp66_ = _tmp65_;
					vala_report_error (_tmp66_, "too many type arguments");
					result = FALSE;
					_vala_code_node_unref0 (base_type_reference);
					_vala_code_node_unref0 (old_symbol);
					_vala_source_file_unref0 (old_source_file);
					return result;
				}
			}
			_vala_code_node_unref0 (base_type_reference);
		}
	}
	{
		ValaList* _type_list = NULL;
		ValaList* _tmp67_;
		gint _type_size = 0;
		ValaList* _tmp68_;
		gint _tmp69_;
		gint _tmp70_;
		gint _type_index = 0;
		_tmp67_ = self->priv->base_types;
		_type_list = _tmp67_;
		_tmp68_ = _type_list;
		_tmp69_ = vala_collection_get_size ((ValaCollection*) _tmp68_);
		_tmp70_ = _tmp69_;
		_type_size = _tmp70_;
		_type_index = -1;
		while (TRUE) {
			gint _tmp71_;
			gint _tmp72_;
			ValaDataType* type = NULL;
			ValaList* _tmp73_;
			gpointer _tmp74_;
			ValaDataType* _tmp75_;
			_type_index = _type_index + 1;
			_tmp71_ = _type_index;
			_tmp72_ = _type_size;
			if (!(_tmp71_ < _tmp72_)) {
				break;
			}
			_tmp73_ = _type_list;
			_tmp74_ = vala_list_get (_tmp73_, _type_index);
			type = (ValaDataType*) _tmp74_;
			_tmp75_ = type;
			vala_code_node_check ((ValaCodeNode*) _tmp75_, context);
			_vala_code_node_unref0 (type);
		}
	}
	{
		ValaList* _p_list = NULL;
		ValaList* _tmp76_;
		gint _p_size = 0;
		ValaList* _tmp77_;
		gint _tmp78_;
		gint _tmp79_;
		gint _p_index = 0;
		_tmp76_ = vala_object_type_symbol_get_type_parameters ((ValaObjectTypeSymbol*) self);
		_p_list = _tmp76_;
		_tmp77_ = _p_list;
		_tmp78_ = vala_collection_get_size ((ValaCollection*) _tmp77_);
		_tmp79_ = _tmp78_;
		_p_size = _tmp79_;
		_p_index = -1;
		while (TRUE) {
			gint _tmp80_;
			gint _tmp81_;
			ValaTypeParameter* p = NULL;
			ValaList* _tmp82_;
			gpointer _tmp83_;
			ValaTypeParameter* _tmp84_;
			_p_index = _p_index + 1;
			_tmp80_ = _p_index;
			_tmp81_ = _p_size;
			if (!(_tmp80_ < _tmp81_)) {
				break;
			}
			_tmp82_ = _p_list;
			_tmp83_ = vala_list_get (_tmp82_, _p_index);
			p = (ValaTypeParameter*) _tmp83_;
			_tmp84_ = p;
			vala_code_node_check ((ValaCodeNode*) _tmp84_, context);
			_vala_code_node_unref0 (p);
		}
	}
	_tmp86_ = self->priv->_base_class;
	if (_tmp86_ != NULL) {
		ValaClass* _tmp87_;
		gboolean _tmp88_;
		gboolean _tmp89_;
		_tmp87_ = self->priv->_base_class;
		_tmp88_ = vala_class_get_is_singleton (_tmp87_);
		_tmp89_ = _tmp88_;
		_tmp85_ = _tmp89_;
	} else {
		_tmp85_ = FALSE;
	}
	if (_tmp85_) {
		ValaSourceReference* _tmp90_;
		ValaSourceReference* _tmp91_;
		gchar* _tmp92_;
		gchar* _tmp93_;
		ValaClass* _tmp94_;
		gchar* _tmp95_;
		gchar* _tmp96_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp90_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp91_ = _tmp90_;
		_tmp92_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp93_ = _tmp92_;
		_tmp94_ = self->priv->_base_class;
		_tmp95_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp94_);
		_tmp96_ = _tmp95_;
		vala_report_error (_tmp91_, "`%s' cannot inherit from SingleInstance class `%s'", _tmp93_, _tmp96_);
		_g_free0 (_tmp96_);
		_g_free0 (_tmp93_);
	}
	_tmp98_ = vala_class_get_is_singleton (self);
	_tmp99_ = _tmp98_;
	if (_tmp99_) {
		ValaSemanticAnalyzer* _tmp100_;
		ValaSemanticAnalyzer* _tmp101_;
		ValaClass* _tmp102_;
		_tmp100_ = vala_code_context_get_analyzer (context);
		_tmp101_ = _tmp100_;
		_tmp102_ = _tmp101_->object_type;
		_tmp97_ = !vala_typesymbol_is_subtype_of ((ValaTypeSymbol*) self, (ValaTypeSymbol*) _tmp102_);
	} else {
		_tmp97_ = FALSE;
	}
	if (_tmp97_) {
		ValaSourceReference* _tmp103_;
		ValaSourceReference* _tmp104_;
		gchar* _tmp105_;
		gchar* _tmp106_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp103_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp104_ = _tmp103_;
		_tmp105_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp106_ = _tmp105_;
		vala_report_error (_tmp104_, "SingleInstance class `%s' requires inheritance from `GLib.Object'", _tmp106_);
		_g_free0 (_tmp106_);
	}
	_tmp108_ = vala_class_get_is_singleton (self);
	_tmp109_ = _tmp108_;
	if (_tmp109_) {
		ValaConstructor* _tmp110_;
		ValaConstructor* _tmp111_;
		_tmp110_ = vala_class_get_constructor (self);
		_tmp111_ = _tmp110_;
		_tmp107_ = _tmp111_ == NULL;
	} else {
		_tmp107_ = FALSE;
	}
	if (_tmp107_) {
		ValaConstructor* c = NULL;
		ValaSourceReference* _tmp112_;
		ValaSourceReference* _tmp113_;
		ValaConstructor* _tmp114_;
		ValaConstructor* _tmp115_;
		ValaSourceReference* _tmp116_;
		ValaSourceReference* _tmp117_;
		ValaBlock* _tmp118_;
		ValaBlock* _tmp119_;
		ValaConstructor* _tmp120_;
		_tmp112_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp113_ = _tmp112_;
		_tmp114_ = vala_constructor_new (_tmp113_);
		c = _tmp114_;
		_tmp115_ = c;
		_tmp116_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp117_ = _tmp116_;
		_tmp118_ = vala_block_new (_tmp117_);
		_tmp119_ = _tmp118_;
		vala_subroutine_set_body ((ValaSubroutine*) _tmp115_, _tmp119_);
		_vala_code_node_unref0 (_tmp119_);
		_tmp120_ = c;
		vala_symbol_add_constructor ((ValaSymbol*) self, _tmp120_);
		_vala_code_node_unref0 (c);
	}
	_tmp122_ = self->priv->_base_class;
	if (_tmp122_ != NULL) {
		ValaClass* _tmp123_;
		gboolean _tmp124_;
		_tmp123_ = self->priv->_base_class;
		_tmp124_ = _tmp123_->priv->_is_sealed;
		_tmp121_ = _tmp124_;
	} else {
		_tmp121_ = FALSE;
	}
	if (_tmp121_) {
		ValaSourceReference* _tmp125_;
		ValaSourceReference* _tmp126_;
		gchar* _tmp127_;
		gchar* _tmp128_;
		ValaClass* _tmp129_;
		gchar* _tmp130_;
		gchar* _tmp131_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp125_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp126_ = _tmp125_;
		_tmp127_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp128_ = _tmp127_;
		_tmp129_ = self->priv->_base_class;
		_tmp130_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp129_);
		_tmp131_ = _tmp130_;
		vala_report_error (_tmp126_, "`%s' cannot inherit from sealed class `%s'", _tmp128_, _tmp131_);
		_g_free0 (_tmp131_);
		_g_free0 (_tmp128_);
	}
	_tmp132_ = self->priv->_is_sealed;
	if (_tmp132_) {
		gboolean _tmp133_;
		gboolean _tmp134_;
		gboolean _tmp139_;
		gboolean _tmp144_;
		gboolean _tmp145_;
		_tmp133_ = vala_class_get_is_compact (self);
		_tmp134_ = _tmp133_;
		if (_tmp134_) {
			ValaSourceReference* _tmp135_;
			ValaSourceReference* _tmp136_;
			gchar* _tmp137_;
			gchar* _tmp138_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp135_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp136_ = _tmp135_;
			_tmp137_ = vala_symbol_get_full_name ((ValaSymbol*) self);
			_tmp138_ = _tmp137_;
			vala_report_error (_tmp136_, "Sealed class `%s' cannot be compact", _tmp138_);
			_g_free0 (_tmp138_);
			result = FALSE;
			_vala_code_node_unref0 (old_symbol);
			_vala_source_file_unref0 (old_source_file);
			return result;
		}
		_tmp139_ = self->priv->_is_abstract;
		if (_tmp139_) {
			ValaSourceReference* _tmp140_;
			ValaSourceReference* _tmp141_;
			gchar* _tmp142_;
			gchar* _tmp143_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp140_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp141_ = _tmp140_;
			_tmp142_ = vala_symbol_get_full_name ((ValaSymbol*) self);
			_tmp143_ = _tmp142_;
			vala_report_error (_tmp141_, "Sealed class `%s' cannot be abstract", _tmp143_);
			_g_free0 (_tmp143_);
			result = FALSE;
			_vala_code_node_unref0 (old_symbol);
			_vala_source_file_unref0 (old_source_file);
			return result;
		}
		_tmp144_ = vala_symbol_get_external_package ((ValaSymbol*) self);
		_tmp145_ = _tmp144_;
		if (!_tmp145_) {
			ValaSourceReference* _tmp146_;
			ValaSourceReference* _tmp147_;
			vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			_tmp146_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
			_tmp147_ = _tmp146_;
			vala_report_error (_tmp147_, "Sealed classes are not fully supported yet");
			result = FALSE;
			_vala_code_node_unref0 (old_symbol);
			_vala_source_file_unref0 (old_source_file);
			return result;
		}
	}
	{
		ValaList* _en_list = NULL;
		ValaList* _tmp148_;
		gint _en_size = 0;
		ValaList* _tmp149_;
		gint _tmp150_;
		gint _tmp151_;
		gint _en_index = 0;
		_tmp148_ = vala_object_type_symbol_get_enums ((ValaObjectTypeSymbol*) self);
		_en_list = _tmp148_;
		_tmp149_ = _en_list;
		_tmp150_ = vala_collection_get_size ((ValaCollection*) _tmp149_);
		_tmp151_ = _tmp150_;
		_en_size = _tmp151_;
		_en_index = -1;
		while (TRUE) {
			gint _tmp152_;
			gint _tmp153_;
			ValaEnum* en = NULL;
			ValaList* _tmp154_;
			gpointer _tmp155_;
			ValaEnum* _tmp156_;
			_en_index = _en_index + 1;
			_tmp152_ = _en_index;
			_tmp153_ = _en_size;
			if (!(_tmp152_ < _tmp153_)) {
				break;
			}
			_tmp154_ = _en_list;
			_tmp155_ = vala_list_get (_tmp154_, _en_index);
			en = (ValaEnum*) _tmp155_;
			_tmp156_ = en;
			vala_code_node_check ((ValaCodeNode*) _tmp156_, context);
			_vala_code_node_unref0 (en);
		}
	}
	{
		ValaList* _f_list = NULL;
		ValaList* _tmp157_;
		gint _f_size = 0;
		ValaList* _tmp158_;
		gint _tmp159_;
		gint _tmp160_;
		gint _f_index = 0;
		_tmp157_ = vala_object_type_symbol_get_fields ((ValaObjectTypeSymbol*) self);
		_f_list = _tmp157_;
		_tmp158_ = _f_list;
		_tmp159_ = vala_collection_get_size ((ValaCollection*) _tmp158_);
		_tmp160_ = _tmp159_;
		_f_size = _tmp160_;
		_f_index = -1;
		while (TRUE) {
			gint _tmp161_;
			gint _tmp162_;
			ValaField* f = NULL;
			ValaList* _tmp163_;
			gpointer _tmp164_;
			gboolean _tmp165_ = FALSE;
			gboolean _tmp166_;
			gboolean _tmp167_;
			ValaField* _tmp205_;
			_f_index = _f_index + 1;
			_tmp161_ = _f_index;
			_tmp162_ = _f_size;
			if (!(_tmp161_ < _tmp162_)) {
				break;
			}
			_tmp163_ = _f_list;
			_tmp164_ = vala_list_get (_tmp163_, _f_index);
			f = (ValaField*) _tmp164_;
			_tmp166_ = vala_class_get_is_compact (self);
			_tmp167_ = _tmp166_;
			if (_tmp167_) {
				ValaField* _tmp168_;
				ValaMemberBinding _tmp169_;
				ValaMemberBinding _tmp170_;
				_tmp168_ = f;
				_tmp169_ = vala_field_get_binding (_tmp168_);
				_tmp170_ = _tmp169_;
				_tmp165_ = _tmp170_ != VALA_MEMBER_BINDING_STATIC;
			} else {
				_tmp165_ = FALSE;
			}
			if (_tmp165_) {
				gboolean _tmp171_ = FALSE;
				gboolean _tmp172_ = FALSE;
				gboolean _tmp173_;
				gboolean _tmp174_;
				gboolean _tmp183_ = FALSE;
				gboolean _tmp184_ = FALSE;
				gboolean _tmp185_;
				gboolean _tmp186_;
				ValaField* _tmp199_;
				ValaMemberBinding _tmp200_;
				ValaMemberBinding _tmp201_;
				_tmp173_ = vala_symbol_get_external_package ((ValaSymbol*) self);
				_tmp174_ = _tmp173_;
				if (!_tmp174_) {
					gboolean _tmp175_;
					gboolean _tmp176_;
					_tmp175_ = vala_class_get_is_opaque (self);
					_tmp176_ = _tmp175_;
					_tmp172_ = !_tmp176_;
				} else {
					_tmp172_ = FALSE;
				}
				if (_tmp172_) {
					ValaField* _tmp177_;
					ValaSymbolAccessibility _tmp178_;
					ValaSymbolAccessibility _tmp179_;
					_tmp177_ = f;
					_tmp178_ = vala_symbol_get_access ((ValaSymbol*) _tmp177_);
					_tmp179_ = _tmp178_;
					_tmp171_ = _tmp179_ == VALA_SYMBOL_ACCESSIBILITY_PRIVATE;
				} else {
					_tmp171_ = FALSE;
				}
				if (_tmp171_) {
					ValaField* _tmp180_;
					ValaSourceReference* _tmp181_;
					ValaSourceReference* _tmp182_;
					_tmp180_ = f;
					_tmp181_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp180_);
					_tmp182_ = _tmp181_;
					vala_report_error (_tmp182_, "private fields are only supported in opaque compact classes, use [Comp" \
"act (opaque = true)]");
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				}
				_tmp185_ = vala_symbol_get_external_package ((ValaSymbol*) self);
				_tmp186_ = _tmp185_;
				if (!_tmp186_) {
					gboolean _tmp187_;
					gboolean _tmp188_;
					_tmp187_ = vala_class_get_is_opaque (self);
					_tmp188_ = _tmp187_;
					_tmp184_ = _tmp188_;
				} else {
					_tmp184_ = FALSE;
				}
				if (_tmp184_) {
					gboolean _tmp189_ = FALSE;
					ValaField* _tmp190_;
					ValaSymbolAccessibility _tmp191_;
					ValaSymbolAccessibility _tmp192_;
					_tmp190_ = f;
					_tmp191_ = vala_symbol_get_access ((ValaSymbol*) _tmp190_);
					_tmp192_ = _tmp191_;
					if (_tmp192_ == VALA_SYMBOL_ACCESSIBILITY_PUBLIC) {
						_tmp189_ = TRUE;
					} else {
						ValaField* _tmp193_;
						ValaSymbolAccessibility _tmp194_;
						ValaSymbolAccessibility _tmp195_;
						_tmp193_ = f;
						_tmp194_ = vala_symbol_get_access ((ValaSymbol*) _tmp193_);
						_tmp195_ = _tmp194_;
						_tmp189_ = _tmp195_ == VALA_SYMBOL_ACCESSIBILITY_PROTECTED;
					}
					_tmp183_ = _tmp189_;
				} else {
					_tmp183_ = FALSE;
				}
				if (_tmp183_) {
					ValaField* _tmp196_;
					ValaSourceReference* _tmp197_;
					ValaSourceReference* _tmp198_;
					_tmp196_ = f;
					_tmp197_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp196_);
					_tmp198_ = _tmp197_;
					vala_report_error (_tmp198_, "fields in opaque compact classes must be private or internal");
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				}
				_tmp199_ = f;
				_tmp200_ = vala_field_get_binding (_tmp199_);
				_tmp201_ = _tmp200_;
				if (_tmp201_ == VALA_MEMBER_BINDING_CLASS) {
					ValaField* _tmp202_;
					ValaSourceReference* _tmp203_;
					ValaSourceReference* _tmp204_;
					_tmp202_ = f;
					_tmp203_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp202_);
					_tmp204_ = _tmp203_;
					vala_report_error (_tmp204_, "class fields are not supported in compact classes");
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				}
			}
			_tmp205_ = f;
			vala_code_node_check ((ValaCodeNode*) _tmp205_, context);
			_vala_code_node_unref0 (f);
		}
	}
	{
		ValaList* _c_list = NULL;
		ValaList* _tmp206_;
		gint _c_size = 0;
		ValaList* _tmp207_;
		gint _tmp208_;
		gint _tmp209_;
		gint _c_index = 0;
		_tmp206_ = vala_object_type_symbol_get_constants ((ValaObjectTypeSymbol*) self);
		_c_list = _tmp206_;
		_tmp207_ = _c_list;
		_tmp208_ = vala_collection_get_size ((ValaCollection*) _tmp207_);
		_tmp209_ = _tmp208_;
		_c_size = _tmp209_;
		_c_index = -1;
		while (TRUE) {
			gint _tmp210_;
			gint _tmp211_;
			ValaConstant* c = NULL;
			ValaList* _tmp212_;
			gpointer _tmp213_;
			ValaConstant* _tmp214_;
			_c_index = _c_index + 1;
			_tmp210_ = _c_index;
			_tmp211_ = _c_size;
			if (!(_tmp210_ < _tmp211_)) {
				break;
			}
			_tmp212_ = _c_list;
			_tmp213_ = vala_list_get (_tmp212_, _c_index);
			c = (ValaConstant*) _tmp213_;
			_tmp214_ = c;
			vala_code_node_check ((ValaCodeNode*) _tmp214_, context);
			_vala_code_node_unref0 (c);
		}
	}
	{
		ValaList* _m_list = NULL;
		ValaList* _tmp215_;
		gint _m_size = 0;
		ValaList* _tmp216_;
		gint _tmp217_;
		gint _tmp218_;
		gint _m_index = 0;
		_tmp215_ = vala_object_type_symbol_get_methods ((ValaObjectTypeSymbol*) self);
		_m_list = _tmp215_;
		_tmp216_ = _m_list;
		_tmp217_ = vala_collection_get_size ((ValaCollection*) _tmp216_);
		_tmp218_ = _tmp217_;
		_m_size = _tmp218_;
		_m_index = -1;
		while (TRUE) {
			gint _tmp219_;
			gint _tmp220_;
			ValaMethod* m = NULL;
			ValaList* _tmp221_;
			gpointer _tmp222_;
			ValaMethod* _tmp223_;
			_m_index = _m_index + 1;
			_tmp219_ = _m_index;
			_tmp220_ = _m_size;
			if (!(_tmp219_ < _tmp220_)) {
				break;
			}
			_tmp221_ = _m_list;
			_tmp222_ = vala_list_get (_tmp221_, _m_index);
			m = (ValaMethod*) _tmp222_;
			_tmp223_ = m;
			vala_code_node_check ((ValaCodeNode*) _tmp223_, context);
			_vala_code_node_unref0 (m);
		}
	}
	{
		ValaList* _prop_list = NULL;
		ValaList* _tmp224_;
		gint _prop_size = 0;
		ValaList* _tmp225_;
		gint _tmp226_;
		gint _tmp227_;
		gint _prop_index = 0;
		_tmp224_ = vala_object_type_symbol_get_properties ((ValaObjectTypeSymbol*) self);
		_prop_list = _tmp224_;
		_tmp225_ = _prop_list;
		_tmp226_ = vala_collection_get_size ((ValaCollection*) _tmp225_);
		_tmp227_ = _tmp226_;
		_prop_size = _tmp227_;
		_prop_index = -1;
		while (TRUE) {
			gint _tmp228_;
			gint _tmp229_;
			ValaProperty* prop = NULL;
			ValaList* _tmp230_;
			gpointer _tmp231_;
			gboolean _tmp232_ = FALSE;
			ValaProperty* _tmp233_;
			ValaAttribute* _tmp234_;
			ValaProperty* _tmp241_;
			_prop_index = _prop_index + 1;
			_tmp228_ = _prop_index;
			_tmp229_ = _prop_size;
			if (!(_tmp228_ < _tmp229_)) {
				break;
			}
			_tmp230_ = _prop_list;
			_tmp231_ = vala_list_get (_tmp230_, _prop_index);
			prop = (ValaProperty*) _tmp231_;
			_tmp233_ = prop;
			_tmp234_ = vala_code_node_get_attribute ((ValaCodeNode*) _tmp233_, "NoAccessorMethod");
			if (_tmp234_ != NULL) {
				ValaSemanticAnalyzer* _tmp235_;
				ValaSemanticAnalyzer* _tmp236_;
				ValaClass* _tmp237_;
				_tmp235_ = vala_code_context_get_analyzer (context);
				_tmp236_ = _tmp235_;
				_tmp237_ = _tmp236_->object_type;
				_tmp232_ = !vala_typesymbol_is_subtype_of ((ValaTypeSymbol*) self, (ValaTypeSymbol*) _tmp237_);
			} else {
				_tmp232_ = FALSE;
			}
			if (_tmp232_) {
				ValaProperty* _tmp238_;
				ValaSourceReference* _tmp239_;
				ValaSourceReference* _tmp240_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp238_ = prop;
				_tmp239_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp238_);
				_tmp240_ = _tmp239_;
				vala_report_error (_tmp240_, "NoAccessorMethod is only allowed for properties in classes derived fro" \
"m GLib.Object");
				result = FALSE;
				_vala_code_node_unref0 (prop);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
			_tmp241_ = prop;
			vala_code_node_check ((ValaCodeNode*) _tmp241_, context);
			_vala_code_node_unref0 (prop);
		}
	}
	{
		ValaList* _sig_list = NULL;
		ValaList* _tmp242_;
		gint _sig_size = 0;
		ValaList* _tmp243_;
		gint _tmp244_;
		gint _tmp245_;
		gint _sig_index = 0;
		_tmp242_ = vala_object_type_symbol_get_signals ((ValaObjectTypeSymbol*) self);
		_sig_list = _tmp242_;
		_tmp243_ = _sig_list;
		_tmp244_ = vala_collection_get_size ((ValaCollection*) _tmp243_);
		_tmp245_ = _tmp244_;
		_sig_size = _tmp245_;
		_sig_index = -1;
		while (TRUE) {
			gint _tmp246_;
			gint _tmp247_;
			ValaSignal* sig = NULL;
			ValaList* _tmp248_;
			gpointer _tmp249_;
			ValaSignal* _tmp250_;
			_sig_index = _sig_index + 1;
			_tmp246_ = _sig_index;
			_tmp247_ = _sig_size;
			if (!(_tmp246_ < _tmp247_)) {
				break;
			}
			_tmp248_ = _sig_list;
			_tmp249_ = vala_list_get (_tmp248_, _sig_index);
			sig = (ValaSignal*) _tmp249_;
			_tmp250_ = sig;
			vala_code_node_check ((ValaCodeNode*) _tmp250_, context);
			_vala_code_node_unref0 (sig);
		}
	}
	_tmp251_ = vala_class_get_constructor (self);
	_tmp252_ = _tmp251_;
	if (_tmp252_ != NULL) {
		ValaConstructor* _tmp253_;
		ValaConstructor* _tmp254_;
		_tmp253_ = vala_class_get_constructor (self);
		_tmp254_ = _tmp253_;
		vala_code_node_check ((ValaCodeNode*) _tmp254_, context);
	}
	_tmp255_ = vala_class_get_class_constructor (self);
	_tmp256_ = _tmp255_;
	if (_tmp256_ != NULL) {
		ValaConstructor* _tmp257_;
		ValaConstructor* _tmp258_;
		_tmp257_ = vala_class_get_class_constructor (self);
		_tmp258_ = _tmp257_;
		vala_code_node_check ((ValaCodeNode*) _tmp258_, context);
	}
	_tmp259_ = vala_class_get_static_constructor (self);
	_tmp260_ = _tmp259_;
	if (_tmp260_ != NULL) {
		ValaConstructor* _tmp261_;
		ValaConstructor* _tmp262_;
		_tmp261_ = vala_class_get_static_constructor (self);
		_tmp262_ = _tmp261_;
		vala_code_node_check ((ValaCodeNode*) _tmp262_, context);
	}
	_tmp263_ = vala_class_get_destructor (self);
	_tmp264_ = _tmp263_;
	if (_tmp264_ != NULL) {
		ValaDestructor* _tmp265_;
		ValaDestructor* _tmp266_;
		_tmp265_ = vala_class_get_destructor (self);
		_tmp266_ = _tmp265_;
		vala_code_node_check ((ValaCodeNode*) _tmp266_, context);
	}
	_tmp267_ = vala_class_get_static_destructor (self);
	_tmp268_ = _tmp267_;
	if (_tmp268_ != NULL) {
		ValaDestructor* _tmp269_;
		ValaDestructor* _tmp270_;
		_tmp269_ = vala_class_get_static_destructor (self);
		_tmp270_ = _tmp269_;
		vala_code_node_check ((ValaCodeNode*) _tmp270_, context);
	}
	_tmp271_ = vala_class_get_class_destructor (self);
	_tmp272_ = _tmp271_;
	if (_tmp272_ != NULL) {
		ValaDestructor* _tmp273_;
		ValaDestructor* _tmp274_;
		_tmp273_ = vala_class_get_class_destructor (self);
		_tmp274_ = _tmp273_;
		vala_code_node_check ((ValaCodeNode*) _tmp274_, context);
	}
	{
		ValaList* _cl_list = NULL;
		ValaList* _tmp275_;
		gint _cl_size = 0;
		ValaList* _tmp276_;
		gint _tmp277_;
		gint _tmp278_;
		gint _cl_index = 0;
		_tmp275_ = vala_object_type_symbol_get_classes ((ValaObjectTypeSymbol*) self);
		_cl_list = _tmp275_;
		_tmp276_ = _cl_list;
		_tmp277_ = vala_collection_get_size ((ValaCollection*) _tmp276_);
		_tmp278_ = _tmp277_;
		_cl_size = _tmp278_;
		_cl_index = -1;
		while (TRUE) {
			gint _tmp279_;
			gint _tmp280_;
			ValaClass* cl = NULL;
			ValaList* _tmp281_;
			gpointer _tmp282_;
			ValaClass* _tmp283_;
			_cl_index = _cl_index + 1;
			_tmp279_ = _cl_index;
			_tmp280_ = _cl_size;
			if (!(_tmp279_ < _tmp280_)) {
				break;
			}
			_tmp281_ = _cl_list;
			_tmp282_ = vala_list_get (_tmp281_, _cl_index);
			cl = (ValaClass*) _tmp282_;
			_tmp283_ = cl;
			vala_code_node_check ((ValaCodeNode*) _tmp283_, context);
			_vala_code_node_unref0 (cl);
		}
	}
	{
		ValaList* _iface_list = NULL;
		ValaList* _tmp284_;
		gint _iface_size = 0;
		ValaList* _tmp285_;
		gint _tmp286_;
		gint _tmp287_;
		gint _iface_index = 0;
		_tmp284_ = vala_object_type_symbol_get_interfaces ((ValaObjectTypeSymbol*) self);
		_iface_list = _tmp284_;
		_tmp285_ = _iface_list;
		_tmp286_ = vala_collection_get_size ((ValaCollection*) _tmp285_);
		_tmp287_ = _tmp286_;
		_iface_size = _tmp287_;
		_iface_index = -1;
		while (TRUE) {
			gint _tmp288_;
			gint _tmp289_;
			ValaInterface* iface = NULL;
			ValaList* _tmp290_;
			gpointer _tmp291_;
			ValaInterface* _tmp292_;
			_iface_index = _iface_index + 1;
			_tmp288_ = _iface_index;
			_tmp289_ = _iface_size;
			if (!(_tmp288_ < _tmp289_)) {
				break;
			}
			_tmp290_ = _iface_list;
			_tmp291_ = vala_list_get (_tmp290_, _iface_index);
			iface = (ValaInterface*) _tmp291_;
			_tmp292_ = iface;
			vala_code_node_check ((ValaCodeNode*) _tmp292_, context);
			_vala_code_node_unref0 (iface);
		}
	}
	{
		ValaList* _st_list = NULL;
		ValaList* _tmp293_;
		gint _st_size = 0;
		ValaList* _tmp294_;
		gint _tmp295_;
		gint _tmp296_;
		gint _st_index = 0;
		_tmp293_ = vala_object_type_symbol_get_structs ((ValaObjectTypeSymbol*) self);
		_st_list = _tmp293_;
		_tmp294_ = _st_list;
		_tmp295_ = vala_collection_get_size ((ValaCollection*) _tmp294_);
		_tmp296_ = _tmp295_;
		_st_size = _tmp296_;
		_st_index = -1;
		while (TRUE) {
			gint _tmp297_;
			gint _tmp298_;
			ValaStruct* st = NULL;
			ValaList* _tmp299_;
			gpointer _tmp300_;
			ValaStruct* _tmp301_;
			_st_index = _st_index + 1;
			_tmp297_ = _st_index;
			_tmp298_ = _st_size;
			if (!(_tmp297_ < _tmp298_)) {
				break;
			}
			_tmp299_ = _st_list;
			_tmp300_ = vala_list_get (_tmp299_, _st_index);
			st = (ValaStruct*) _tmp300_;
			_tmp301_ = st;
			vala_code_node_check ((ValaCodeNode*) _tmp301_, context);
			_vala_code_node_unref0 (st);
		}
	}
	{
		ValaList* _d_list = NULL;
		ValaList* _tmp302_;
		gint _d_size = 0;
		ValaList* _tmp303_;
		gint _tmp304_;
		gint _tmp305_;
		gint _d_index = 0;
		_tmp302_ = vala_object_type_symbol_get_delegates ((ValaObjectTypeSymbol*) self);
		_d_list = _tmp302_;
		_tmp303_ = _d_list;
		_tmp304_ = vala_collection_get_size ((ValaCollection*) _tmp303_);
		_tmp305_ = _tmp304_;
		_d_size = _tmp305_;
		_d_index = -1;
		while (TRUE) {
			gint _tmp306_;
			gint _tmp307_;
			ValaDelegate* d = NULL;
			ValaList* _tmp308_;
			gpointer _tmp309_;
			ValaDelegate* _tmp310_;
			_d_index = _d_index + 1;
			_tmp306_ = _d_index;
			_tmp307_ = _d_size;
			if (!(_tmp306_ < _tmp307_)) {
				break;
			}
			_tmp308_ = _d_list;
			_tmp309_ = vala_list_get (_tmp308_, _d_index);
			d = (ValaDelegate*) _tmp309_;
			_tmp310_ = d;
			vala_code_node_check ((ValaCodeNode*) _tmp310_, context);
			_vala_code_node_unref0 (d);
		}
	}
	_tmp311_ = vala_class_get_is_compact (self);
	_tmp312_ = _tmp311_;
	if (_tmp312_) {
		gboolean _tmp328_ = FALSE;
		gboolean _tmp329_ = FALSE;
		gboolean _tmp330_ = FALSE;
		gboolean _tmp331_;
		gboolean _tmp332_;
		{
			ValaList* _base_type_list = NULL;
			ValaList* _tmp313_;
			gint _base_type_size = 0;
			ValaList* _tmp314_;
			gint _tmp315_;
			gint _tmp316_;
			gint _base_type_index = 0;
			_tmp313_ = vala_class_get_base_types (self);
			_base_type_list = _tmp313_;
			_tmp314_ = _base_type_list;
			_tmp315_ = vala_collection_get_size ((ValaCollection*) _tmp314_);
			_tmp316_ = _tmp315_;
			_base_type_size = _tmp316_;
			_base_type_index = -1;
			while (TRUE) {
				gint _tmp317_;
				gint _tmp318_;
				ValaDataType* base_type = NULL;
				ValaList* _tmp319_;
				gpointer _tmp320_;
				ValaDataType* _tmp321_;
				ValaTypeSymbol* _tmp322_;
				ValaTypeSymbol* _tmp323_;
				_base_type_index = _base_type_index + 1;
				_tmp317_ = _base_type_index;
				_tmp318_ = _base_type_size;
				if (!(_tmp317_ < _tmp318_)) {
					break;
				}
				_tmp319_ = _base_type_list;
				_tmp320_ = vala_list_get (_tmp319_, _base_type_index);
				base_type = (ValaDataType*) _tmp320_;
				_tmp321_ = base_type;
				_tmp322_ = vala_data_type_get_type_symbol (_tmp321_);
				_tmp323_ = _tmp322_;
				if (VALA_IS_INTERFACE (_tmp323_)) {
					ValaSourceReference* _tmp324_;
					ValaSourceReference* _tmp325_;
					gchar* _tmp326_;
					gchar* _tmp327_;
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					_tmp324_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp325_ = _tmp324_;
					_tmp326_ = vala_symbol_get_full_name ((ValaSymbol*) self);
					_tmp327_ = _tmp326_;
					vala_report_error (_tmp325_, "compact classes `%s' may not implement interfaces", _tmp327_);
					_g_free0 (_tmp327_);
				}
				_vala_code_node_unref0 (base_type);
			}
		}
		_tmp331_ = vala_symbol_get_external ((ValaSymbol*) self);
		_tmp332_ = _tmp331_;
		if (!_tmp332_) {
			gboolean _tmp333_;
			gboolean _tmp334_;
			_tmp333_ = vala_symbol_get_external_package ((ValaSymbol*) self);
			_tmp334_ = _tmp333_;
			_tmp330_ = !_tmp334_;
		} else {
			_tmp330_ = FALSE;
		}
		if (_tmp330_) {
			ValaClass* _tmp335_;
			_tmp335_ = self->priv->_base_class;
			_tmp329_ = _tmp335_ != NULL;
		} else {
			_tmp329_ = FALSE;
		}
		if (_tmp329_) {
			ValaClass* _tmp336_;
			ValaSemanticAnalyzer* _tmp337_;
			ValaSemanticAnalyzer* _tmp338_;
			ValaClass* _tmp339_;
			_tmp336_ = self->priv->_base_class;
			_tmp337_ = vala_code_context_get_analyzer (context);
			_tmp338_ = _tmp337_;
			_tmp339_ = _tmp338_->gsource_type;
			_tmp328_ = _tmp336_ != _tmp339_;
		} else {
			_tmp328_ = FALSE;
		}
		if (_tmp328_) {
			{
				ValaList* _f_list = NULL;
				ValaList* _tmp340_;
				gint _f_size = 0;
				ValaList* _tmp341_;
				gint _tmp342_;
				gint _tmp343_;
				gint _f_index = 0;
				_tmp340_ = vala_object_type_symbol_get_fields ((ValaObjectTypeSymbol*) self);
				_f_list = _tmp340_;
				_tmp341_ = _f_list;
				_tmp342_ = vala_collection_get_size ((ValaCollection*) _tmp341_);
				_tmp343_ = _tmp342_;
				_f_size = _tmp343_;
				_f_index = -1;
				while (TRUE) {
					gint _tmp344_;
					gint _tmp345_;
					ValaField* f = NULL;
					ValaList* _tmp346_;
					gpointer _tmp347_;
					ValaField* _tmp348_;
					ValaMemberBinding _tmp349_;
					ValaMemberBinding _tmp350_;
					_f_index = _f_index + 1;
					_tmp344_ = _f_index;
					_tmp345_ = _f_size;
					if (!(_tmp344_ < _tmp345_)) {
						break;
					}
					_tmp346_ = _f_list;
					_tmp347_ = vala_list_get (_tmp346_, _f_index);
					f = (ValaField*) _tmp347_;
					_tmp348_ = f;
					_tmp349_ = vala_field_get_binding (_tmp348_);
					_tmp350_ = _tmp349_;
					if (_tmp350_ == VALA_MEMBER_BINDING_INSTANCE) {
						ValaSourceReference* _tmp351_;
						ValaSourceReference* _tmp352_;
						vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
						_tmp351_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
						_tmp352_ = _tmp351_;
						vala_report_error (_tmp352_, "derived compact classes may not have instance fields");
						_vala_code_node_unref0 (f);
						break;
					}
					_vala_code_node_unref0 (f);
				}
			}
		}
	}
	_tmp353_ = g_direct_equal;
	_tmp354_ = vala_array_list_new (VALA_TYPE_TYPESYMBOL, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp353_);
	prerequisites = (ValaList*) _tmp354_;
	{
		ValaList* _base_type_list = NULL;
		ValaList* _tmp355_;
		gint _base_type_size = 0;
		ValaList* _tmp356_;
		gint _tmp357_;
		gint _tmp358_;
		gint _base_type_index = 0;
		_tmp355_ = vala_class_get_base_types (self);
		_base_type_list = _tmp355_;
		_tmp356_ = _base_type_list;
		_tmp357_ = vala_collection_get_size ((ValaCollection*) _tmp356_);
		_tmp358_ = _tmp357_;
		_base_type_size = _tmp358_;
		_base_type_index = -1;
		while (TRUE) {
			gint _tmp359_;
			gint _tmp360_;
			ValaDataType* base_type = NULL;
			ValaList* _tmp361_;
			gpointer _tmp362_;
			ValaDataType* _tmp363_;
			ValaTypeSymbol* _tmp364_;
			ValaTypeSymbol* _tmp365_;
			_base_type_index = _base_type_index + 1;
			_tmp359_ = _base_type_index;
			_tmp360_ = _base_type_size;
			if (!(_tmp359_ < _tmp360_)) {
				break;
			}
			_tmp361_ = _base_type_list;
			_tmp362_ = vala_list_get (_tmp361_, _base_type_index);
			base_type = (ValaDataType*) _tmp362_;
			_tmp363_ = base_type;
			_tmp364_ = vala_data_type_get_type_symbol (_tmp363_);
			_tmp365_ = _tmp364_;
			if (VALA_IS_INTERFACE (_tmp365_)) {
				ValaDataType* _tmp366_;
				ValaTypeSymbol* _tmp367_;
				ValaTypeSymbol* _tmp368_;
				ValaList* _tmp369_;
				_tmp366_ = base_type;
				_tmp367_ = vala_data_type_get_type_symbol (_tmp366_);
				_tmp368_ = _tmp367_;
				_tmp369_ = prerequisites;
				vala_class_get_all_prerequisites (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp368_, VALA_TYPE_INTERFACE, ValaInterface), _tmp369_);
			}
			_vala_code_node_unref0 (base_type);
		}
	}
	_tmp370_ = g_str_equal;
	_tmp371_ = vala_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp370_);
	missing_prereqs = (ValaList*) _tmp371_;
	{
		ValaList* _prereq_list = NULL;
		ValaList* _tmp372_;
		gint _prereq_size = 0;
		ValaList* _tmp373_;
		gint _tmp374_;
		gint _tmp375_;
		gint _prereq_index = 0;
		_tmp372_ = prerequisites;
		_prereq_list = _tmp372_;
		_tmp373_ = _prereq_list;
		_tmp374_ = vala_collection_get_size ((ValaCollection*) _tmp373_);
		_tmp375_ = _tmp374_;
		_prereq_size = _tmp375_;
		_prereq_index = -1;
		while (TRUE) {
			gint _tmp376_;
			gint _tmp377_;
			ValaTypeSymbol* prereq = NULL;
			ValaList* _tmp378_;
			gpointer _tmp379_;
			ValaTypeSymbol* _tmp380_;
			_prereq_index = _prereq_index + 1;
			_tmp376_ = _prereq_index;
			_tmp377_ = _prereq_size;
			if (!(_tmp376_ < _tmp377_)) {
				break;
			}
			_tmp378_ = _prereq_list;
			_tmp379_ = vala_list_get (_tmp378_, _prereq_index);
			prereq = (ValaTypeSymbol*) _tmp379_;
			_tmp380_ = prereq;
			if (!vala_class_is_a (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp380_, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol))) {
				ValaList* _tmp381_;
				ValaTypeSymbol* _tmp382_;
				gchar* _tmp383_;
				gchar* _tmp384_;
				_tmp381_ = missing_prereqs;
				_tmp382_ = prereq;
				_tmp383_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp382_);
				_tmp384_ = _tmp383_;
				vala_list_insert (_tmp381_, 0, _tmp384_);
				_g_free0 (_tmp384_);
			}
			_vala_code_node_unref0 (prereq);
		}
	}
	_tmp385_ = missing_prereqs;
	_tmp386_ = vala_collection_get_size ((ValaCollection*) _tmp385_);
	_tmp387_ = _tmp386_;
	if (_tmp387_ > 0) {
		gchar* error_string = NULL;
		gchar* _tmp388_;
		gchar* _tmp389_;
		gchar* _tmp390_;
		gchar* _tmp391_;
		gboolean first = FALSE;
		const gchar* _tmp406_;
		gchar* _tmp407_;
		ValaSourceReference* _tmp408_;
		ValaSourceReference* _tmp409_;
		const gchar* _tmp410_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp388_ = vala_symbol_get_full_name ((ValaSymbol*) self);
		_tmp389_ = _tmp388_;
		_tmp390_ = g_strdup_printf ("%s: some prerequisites (", _tmp389_);
		_tmp391_ = _tmp390_;
		_g_free0 (_tmp389_);
		error_string = _tmp391_;
		first = TRUE;
		{
			ValaList* _s_list = NULL;
			ValaList* _tmp392_;
			gint _s_size = 0;
			ValaList* _tmp393_;
			gint _tmp394_;
			gint _tmp395_;
			gint _s_index = 0;
			_tmp392_ = missing_prereqs;
			_s_list = _tmp392_;
			_tmp393_ = _s_list;
			_tmp394_ = vala_collection_get_size ((ValaCollection*) _tmp393_);
			_tmp395_ = _tmp394_;
			_s_size = _tmp395_;
			_s_index = -1;
			while (TRUE) {
				gint _tmp396_;
				gint _tmp397_;
				gchar* s = NULL;
				ValaList* _tmp398_;
				gpointer _tmp399_;
				_s_index = _s_index + 1;
				_tmp396_ = _s_index;
				_tmp397_ = _s_size;
				if (!(_tmp396_ < _tmp397_)) {
					break;
				}
				_tmp398_ = _s_list;
				_tmp399_ = vala_list_get (_tmp398_, _s_index);
				s = (gchar*) _tmp399_;
				if (first) {
					const gchar* _tmp400_;
					const gchar* _tmp401_;
					gchar* _tmp402_;
					_tmp400_ = error_string;
					_tmp401_ = s;
					_tmp402_ = g_strdup_printf ("%s`%s'", _tmp400_, _tmp401_);
					_g_free0 (error_string);
					error_string = _tmp402_;
					first = FALSE;
				} else {
					const gchar* _tmp403_;
					const gchar* _tmp404_;
					gchar* _tmp405_;
					_tmp403_ = error_string;
					_tmp404_ = s;
					_tmp405_ = g_strdup_printf ("%s, `%s'", _tmp403_, _tmp404_);
					_g_free0 (error_string);
					error_string = _tmp405_;
				}
				_g_free0 (s);
			}
		}
		_tmp406_ = error_string;
		_tmp407_ = g_strconcat (_tmp406_, ") are not met", NULL);
		_g_free0 (error_string);
		error_string = _tmp407_;
		_tmp408_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp409_ = _tmp408_;
		_tmp410_ = error_string;
		vala_report_error (_tmp409_, "%s", _tmp410_);
		_g_free0 (error_string);
	}
	_tmp411_ = vala_symbol_get_source_type ((ValaSymbol*) self);
	_tmp412_ = _tmp411_;
	if (_tmp412_ == VALA_SOURCE_FILE_TYPE_SOURCE) {
		gboolean _tmp563_;
		{
			ValaList* _base_type_list = NULL;
			ValaList* _tmp413_;
			gint _base_type_size = 0;
			ValaList* _tmp414_;
			gint _tmp415_;
			gint _tmp416_;
			gint _base_type_index = 0;
			_tmp413_ = vala_class_get_base_types (self);
			_base_type_list = _tmp413_;
			_tmp414_ = _base_type_list;
			_tmp415_ = vala_collection_get_size ((ValaCollection*) _tmp414_);
			_tmp416_ = _tmp415_;
			_base_type_size = _tmp416_;
			_base_type_index = -1;
			while (TRUE) {
				gint _tmp417_;
				gint _tmp418_;
				ValaDataType* base_type = NULL;
				ValaList* _tmp419_;
				gpointer _tmp420_;
				ValaDataType* _tmp421_;
				ValaTypeSymbol* _tmp422_;
				ValaTypeSymbol* _tmp423_;
				_base_type_index = _base_type_index + 1;
				_tmp417_ = _base_type_index;
				_tmp418_ = _base_type_size;
				if (!(_tmp417_ < _tmp418_)) {
					break;
				}
				_tmp419_ = _base_type_list;
				_tmp420_ = vala_list_get (_tmp419_, _base_type_index);
				base_type = (ValaDataType*) _tmp420_;
				_tmp421_ = base_type;
				_tmp422_ = vala_data_type_get_type_symbol (_tmp421_);
				_tmp423_ = _tmp422_;
				if (VALA_IS_INTERFACE (_tmp423_)) {
					ValaInterface* iface = NULL;
					ValaDataType* _tmp424_;
					ValaTypeSymbol* _tmp425_;
					ValaTypeSymbol* _tmp426_;
					gboolean _tmp427_ = FALSE;
					ValaClass* _tmp428_;
					_tmp424_ = base_type;
					_tmp425_ = vala_data_type_get_type_symbol (_tmp424_);
					_tmp426_ = _tmp425_;
					iface = G_TYPE_CHECK_INSTANCE_CAST (_tmp426_, VALA_TYPE_INTERFACE, ValaInterface);
					_tmp428_ = self->priv->_base_class;
					if (_tmp428_ != NULL) {
						ValaClass* _tmp429_;
						ValaInterface* _tmp430_;
						_tmp429_ = self->priv->_base_class;
						_tmp430_ = iface;
						_tmp427_ = vala_typesymbol_is_subtype_of ((ValaTypeSymbol*) _tmp429_, (ValaTypeSymbol*) _tmp430_);
					} else {
						_tmp427_ = FALSE;
					}
					if (_tmp427_) {
						_vala_code_node_unref0 (base_type);
						break;
					}
					{
						ValaList* _m_list = NULL;
						ValaInterface* _tmp431_;
						ValaList* _tmp432_;
						gint _m_size = 0;
						ValaList* _tmp433_;
						gint _tmp434_;
						gint _tmp435_;
						gint _m_index = 0;
						_tmp431_ = iface;
						_tmp432_ = vala_object_type_symbol_get_methods ((ValaObjectTypeSymbol*) _tmp431_);
						_m_list = _tmp432_;
						_tmp433_ = _m_list;
						_tmp434_ = vala_collection_get_size ((ValaCollection*) _tmp433_);
						_tmp435_ = _tmp434_;
						_m_size = _tmp435_;
						_m_index = -1;
						while (TRUE) {
							gint _tmp436_;
							gint _tmp437_;
							ValaMethod* m = NULL;
							ValaList* _tmp438_;
							gpointer _tmp439_;
							ValaMethod* _tmp440_;
							gboolean _tmp441_;
							gboolean _tmp442_;
							_m_index = _m_index + 1;
							_tmp436_ = _m_index;
							_tmp437_ = _m_size;
							if (!(_tmp436_ < _tmp437_)) {
								break;
							}
							_tmp438_ = _m_list;
							_tmp439_ = vala_list_get (_tmp438_, _m_index);
							m = (ValaMethod*) _tmp439_;
							_tmp440_ = m;
							_tmp441_ = vala_method_get_is_abstract (_tmp440_);
							_tmp442_ = _tmp441_;
							if (_tmp442_) {
								gboolean implemented = FALSE;
								ValaClass* base_class = NULL;
								implemented = FALSE;
								base_class = self;
								while (TRUE) {
									gboolean _tmp443_ = FALSE;
									ValaClass* _tmp444_;
									ValaClass* _tmp497_;
									ValaClass* _tmp498_;
									_tmp444_ = base_class;
									if (_tmp444_ != NULL) {
										_tmp443_ = !implemented;
									} else {
										_tmp443_ = FALSE;
									}
									if (!_tmp443_) {
										break;
									}
									{
										ValaList* _impl_list = NULL;
										ValaClass* _tmp445_;
										ValaList* _tmp446_;
										gint _impl_size = 0;
										ValaList* _tmp447_;
										gint _tmp448_;
										gint _tmp449_;
										gint _impl_index = 0;
										_tmp445_ = base_class;
										_tmp446_ = vala_object_type_symbol_get_methods ((ValaObjectTypeSymbol*) _tmp445_);
										_impl_list = _tmp446_;
										_tmp447_ = _impl_list;
										_tmp448_ = vala_collection_get_size ((ValaCollection*) _tmp447_);
										_tmp449_ = _tmp448_;
										_impl_size = _tmp449_;
										_impl_index = -1;
										while (TRUE) {
											gint _tmp450_;
											gint _tmp451_;
											ValaMethod* impl = NULL;
											ValaList* _tmp452_;
											gpointer _tmp453_;
											gboolean _tmp454_ = FALSE;
											ValaMethod* _tmp455_;
											ValaMethod* _tmp456_;
											ValaMethod* _tmp457_;
											ValaMethod* _tmp458_;
											_impl_index = _impl_index + 1;
											_tmp450_ = _impl_index;
											_tmp451_ = _impl_size;
											if (!(_tmp450_ < _tmp451_)) {
												break;
											}
											_tmp452_ = _impl_list;
											_tmp453_ = vala_list_get (_tmp452_, _impl_index);
											impl = (ValaMethod*) _tmp453_;
											_tmp455_ = impl;
											_tmp456_ = vala_method_get_base_interface_method (_tmp455_);
											_tmp457_ = _tmp456_;
											_tmp458_ = m;
											if (_tmp457_ == _tmp458_) {
												_tmp454_ = TRUE;
											} else {
												gboolean _tmp459_ = FALSE;
												gboolean _tmp460_ = FALSE;
												gboolean _tmp461_ = FALSE;
												gboolean _tmp462_ = FALSE;
												ValaClass* _tmp463_;
												_tmp463_ = base_class;
												if (_tmp463_ != self) {
													ValaMethod* _tmp464_;
													ValaMethod* _tmp465_;
													ValaMethod* _tmp466_;
													_tmp464_ = impl;
													_tmp465_ = vala_method_get_base_interface_method (_tmp464_);
													_tmp466_ = _tmp465_;
													_tmp462_ = _tmp466_ == NULL;
												} else {
													_tmp462_ = FALSE;
												}
												if (_tmp462_) {
													ValaMethod* _tmp467_;
													const gchar* _tmp468_;
													const gchar* _tmp469_;
													ValaMethod* _tmp470_;
													const gchar* _tmp471_;
													const gchar* _tmp472_;
													_tmp467_ = impl;
													_tmp468_ = vala_symbol_get_name ((ValaSymbol*) _tmp467_);
													_tmp469_ = _tmp468_;
													_tmp470_ = m;
													_tmp471_ = vala_symbol_get_name ((ValaSymbol*) _tmp470_);
													_tmp472_ = _tmp471_;
													_tmp461_ = g_strcmp0 (_tmp469_, _tmp472_) == 0;
												} else {
													_tmp461_ = FALSE;
												}
												if (_tmp461_) {
													gboolean _tmp473_ = FALSE;
													ValaMethod* _tmp474_;
													ValaDataType* _tmp475_;
													ValaDataType* _tmp476_;
													_tmp474_ = impl;
													_tmp475_ = vala_method_get_base_interface_type (_tmp474_);
													_tmp476_ = _tmp475_;
													if (_tmp476_ == NULL) {
														_tmp473_ = TRUE;
													} else {
														ValaMethod* _tmp477_;
														ValaDataType* _tmp478_;
														ValaDataType* _tmp479_;
														ValaTypeSymbol* _tmp480_;
														ValaTypeSymbol* _tmp481_;
														ValaInterface* _tmp482_;
														_tmp477_ = impl;
														_tmp478_ = vala_method_get_base_interface_type (_tmp477_);
														_tmp479_ = _tmp478_;
														_tmp480_ = vala_data_type_get_type_symbol (_tmp479_);
														_tmp481_ = _tmp480_;
														_tmp482_ = iface;
														_tmp473_ = _tmp481_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp482_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol);
													}
													_tmp460_ = _tmp473_;
												} else {
													_tmp460_ = FALSE;
												}
												if (_tmp460_) {
													ValaMethod* _tmp483_;
													ValaMethod* _tmp484_;
													_tmp483_ = impl;
													_tmp484_ = m;
													_tmp459_ = vala_method_compatible_no_error (_tmp483_, _tmp484_);
												} else {
													_tmp459_ = FALSE;
												}
												_tmp454_ = _tmp459_;
											}
											if (_tmp454_) {
												ValaMethod* _tmp485_;
												ValaVersionAttribute* _tmp486_;
												ValaVersionAttribute* _tmp487_;
												ValaSourceReference* _tmp488_;
												ValaSourceReference* _tmp489_;
												ValaMethod* _tmp490_;
												ValaMethod* _tmp491_;
												ValaMethod* _tmp492_;
												ValaMethod* _tmp493_;
												_tmp485_ = impl;
												_tmp486_ = vala_symbol_get_version ((ValaSymbol*) _tmp485_);
												_tmp487_ = _tmp486_;
												_tmp488_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
												_tmp489_ = _tmp488_;
												vala_version_attribute_check (_tmp487_, context, _tmp489_);
												_tmp490_ = impl;
												vala_symbol_set_used ((ValaSymbol*) _tmp490_, TRUE);
												implemented = TRUE;
												_tmp491_ = impl;
												_tmp492_ = vala_method_get_base_interface_method (_tmp491_);
												_tmp493_ = _tmp492_;
												if (_tmp493_ == NULL) {
													ValaHashMap* _tmp494_;
													ValaMethod* _tmp495_;
													ValaMethod* _tmp496_;
													_tmp494_ = self->priv->implicit_implementations;
													_tmp495_ = m;
													_tmp496_ = impl;
													vala_map_set ((ValaMap*) _tmp494_, _tmp495_, _tmp496_);
												}
												_vala_code_node_unref0 (impl);
												break;
											}
											_vala_code_node_unref0 (impl);
										}
									}
									_tmp497_ = base_class;
									_tmp498_ = _tmp497_->priv->_base_class;
									base_class = _tmp498_;
								}
								if (!implemented) {
									ValaSourceReference* _tmp499_;
									ValaSourceReference* _tmp500_;
									gchar* _tmp501_;
									gchar* _tmp502_;
									ValaMethod* _tmp503_;
									gchar* _tmp504_;
									gchar* _tmp505_;
									vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
									_tmp499_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
									_tmp500_ = _tmp499_;
									_tmp501_ = vala_symbol_get_full_name ((ValaSymbol*) self);
									_tmp502_ = _tmp501_;
									_tmp503_ = m;
									_tmp504_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp503_);
									_tmp505_ = _tmp504_;
									vala_report_error (_tmp500_, "`%s' does not implement interface method `%s'", _tmp502_, _tmp505_);
									_g_free0 (_tmp505_);
									_g_free0 (_tmp502_);
								}
							}
							_vala_code_node_unref0 (m);
						}
					}
					{
						ValaList* _prop_list = NULL;
						ValaInterface* _tmp506_;
						ValaList* _tmp507_;
						gint _prop_size = 0;
						ValaList* _tmp508_;
						gint _tmp509_;
						gint _tmp510_;
						gint _prop_index = 0;
						_tmp506_ = iface;
						_tmp507_ = vala_object_type_symbol_get_properties ((ValaObjectTypeSymbol*) _tmp506_);
						_prop_list = _tmp507_;
						_tmp508_ = _prop_list;
						_tmp509_ = vala_collection_get_size ((ValaCollection*) _tmp508_);
						_tmp510_ = _tmp509_;
						_prop_size = _tmp510_;
						_prop_index = -1;
						while (TRUE) {
							gint _tmp511_;
							gint _tmp512_;
							ValaProperty* prop = NULL;
							ValaList* _tmp513_;
							gpointer _tmp514_;
							ValaProperty* _tmp515_;
							gboolean _tmp516_;
							gboolean _tmp517_;
							_prop_index = _prop_index + 1;
							_tmp511_ = _prop_index;
							_tmp512_ = _prop_size;
							if (!(_tmp511_ < _tmp512_)) {
								break;
							}
							_tmp513_ = _prop_list;
							_tmp514_ = vala_list_get (_tmp513_, _prop_index);
							prop = (ValaProperty*) _tmp514_;
							_tmp515_ = prop;
							_tmp516_ = vala_property_get_is_abstract (_tmp515_);
							_tmp517_ = _tmp516_;
							if (_tmp517_) {
								ValaSymbol* sym = NULL;
								ValaClass* base_class = NULL;
								ValaSymbol* _tmp530_;
								sym = NULL;
								base_class = self;
								while (TRUE) {
									gboolean _tmp518_ = FALSE;
									ValaClass* _tmp519_;
									ValaClass* _tmp521_;
									ValaScope* _tmp522_;
									ValaScope* _tmp523_;
									ValaProperty* _tmp524_;
									const gchar* _tmp525_;
									const gchar* _tmp526_;
									ValaSymbol* _tmp527_;
									ValaClass* _tmp528_;
									ValaClass* _tmp529_;
									_tmp519_ = base_class;
									if (_tmp519_ != NULL) {
										ValaSymbol* _tmp520_;
										_tmp520_ = sym;
										_tmp518_ = !VALA_IS_PROPERTY (_tmp520_);
									} else {
										_tmp518_ = FALSE;
									}
									if (!_tmp518_) {
										break;
									}
									_tmp521_ = base_class;
									_tmp522_ = vala_symbol_get_scope ((ValaSymbol*) _tmp521_);
									_tmp523_ = _tmp522_;
									_tmp524_ = prop;
									_tmp525_ = vala_symbol_get_name ((ValaSymbol*) _tmp524_);
									_tmp526_ = _tmp525_;
									_tmp527_ = vala_scope_lookup (_tmp523_, _tmp526_);
									_vala_code_node_unref0 (sym);
									sym = _tmp527_;
									_tmp528_ = base_class;
									_tmp529_ = _tmp528_->priv->_base_class;
									base_class = _tmp529_;
								}
								_tmp530_ = sym;
								if (VALA_IS_PROPERTY (_tmp530_)) {
									ValaProperty* base_prop = NULL;
									ValaSymbol* _tmp531_;
									ValaProperty* _tmp532_;
									gchar* invalid_match = NULL;
									gboolean _tmp533_ = FALSE;
									ValaProperty* _tmp534_;
									gboolean _tmp535_;
									gboolean _tmp536_;
									ValaSymbol* _tmp550_;
									ValaVersionAttribute* _tmp551_;
									ValaVersionAttribute* _tmp552_;
									ValaSourceReference* _tmp553_;
									ValaSourceReference* _tmp554_;
									ValaSymbol* _tmp555_;
									_tmp531_ = sym;
									_tmp532_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp531_, VALA_TYPE_PROPERTY, ValaProperty));
									base_prop = _tmp532_;
									invalid_match = NULL;
									_tmp534_ = base_prop;
									_tmp535_ = vala_symbol_get_hides ((ValaSymbol*) _tmp534_);
									_tmp536_ = _tmp535_;
									if (!_tmp536_) {
										ValaProperty* _tmp537_;
										ValaProperty* _tmp538_;
										gchar* _tmp539_ = NULL;
										gboolean _tmp540_;
										_tmp537_ = base_prop;
										_tmp538_ = prop;
										_tmp540_ = vala_property_compatible (_tmp537_, _tmp538_, &_tmp539_);
										_g_free0 (invalid_match);
										invalid_match = _tmp539_;
										_tmp533_ = !_tmp540_;
									} else {
										_tmp533_ = FALSE;
									}
									if (_tmp533_) {
										ValaSourceReference* _tmp541_;
										ValaSourceReference* _tmp542_;
										ValaProperty* _tmp543_;
										gchar* _tmp544_;
										gchar* _tmp545_;
										ValaProperty* _tmp546_;
										gchar* _tmp547_;
										gchar* _tmp548_;
										const gchar* _tmp549_;
										vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
										_tmp541_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
										_tmp542_ = _tmp541_;
										_tmp543_ = prop;
										_tmp544_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp543_);
										_tmp545_ = _tmp544_;
										_tmp546_ = base_prop;
										_tmp547_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp546_);
										_tmp548_ = _tmp547_;
										_tmp549_ = invalid_match;
										vala_report_error (_tmp542_, "Type and/or accessors of inherited properties `%s' and `%s' do not mat" \
"ch: %s.", _tmp545_, _tmp548_, _tmp549_);
										_g_free0 (_tmp548_);
										_g_free0 (_tmp545_);
									}
									_tmp550_ = sym;
									_tmp551_ = vala_symbol_get_version (_tmp550_);
									_tmp552_ = _tmp551_;
									_tmp553_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
									_tmp554_ = _tmp553_;
									vala_version_attribute_check (_tmp552_, context, _tmp554_);
									_tmp555_ = sym;
									vala_symbol_set_used (_tmp555_, TRUE);
									_g_free0 (invalid_match);
									_vala_code_node_unref0 (base_prop);
								} else {
									ValaSourceReference* _tmp556_;
									ValaSourceReference* _tmp557_;
									gchar* _tmp558_;
									gchar* _tmp559_;
									ValaProperty* _tmp560_;
									gchar* _tmp561_;
									gchar* _tmp562_;
									vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
									_tmp556_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
									_tmp557_ = _tmp556_;
									_tmp558_ = vala_symbol_get_full_name ((ValaSymbol*) self);
									_tmp559_ = _tmp558_;
									_tmp560_ = prop;
									_tmp561_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp560_);
									_tmp562_ = _tmp561_;
									vala_report_error (_tmp557_, "`%s' does not implement interface property `%s'", _tmp559_, _tmp562_);
									_g_free0 (_tmp562_);
									_g_free0 (_tmp559_);
								}
								_vala_code_node_unref0 (sym);
							}
							_vala_code_node_unref0 (prop);
						}
					}
				}
				_vala_code_node_unref0 (base_type);
			}
		}
		_tmp563_ = self->priv->_is_abstract;
		if (!_tmp563_) {
			ValaClass* base_class = NULL;
			ValaClass* _tmp564_;
			_tmp564_ = self->priv->_base_class;
			base_class = _tmp564_;
			while (TRUE) {
				gboolean _tmp565_ = FALSE;
				ValaClass* _tmp566_;
				ValaClass* _tmp627_;
				ValaClass* _tmp628_;
				_tmp566_ = base_class;
				if (_tmp566_ != NULL) {
					ValaClass* _tmp567_;
					gboolean _tmp568_;
					_tmp567_ = base_class;
					_tmp568_ = _tmp567_->priv->_is_abstract;
					_tmp565_ = _tmp568_;
				} else {
					_tmp565_ = FALSE;
				}
				if (!_tmp565_) {
					break;
				}
				{
					ValaList* _base_method_list = NULL;
					ValaClass* _tmp569_;
					ValaList* _tmp570_;
					gint _base_method_size = 0;
					ValaList* _tmp571_;
					gint _tmp572_;
					gint _tmp573_;
					gint _base_method_index = 0;
					_tmp569_ = base_class;
					_tmp570_ = vala_object_type_symbol_get_methods ((ValaObjectTypeSymbol*) _tmp569_);
					_base_method_list = _tmp570_;
					_tmp571_ = _base_method_list;
					_tmp572_ = vala_collection_get_size ((ValaCollection*) _tmp571_);
					_tmp573_ = _tmp572_;
					_base_method_size = _tmp573_;
					_base_method_index = -1;
					while (TRUE) {
						gint _tmp574_;
						gint _tmp575_;
						ValaMethod* base_method = NULL;
						ValaList* _tmp576_;
						gpointer _tmp577_;
						ValaMethod* _tmp578_;
						gboolean _tmp579_;
						gboolean _tmp580_;
						_base_method_index = _base_method_index + 1;
						_tmp574_ = _base_method_index;
						_tmp575_ = _base_method_size;
						if (!(_tmp574_ < _tmp575_)) {
							break;
						}
						_tmp576_ = _base_method_list;
						_tmp577_ = vala_list_get (_tmp576_, _base_method_index);
						base_method = (ValaMethod*) _tmp577_;
						_tmp578_ = base_method;
						_tmp579_ = vala_method_get_is_abstract (_tmp578_);
						_tmp580_ = _tmp579_;
						if (_tmp580_) {
							ValaMethod* override_method = NULL;
							ValaMethod* _tmp581_;
							const gchar* _tmp582_;
							const gchar* _tmp583_;
							ValaSymbol* _tmp584_;
							ValaMethod* _tmp585_;
							gboolean _tmp586_ = FALSE;
							ValaMethod* _tmp587_;
							_tmp581_ = base_method;
							_tmp582_ = vala_symbol_get_name ((ValaSymbol*) _tmp581_);
							_tmp583_ = _tmp582_;
							_tmp584_ = vala_semantic_analyzer_symbol_lookup_inherited ((ValaSymbol*) self, _tmp583_);
							_tmp585_ = VALA_IS_METHOD (_tmp584_) ? ((ValaMethod*) _tmp584_) : NULL;
							if (_tmp585_ == NULL) {
								_vala_code_node_unref0 (_tmp584_);
							}
							override_method = _tmp585_;
							_tmp587_ = override_method;
							if (_tmp587_ == NULL) {
								_tmp586_ = TRUE;
							} else {
								ValaMethod* _tmp588_;
								gboolean _tmp589_;
								gboolean _tmp590_;
								_tmp588_ = override_method;
								_tmp589_ = vala_method_get_overrides (_tmp588_);
								_tmp590_ = _tmp589_;
								_tmp586_ = !_tmp590_;
							}
							if (_tmp586_) {
								ValaSourceReference* _tmp591_;
								ValaSourceReference* _tmp592_;
								gchar* _tmp593_;
								gchar* _tmp594_;
								ValaMethod* _tmp595_;
								gchar* _tmp596_;
								gchar* _tmp597_;
								vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
								_tmp591_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
								_tmp592_ = _tmp591_;
								_tmp593_ = vala_symbol_get_full_name ((ValaSymbol*) self);
								_tmp594_ = _tmp593_;
								_tmp595_ = base_method;
								_tmp596_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp595_);
								_tmp597_ = _tmp596_;
								vala_report_error (_tmp592_, "`%s' does not implement abstract method `%s'", _tmp594_, _tmp597_);
								_g_free0 (_tmp597_);
								_g_free0 (_tmp594_);
							}
							_vala_code_node_unref0 (override_method);
						}
						_vala_code_node_unref0 (base_method);
					}
				}
				{
					ValaList* _base_property_list = NULL;
					ValaClass* _tmp598_;
					ValaList* _tmp599_;
					gint _base_property_size = 0;
					ValaList* _tmp600_;
					gint _tmp601_;
					gint _tmp602_;
					gint _base_property_index = 0;
					_tmp598_ = base_class;
					_tmp599_ = vala_object_type_symbol_get_properties ((ValaObjectTypeSymbol*) _tmp598_);
					_base_property_list = _tmp599_;
					_tmp600_ = _base_property_list;
					_tmp601_ = vala_collection_get_size ((ValaCollection*) _tmp600_);
					_tmp602_ = _tmp601_;
					_base_property_size = _tmp602_;
					_base_property_index = -1;
					while (TRUE) {
						gint _tmp603_;
						gint _tmp604_;
						ValaProperty* base_property = NULL;
						ValaList* _tmp605_;
						gpointer _tmp606_;
						ValaProperty* _tmp607_;
						gboolean _tmp608_;
						gboolean _tmp609_;
						_base_property_index = _base_property_index + 1;
						_tmp603_ = _base_property_index;
						_tmp604_ = _base_property_size;
						if (!(_tmp603_ < _tmp604_)) {
							break;
						}
						_tmp605_ = _base_property_list;
						_tmp606_ = vala_list_get (_tmp605_, _base_property_index);
						base_property = (ValaProperty*) _tmp606_;
						_tmp607_ = base_property;
						_tmp608_ = vala_property_get_is_abstract (_tmp607_);
						_tmp609_ = _tmp608_;
						if (_tmp609_) {
							ValaProperty* override_property = NULL;
							ValaProperty* _tmp610_;
							const gchar* _tmp611_;
							const gchar* _tmp612_;
							ValaSymbol* _tmp613_;
							ValaProperty* _tmp614_;
							gboolean _tmp615_ = FALSE;
							ValaProperty* _tmp616_;
							_tmp610_ = base_property;
							_tmp611_ = vala_symbol_get_name ((ValaSymbol*) _tmp610_);
							_tmp612_ = _tmp611_;
							_tmp613_ = vala_semantic_analyzer_symbol_lookup_inherited ((ValaSymbol*) self, _tmp612_);
							_tmp614_ = VALA_IS_PROPERTY (_tmp613_) ? ((ValaProperty*) _tmp613_) : NULL;
							if (_tmp614_ == NULL) {
								_vala_code_node_unref0 (_tmp613_);
							}
							override_property = _tmp614_;
							_tmp616_ = override_property;
							if (_tmp616_ == NULL) {
								_tmp615_ = TRUE;
							} else {
								ValaProperty* _tmp617_;
								gboolean _tmp618_;
								gboolean _tmp619_;
								_tmp617_ = override_property;
								_tmp618_ = vala_property_get_overrides (_tmp617_);
								_tmp619_ = _tmp618_;
								_tmp615_ = !_tmp619_;
							}
							if (_tmp615_) {
								ValaSourceReference* _tmp620_;
								ValaSourceReference* _tmp621_;
								gchar* _tmp622_;
								gchar* _tmp623_;
								ValaProperty* _tmp624_;
								gchar* _tmp625_;
								gchar* _tmp626_;
								vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
								_tmp620_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
								_tmp621_ = _tmp620_;
								_tmp622_ = vala_symbol_get_full_name ((ValaSymbol*) self);
								_tmp623_ = _tmp622_;
								_tmp624_ = base_property;
								_tmp625_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp624_);
								_tmp626_ = _tmp625_;
								vala_report_error (_tmp621_, "`%s' does not implement abstract property `%s'", _tmp623_, _tmp626_);
								_g_free0 (_tmp626_);
								_g_free0 (_tmp623_);
							}
							_vala_code_node_unref0 (override_property);
						}
						_vala_code_node_unref0 (base_property);
					}
				}
				_tmp627_ = base_class;
				_tmp628_ = _tmp627_->priv->_base_class;
				base_class = _tmp628_;
			}
		}
	}
	_tmp629_ = vala_code_context_get_analyzer (context);
	_tmp630_ = _tmp629_;
	_tmp631_ = old_source_file;
	vala_semantic_analyzer_set_current_source_file (_tmp630_, _tmp631_);
	_tmp632_ = vala_code_context_get_analyzer (context);
	_tmp633_ = _tmp632_;
	_tmp634_ = old_symbol;
	vala_semantic_analyzer_set_current_symbol (_tmp633_, _tmp634_);
	_tmp635_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp636_ = _tmp635_;
	result = !_tmp636_;
	_vala_iterable_unref0 (missing_prereqs);
	_vala_iterable_unref0 (prerequisites);
	_vala_code_node_unref0 (old_symbol);
	_vala_source_file_unref0 (old_source_file);
	return result;
}

static void
vala_class_class_init (ValaClassClass * klass,
                       gpointer klass_data)
{
	vala_class_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_class_finalize;
	g_type_class_adjust_private_offset (klass, &ValaClass_private_offset);
	((ValaSymbolClass *) klass)->add_field = (void (*) (ValaSymbol*, ValaField*)) vala_class_real_add_field;
	((ValaSymbolClass *) klass)->add_method = (void (*) (ValaSymbol*, ValaMethod*)) vala_class_real_add_method;
	((ValaSymbolClass *) klass)->add_property = (void (*) (ValaSymbol*, ValaProperty*)) vala_class_real_add_property;
	((ValaSymbolClass *) klass)->add_constructor = (void (*) (ValaSymbol*, ValaConstructor*)) vala_class_real_add_constructor;
	((ValaSymbolClass *) klass)->add_destructor = (void (*) (ValaSymbol*, ValaDestructor*)) vala_class_real_add_destructor;
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_class_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_class_real_accept_children;
	((ValaTypeSymbolClass *) klass)->is_reference_type = (gboolean (*) (ValaTypeSymbol*)) vala_class_real_is_reference_type;
	((ValaTypeSymbolClass *) klass)->is_subtype_of = (gboolean (*) (ValaTypeSymbol*, ValaTypeSymbol*)) vala_class_real_is_subtype_of;
	((ValaCodeNodeClass *) klass)->replace_type = (void (*) (ValaCodeNode*, ValaDataType*, ValaDataType*)) vala_class_real_replace_type;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode*, ValaCodeContext*)) vala_class_real_check;
}

static void
vala_class_instance_init (ValaClass * self,
                          gpointer klass)
{
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	GEqualFunc _tmp2_;
	ValaHashMap* _tmp3_;
	self->priv = vala_class_get_instance_private (self);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_DATA_TYPE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp0_);
	self->priv->base_types = (ValaList*) _tmp1_;
	_tmp2_ = g_direct_equal;
	_tmp3_ = vala_hash_map_new (VALA_TYPE_METHOD, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, VALA_TYPE_METHOD, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _vala_symbol_hash_func_ghash_func, _vala_symbol_equal_func_gequal_func, _tmp2_);
	self->priv->implicit_implementations = _tmp3_;
}

static void
vala_class_finalize (ValaCodeNode * obj)
{
	ValaClass * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_CLASS, ValaClass);
	_vala_code_node_unref0 (self->priv->_base_class);
	_g_free0 (self->priv->_is_compact);
	_g_free0 (self->priv->_is_opaque);
	_g_free0 (self->priv->_is_immutable);
	_g_free0 (self->priv->_is_singleton);
	_vala_iterable_unref0 (self->priv->base_types);
	_vala_map_unref0 (self->priv->implicit_implementations);
	_vala_code_node_unref0 (self->priv->_default_construction_method);
	_vala_code_node_unref0 (self->priv->_constructor);
	_vala_code_node_unref0 (self->priv->_class_constructor);
	_vala_code_node_unref0 (self->priv->_static_constructor);
	_vala_code_node_unref0 (self->priv->_destructor);
	_vala_code_node_unref0 (self->priv->_class_destructor);
	_vala_code_node_unref0 (self->priv->_static_destructor);
	VALA_CODE_NODE_CLASS (vala_class_parent_class)->finalize (obj);
}

/**
 * Represents a class declaration in the source code.
 */
static GType
vala_class_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaClassClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_class_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaClass), 0, (GInstanceInitFunc) vala_class_instance_init, NULL };
	GType vala_class_type_id;
	vala_class_type_id = g_type_register_static (VALA_TYPE_OBJECT_TYPE_SYMBOL, "ValaClass", &g_define_type_info, 0);
	ValaClass_private_offset = g_type_add_instance_private (vala_class_type_id, sizeof (ValaClassPrivate));
	return vala_class_type_id;
}

GType
vala_class_get_type (void)
{
	static volatile gsize vala_class_type_id__volatile = 0;
	if (g_once_init_enter (&vala_class_type_id__volatile)) {
		GType vala_class_type_id;
		vala_class_type_id = vala_class_get_type_once ();
		g_once_init_leave (&vala_class_type_id__volatile, vala_class_type_id);
	}
	return vala_class_type_id__volatile;
}

