/* valainterface.c generated by valac, the Vala compiler
 * generated from valainterface.vala, do not modify */

/* valainterface.vala
 *
 * Copyright (C) 2006-2010  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include "vala.h"
#include <valagee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))
#define _vala_map_unref0(var) ((var == NULL) ? NULL : (var = (vala_map_unref (var), NULL)))

struct _ValaInterfacePrivate {
	ValaList* prerequisites;
	ValaList* virtuals;
};

static gint ValaInterface_private_offset;
static gpointer vala_interface_parent_class = NULL;

static void vala_interface_real_add_method (ValaSymbol* base,
                                     ValaMethod* m);
static void vala_interface_real_add_property (ValaSymbol* base,
                                       ValaProperty* prop);
static ValaList* vala_interface_real_get_virtuals (ValaInterface* self);
static void vala_interface_real_accept (ValaCodeNode* base,
                                 ValaCodeVisitor* visitor);
static void vala_interface_real_accept_children (ValaCodeNode* base,
                                          ValaCodeVisitor* visitor);
static gboolean vala_interface_real_is_reference_type (ValaTypeSymbol* base);
static gboolean vala_interface_real_is_subtype_of (ValaTypeSymbol* base,
                                            ValaTypeSymbol* t);
static void vala_interface_real_replace_type (ValaCodeNode* base,
                                       ValaDataType* old_type,
                                       ValaDataType* new_type);
static gboolean vala_interface_real_check (ValaCodeNode* base,
                                    ValaCodeContext* context);
static void vala_interface_finalize (ValaCodeNode * obj);
static GType vala_interface_get_type_once (void);

static inline gpointer
vala_interface_get_instance_private (ValaInterface* self)
{
	return G_STRUCT_MEMBER_P (self, ValaInterface_private_offset);
}

/**
 * Creates a new interface.
 *
 * @param name              type name
 * @param source_reference  reference to source code
 * @return                  newly created interface
 */
ValaInterface*
vala_interface_construct (GType object_type,
                          const gchar* name,
                          ValaSourceReference* source_reference,
                          ValaComment* comment)
{
	ValaInterface* self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (ValaInterface*) vala_object_type_symbol_construct (object_type, name, source_reference, comment);
	return self;
}

ValaInterface*
vala_interface_new (const gchar* name,
                    ValaSourceReference* source_reference,
                    ValaComment* comment)
{
	return vala_interface_construct (VALA_TYPE_INTERFACE, name, source_reference, comment);
}

/**
 * Adds the specified interface or class to the list of prerequisites of
 * this interface.
 *
 * @param type an interface or class reference
 */
void
vala_interface_add_prerequisite (ValaInterface* self,
                                 ValaDataType* type)
{
	ValaList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (type != NULL);
	_tmp0_ = self->priv->prerequisites;
	vala_collection_add ((ValaCollection*) _tmp0_, type);
	vala_code_node_set_parent_node ((ValaCodeNode*) type, (ValaCodeNode*) self);
}

/**
 * Returns the base type list.
 *
 * @return list of base types
 */
ValaList*
vala_interface_get_prerequisites (ValaInterface* self)
{
	ValaList* _tmp0_;
	ValaList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->prerequisites;
	result = _tmp0_;
	return result;
}

/**
 * Adds the specified method as a member to this interface.
 *
 * @param m a method
 */
static void
vala_interface_real_add_method (ValaSymbol* base,
                                ValaMethod* m)
{
	ValaInterface * self;
	ValaMemberBinding _tmp2_;
	ValaMemberBinding _tmp3_;
	gboolean _tmp16_ = FALSE;
	ValaDataType* _tmp17_;
	ValaDataType* _tmp18_;
	self = (ValaInterface*) base;
	g_return_if_fail (m != NULL);
	if (VALA_IS_CREATION_METHOD (m)) {
		ValaSourceReference* _tmp0_;
		ValaSourceReference* _tmp1_;
		_tmp0_ = vala_code_node_get_source_reference ((ValaCodeNode*) m);
		_tmp1_ = _tmp0_;
		vala_report_error (_tmp1_, "construction methods may only be declared within classes and structs");
		vala_code_node_set_error ((ValaCodeNode*) m, TRUE);
		return;
	}
	_tmp2_ = vala_method_get_binding (m);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != VALA_MEMBER_BINDING_STATIC) {
		ValaDataType* _tmp4_;
		ValaDataType* _tmp5_;
		ValaParameter* _tmp6_;
		ValaParameter* _tmp7_;
		ValaScope* _tmp8_;
		ValaScope* _tmp9_;
		ValaParameter* _tmp10_;
		ValaParameter* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		ValaParameter* _tmp14_;
		ValaParameter* _tmp15_;
		_tmp4_ = vala_semantic_analyzer_get_this_type ((ValaSymbol*) m, (ValaTypeSymbol*) self);
		_tmp5_ = _tmp4_;
		_tmp6_ = vala_parameter_new ("this", _tmp5_, NULL);
		_tmp7_ = _tmp6_;
		vala_method_set_this_parameter (m, _tmp7_);
		_vala_code_node_unref0 (_tmp7_);
		_vala_code_node_unref0 (_tmp5_);
		_tmp8_ = vala_symbol_get_scope ((ValaSymbol*) m);
		_tmp9_ = _tmp8_;
		_tmp10_ = vala_method_get_this_parameter (m);
		_tmp11_ = _tmp10_;
		_tmp12_ = vala_symbol_get_name ((ValaSymbol*) _tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = vala_method_get_this_parameter (m);
		_tmp15_ = _tmp14_;
		vala_scope_add (_tmp9_, _tmp13_, (ValaSymbol*) _tmp15_);
	}
	_tmp17_ = vala_callable_get_return_type ((ValaCallable*) m);
	_tmp18_ = _tmp17_;
	if (!VALA_IS_VOID_TYPE (_tmp18_)) {
		ValaList* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		_tmp19_ = vala_method_get_postconditions (m);
		_tmp20_ = vala_collection_get_size ((ValaCollection*) _tmp19_);
		_tmp21_ = _tmp20_;
		_tmp16_ = _tmp21_ > 0;
	} else {
		_tmp16_ = FALSE;
	}
	if (_tmp16_) {
		ValaDataType* _tmp22_;
		ValaDataType* _tmp23_;
		ValaDataType* _tmp24_;
		ValaDataType* _tmp25_;
		ValaSourceReference* _tmp26_;
		ValaSourceReference* _tmp27_;
		ValaLocalVariable* _tmp28_;
		ValaLocalVariable* _tmp29_;
		ValaLocalVariable* _tmp30_;
		ValaLocalVariable* _tmp31_;
		_tmp22_ = vala_callable_get_return_type ((ValaCallable*) m);
		_tmp23_ = _tmp22_;
		_tmp24_ = vala_data_type_copy (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp27_ = _tmp26_;
		_tmp28_ = vala_local_variable_new (_tmp25_, "result", NULL, _tmp27_);
		_tmp29_ = _tmp28_;
		vala_subroutine_set_result_var ((ValaSubroutine*) m, _tmp29_);
		_vala_code_node_unref0 (_tmp29_);
		_vala_code_node_unref0 (_tmp25_);
		_tmp30_ = vala_subroutine_get_result_var ((ValaSubroutine*) m);
		_tmp31_ = _tmp30_;
		vala_local_variable_set_is_result (_tmp31_, TRUE);
	}
	VALA_SYMBOL_CLASS (vala_interface_parent_class)->add_method ((ValaSymbol*) G_TYPE_CHECK_INSTANCE_CAST (self, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol), m);
}

/**
 * Adds the specified property as a member to this interface.
 *
 * @param prop a property
 */
static void
vala_interface_real_add_property (ValaSymbol* base,
                                  ValaProperty* prop)
{
	ValaInterface * self;
	ValaField* _tmp0_;
	ValaField* _tmp1_;
	ValaMemberBinding _tmp4_;
	ValaMemberBinding _tmp5_;
	self = (ValaInterface*) base;
	g_return_if_fail (prop != NULL);
	_tmp0_ = vala_property_get_field (prop);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		ValaSourceReference* _tmp2_;
		ValaSourceReference* _tmp3_;
		_tmp2_ = vala_code_node_get_source_reference ((ValaCodeNode*) prop);
		_tmp3_ = _tmp2_;
		vala_report_error (_tmp3_, "interface properties should be `abstract' or have `get' accessor and/o" \
"r `set' mutator");
		vala_code_node_set_error ((ValaCodeNode*) prop, TRUE);
		return;
	}
	VALA_SYMBOL_CLASS (vala_interface_parent_class)->add_property ((ValaSymbol*) G_TYPE_CHECK_INSTANCE_CAST (self, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol), prop);
	_tmp4_ = vala_property_get_binding (prop);
	_tmp5_ = _tmp4_;
	if (_tmp5_ != VALA_MEMBER_BINDING_STATIC) {
		ValaDataType* _tmp6_;
		ValaDataType* _tmp7_;
		ValaParameter* _tmp8_;
		ValaParameter* _tmp9_;
		ValaScope* _tmp10_;
		ValaScope* _tmp11_;
		ValaParameter* _tmp12_;
		ValaParameter* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		ValaParameter* _tmp16_;
		ValaParameter* _tmp17_;
		_tmp6_ = vala_semantic_analyzer_get_this_type ((ValaSymbol*) prop, (ValaTypeSymbol*) self);
		_tmp7_ = _tmp6_;
		_tmp8_ = vala_parameter_new ("this", _tmp7_, NULL);
		_tmp9_ = _tmp8_;
		vala_property_set_this_parameter (prop, _tmp9_);
		_vala_code_node_unref0 (_tmp9_);
		_vala_code_node_unref0 (_tmp7_);
		_tmp10_ = vala_symbol_get_scope ((ValaSymbol*) prop);
		_tmp11_ = _tmp10_;
		_tmp12_ = vala_property_get_this_parameter (prop);
		_tmp13_ = _tmp12_;
		_tmp14_ = vala_symbol_get_name ((ValaSymbol*) _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = vala_property_get_this_parameter (prop);
		_tmp17_ = _tmp16_;
		vala_scope_add (_tmp11_, _tmp15_, (ValaSymbol*) _tmp17_);
	}
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

static ValaList*
vala_interface_real_get_virtuals (ValaInterface* self)
{
	ValaList* _tmp0_;
	ValaList* _tmp1_;
	ValaList* result = NULL;
	_tmp0_ = self->priv->virtuals;
	_tmp1_ = _vala_iterable_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

ValaList*
vala_interface_get_virtuals (ValaInterface* self)
{
	ValaInterfaceClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = VALA_INTERFACE_GET_CLASS (self);
	if (_klass_->get_virtuals) {
		return _klass_->get_virtuals (self);
	}
	return NULL;
}

static void
vala_interface_real_accept (ValaCodeNode* base,
                            ValaCodeVisitor* visitor)
{
	ValaInterface * self;
	self = (ValaInterface*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_interface (visitor, self);
}

static void
vala_interface_real_accept_children (ValaCodeNode* base,
                                     ValaCodeVisitor* visitor)
{
	ValaInterface * self;
	self = (ValaInterface*) base;
	g_return_if_fail (visitor != NULL);
	{
		ValaList* _type_list = NULL;
		ValaList* _tmp0_;
		gint _type_size = 0;
		ValaList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _type_index = 0;
		_tmp0_ = self->priv->prerequisites;
		_type_list = _tmp0_;
		_tmp1_ = _type_list;
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_type_size = _tmp3_;
		_type_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			ValaDataType* type = NULL;
			ValaList* _tmp6_;
			gpointer _tmp7_;
			ValaDataType* _tmp8_;
			_type_index = _type_index + 1;
			_tmp4_ = _type_index;
			_tmp5_ = _type_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _type_list;
			_tmp7_ = vala_list_get (_tmp6_, _type_index);
			type = (ValaDataType*) _tmp7_;
			_tmp8_ = type;
			vala_code_node_accept ((ValaCodeNode*) _tmp8_, visitor);
			_vala_code_node_unref0 (type);
		}
	}
	VALA_CODE_NODE_CLASS (vala_interface_parent_class)->accept_children ((ValaCodeNode*) G_TYPE_CHECK_INSTANCE_CAST (self, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol), visitor);
}

static gboolean
vala_interface_real_is_reference_type (ValaTypeSymbol* base)
{
	ValaInterface * self;
	gboolean result = FALSE;
	self = (ValaInterface*) base;
	result = TRUE;
	return result;
}

static gboolean
vala_interface_real_is_subtype_of (ValaTypeSymbol* base,
                                   ValaTypeSymbol* t)
{
	ValaInterface * self;
	gboolean result = FALSE;
	self = (ValaInterface*) base;
	g_return_val_if_fail (t != NULL, FALSE);
	if (G_TYPE_CHECK_INSTANCE_CAST (self, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol) == t) {
		result = TRUE;
		return result;
	}
	{
		ValaList* _prerequisite_list = NULL;
		ValaList* _tmp0_;
		gint _prerequisite_size = 0;
		ValaList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _prerequisite_index = 0;
		_tmp0_ = self->priv->prerequisites;
		_prerequisite_list = _tmp0_;
		_tmp1_ = _prerequisite_list;
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_prerequisite_size = _tmp3_;
		_prerequisite_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			ValaDataType* prerequisite = NULL;
			ValaList* _tmp6_;
			gpointer _tmp7_;
			gboolean _tmp8_ = FALSE;
			ValaDataType* _tmp9_;
			ValaTypeSymbol* _tmp10_;
			ValaTypeSymbol* _tmp11_;
			_prerequisite_index = _prerequisite_index + 1;
			_tmp4_ = _prerequisite_index;
			_tmp5_ = _prerequisite_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _prerequisite_list;
			_tmp7_ = vala_list_get (_tmp6_, _prerequisite_index);
			prerequisite = (ValaDataType*) _tmp7_;
			_tmp9_ = prerequisite;
			_tmp10_ = vala_data_type_get_type_symbol (_tmp9_);
			_tmp11_ = _tmp10_;
			if (_tmp11_ != NULL) {
				ValaDataType* _tmp12_;
				ValaTypeSymbol* _tmp13_;
				ValaTypeSymbol* _tmp14_;
				_tmp12_ = prerequisite;
				_tmp13_ = vala_data_type_get_type_symbol (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp8_ = vala_typesymbol_is_subtype_of (_tmp14_, t);
			} else {
				_tmp8_ = FALSE;
			}
			if (_tmp8_) {
				result = TRUE;
				_vala_code_node_unref0 (prerequisite);
				return result;
			}
			_vala_code_node_unref0 (prerequisite);
		}
	}
	result = FALSE;
	return result;
}

static void
vala_interface_real_replace_type (ValaCodeNode* base,
                                  ValaDataType* old_type,
                                  ValaDataType* new_type)
{
	ValaInterface * self;
	self = (ValaInterface*) base;
	g_return_if_fail (old_type != NULL);
	g_return_if_fail (new_type != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				ValaList* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				ValaList* _tmp5_;
				gpointer _tmp6_;
				ValaDataType* _tmp7_;
				gboolean _tmp8_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->prerequisites;
				_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
				_tmp4_ = _tmp3_;
				if (!(i < _tmp4_)) {
					break;
				}
				_tmp5_ = self->priv->prerequisites;
				_tmp6_ = vala_list_get (_tmp5_, i);
				_tmp7_ = (ValaDataType*) _tmp6_;
				_tmp8_ = _tmp7_ == old_type;
				_vala_code_node_unref0 (_tmp7_);
				if (_tmp8_) {
					ValaList* _tmp9_;
					_tmp9_ = self->priv->prerequisites;
					vala_list_set (_tmp9_, i, new_type);
					vala_code_node_set_parent_node ((ValaCodeNode*) new_type, (ValaCodeNode*) self);
					return;
				}
			}
		}
	}
}

static gpointer
_vala_source_file_ref0 (gpointer self)
{
	return self ? vala_source_file_ref (self) : NULL;
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

static gboolean
vala_interface_real_check (ValaCodeNode* base,
                           ValaCodeContext* context)
{
	ValaInterface * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaSourceFile* old_source_file = NULL;
	ValaSemanticAnalyzer* _tmp4_;
	ValaSemanticAnalyzer* _tmp5_;
	ValaSourceFile* _tmp6_;
	ValaSourceFile* _tmp7_;
	ValaSourceFile* _tmp8_;
	ValaSymbol* old_symbol = NULL;
	ValaSemanticAnalyzer* _tmp9_;
	ValaSemanticAnalyzer* _tmp10_;
	ValaSymbol* _tmp11_;
	ValaSymbol* _tmp12_;
	ValaSymbol* _tmp13_;
	ValaSourceReference* _tmp14_;
	ValaSourceReference* _tmp15_;
	ValaSemanticAnalyzer* _tmp22_;
	ValaSemanticAnalyzer* _tmp23_;
	ValaClass* prereq_class = NULL;
	gboolean _tmp123_;
	gboolean _tmp124_;
	ValaMap* positions = NULL;
	GHashFunc _tmp254_;
	GEqualFunc _tmp255_;
	GEqualFunc _tmp256_;
	ValaHashMap* _tmp257_;
	gboolean ordered_seen = FALSE;
	gboolean unordered_seen = FALSE;
	ValaSemanticAnalyzer* _tmp322_;
	ValaSemanticAnalyzer* _tmp323_;
	ValaSourceFile* _tmp324_;
	ValaSemanticAnalyzer* _tmp325_;
	ValaSemanticAnalyzer* _tmp326_;
	ValaSymbol* _tmp327_;
	gboolean _tmp328_;
	gboolean _tmp329_;
	gboolean result = FALSE;
	self = (ValaInterface*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	if (!VALA_CODE_NODE_CLASS (vala_interface_parent_class)->check ((ValaCodeNode*) G_TYPE_CHECK_INSTANCE_CAST (self, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol), context)) {
		result = FALSE;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_code_context_get_analyzer (context);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_semantic_analyzer_get_current_source_file (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _vala_source_file_ref0 (_tmp7_);
	old_source_file = _tmp8_;
	_tmp9_ = vala_code_context_get_analyzer (context);
	_tmp10_ = _tmp9_;
	_tmp11_ = vala_semantic_analyzer_get_current_symbol (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = _vala_code_node_ref0 (_tmp12_);
	old_symbol = _tmp13_;
	_tmp14_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
	_tmp15_ = _tmp14_;
	if (_tmp15_ != NULL) {
		ValaSemanticAnalyzer* _tmp16_;
		ValaSemanticAnalyzer* _tmp17_;
		ValaSourceReference* _tmp18_;
		ValaSourceReference* _tmp19_;
		ValaSourceFile* _tmp20_;
		ValaSourceFile* _tmp21_;
		_tmp16_ = vala_code_context_get_analyzer (context);
		_tmp17_ = _tmp16_;
		_tmp18_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp19_ = _tmp18_;
		_tmp20_ = vala_source_reference_get_file (_tmp19_);
		_tmp21_ = _tmp20_;
		vala_semantic_analyzer_set_current_source_file (_tmp17_, _tmp21_);
	}
	_tmp22_ = vala_code_context_get_analyzer (context);
	_tmp23_ = _tmp22_;
	vala_semantic_analyzer_set_current_symbol (_tmp23_, (ValaSymbol*) self);
	{
		ValaList* _prerequisite_reference_list = NULL;
		ValaList* _tmp24_;
		gint _prerequisite_reference_size = 0;
		ValaList* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gint _prerequisite_reference_index = 0;
		_tmp24_ = vala_interface_get_prerequisites (self);
		_prerequisite_reference_list = _tmp24_;
		_tmp25_ = _prerequisite_reference_list;
		_tmp26_ = vala_collection_get_size ((ValaCollection*) _tmp25_);
		_tmp27_ = _tmp26_;
		_prerequisite_reference_size = _tmp27_;
		_prerequisite_reference_index = -1;
		while (TRUE) {
			gint _tmp28_;
			gint _tmp29_;
			ValaDataType* prerequisite_reference = NULL;
			ValaList* _tmp30_;
			gpointer _tmp31_;
			ValaSemanticAnalyzer* _tmp32_;
			ValaSemanticAnalyzer* _tmp33_;
			ValaDataType* _tmp34_;
			_prerequisite_reference_index = _prerequisite_reference_index + 1;
			_tmp28_ = _prerequisite_reference_index;
			_tmp29_ = _prerequisite_reference_size;
			if (!(_tmp28_ < _tmp29_)) {
				break;
			}
			_tmp30_ = _prerequisite_reference_list;
			_tmp31_ = vala_list_get (_tmp30_, _prerequisite_reference_index);
			prerequisite_reference = (ValaDataType*) _tmp31_;
			_tmp32_ = vala_code_context_get_analyzer (context);
			_tmp33_ = _tmp32_;
			_tmp34_ = prerequisite_reference;
			if (!vala_semantic_analyzer_is_type_accessible (_tmp33_, (ValaSymbol*) self, _tmp34_)) {
				ValaSourceReference* _tmp35_;
				ValaSourceReference* _tmp36_;
				ValaDataType* _tmp37_;
				gchar* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp35_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp36_ = _tmp35_;
				_tmp37_ = prerequisite_reference;
				_tmp38_ = vala_code_node_to_string ((ValaCodeNode*) _tmp37_);
				_tmp39_ = _tmp38_;
				_tmp40_ = vala_symbol_get_full_name ((ValaSymbol*) self);
				_tmp41_ = _tmp40_;
				vala_report_error (_tmp36_, "prerequisite `%s' is less accessible than interface `%s'", _tmp39_, _tmp41_);
				_g_free0 (_tmp41_);
				_g_free0 (_tmp39_);
				result = FALSE;
				_vala_code_node_unref0 (prerequisite_reference);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
			_vala_code_node_unref0 (prerequisite_reference);
		}
	}
	prereq_class = NULL;
	{
		ValaList* _prereq_list = NULL;
		ValaList* _tmp42_;
		gint _prereq_size = 0;
		ValaList* _tmp43_;
		gint _tmp44_;
		gint _tmp45_;
		gint _prereq_index = 0;
		_tmp42_ = vala_interface_get_prerequisites (self);
		_prereq_list = _tmp42_;
		_tmp43_ = _prereq_list;
		_tmp44_ = vala_collection_get_size ((ValaCollection*) _tmp43_);
		_tmp45_ = _tmp44_;
		_prereq_size = _tmp45_;
		_prereq_index = -1;
		while (TRUE) {
			gint _tmp46_;
			gint _tmp47_;
			ValaDataType* prereq = NULL;
			ValaList* _tmp48_;
			gpointer _tmp49_;
			ValaDataType* _tmp50_;
			ValaDataType* _tmp58_;
			ValaTypeSymbol* _tmp59_;
			ValaTypeSymbol* _tmp60_;
			_prereq_index = _prereq_index + 1;
			_tmp46_ = _prereq_index;
			_tmp47_ = _prereq_size;
			if (!(_tmp46_ < _tmp47_)) {
				break;
			}
			_tmp48_ = _prereq_list;
			_tmp49_ = vala_list_get (_tmp48_, _prereq_index);
			prereq = (ValaDataType*) _tmp49_;
			_tmp50_ = prereq;
			if (!VALA_IS_OBJECT_TYPE (_tmp50_)) {
				ValaSourceReference* _tmp51_;
				ValaSourceReference* _tmp52_;
				ValaDataType* _tmp53_;
				gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
				gchar* _tmp57_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp51_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp52_ = _tmp51_;
				_tmp53_ = prereq;
				_tmp54_ = vala_code_node_to_string ((ValaCodeNode*) _tmp53_);
				_tmp55_ = _tmp54_;
				_tmp56_ = vala_symbol_get_full_name ((ValaSymbol*) self);
				_tmp57_ = _tmp56_;
				vala_report_error (_tmp52_, "Prerequisite `%s' of interface `%s' is not a class or interface", _tmp55_, _tmp57_);
				_g_free0 (_tmp57_);
				_g_free0 (_tmp55_);
				result = FALSE;
				_vala_code_node_unref0 (prereq);
				_vala_code_node_unref0 (prereq_class);
				_vala_code_node_unref0 (old_symbol);
				_vala_source_file_unref0 (old_source_file);
				return result;
			}
			_tmp58_ = prereq;
			_tmp59_ = vala_data_type_get_type_symbol (_tmp58_);
			_tmp60_ = _tmp59_;
			if (VALA_IS_CLASS (_tmp60_)) {
				ValaClass* _tmp61_;
				ValaDataType* _tmp74_;
				ValaTypeSymbol* _tmp75_;
				ValaTypeSymbol* _tmp76_;
				ValaClass* _tmp77_;
				_tmp61_ = prereq_class;
				if (_tmp61_ != NULL) {
					ValaSourceReference* _tmp62_;
					ValaSourceReference* _tmp63_;
					gchar* _tmp64_;
					gchar* _tmp65_;
					ValaDataType* _tmp66_;
					ValaTypeSymbol* _tmp67_;
					ValaTypeSymbol* _tmp68_;
					gchar* _tmp69_;
					gchar* _tmp70_;
					ValaClass* _tmp71_;
					gchar* _tmp72_;
					gchar* _tmp73_;
					vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					_tmp62_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp63_ = _tmp62_;
					_tmp64_ = vala_symbol_get_full_name ((ValaSymbol*) self);
					_tmp65_ = _tmp64_;
					_tmp66_ = prereq;
					_tmp67_ = vala_data_type_get_type_symbol (_tmp66_);
					_tmp68_ = _tmp67_;
					_tmp69_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp68_);
					_tmp70_ = _tmp69_;
					_tmp71_ = prereq_class;
					_tmp72_ = vala_symbol_get_full_name ((ValaSymbol*) _tmp71_);
					_tmp73_ = _tmp72_;
					vala_report_error (_tmp63_, "%s: Interfaces cannot have multiple instantiable prerequisites (`%s' a" \
"nd `%s')", _tmp65_, _tmp70_, _tmp73_);
					_g_free0 (_tmp73_);
					_g_free0 (_tmp70_);
					_g_free0 (_tmp65_);
					result = FALSE;
					_vala_code_node_unref0 (prereq);
					_vala_code_node_unref0 (prereq_class);
					_vala_code_node_unref0 (old_symbol);
					_vala_source_file_unref0 (old_source_file);
					return result;
				}
				_tmp74_ = prereq;
				_tmp75_ = vala_data_type_get_type_symbol (_tmp74_);
				_tmp76_ = _tmp75_;
				_tmp77_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, VALA_TYPE_CLASS, ValaClass));
				_vala_code_node_unref0 (prereq_class);
				prereq_class = _tmp77_;
			}
			_vala_code_node_unref0 (prereq);
		}
	}
	{
		ValaList* _type_list = NULL;
		ValaList* _tmp78_;
		gint _type_size = 0;
		ValaList* _tmp79_;
		gint _tmp80_;
		gint _tmp81_;
		gint _type_index = 0;
		_tmp78_ = self->priv->prerequisites;
		_type_list = _tmp78_;
		_tmp79_ = _type_list;
		_tmp80_ = vala_collection_get_size ((ValaCollection*) _tmp79_);
		_tmp81_ = _tmp80_;
		_type_size = _tmp81_;
		_type_index = -1;
		while (TRUE) {
			gint _tmp82_;
			gint _tmp83_;
			ValaDataType* type = NULL;
			ValaList* _tmp84_;
			gpointer _tmp85_;
			ValaDataType* _tmp86_;
			_type_index = _type_index + 1;
			_tmp82_ = _type_index;
			_tmp83_ = _type_size;
			if (!(_tmp82_ < _tmp83_)) {
				break;
			}
			_tmp84_ = _type_list;
			_tmp85_ = vala_list_get (_tmp84_, _type_index);
			type = (ValaDataType*) _tmp85_;
			_tmp86_ = type;
			vala_code_node_check ((ValaCodeNode*) _tmp86_, context);
			_vala_code_node_unref0 (type);
		}
	}
	{
		ValaList* _p_list = NULL;
		ValaList* _tmp87_;
		gint _p_size = 0;
		ValaList* _tmp88_;
		gint _tmp89_;
		gint _tmp90_;
		gint _p_index = 0;
		_tmp87_ = vala_object_type_symbol_get_type_parameters ((ValaObjectTypeSymbol*) self);
		_p_list = _tmp87_;
		_tmp88_ = _p_list;
		_tmp89_ = vala_collection_get_size ((ValaCollection*) _tmp88_);
		_tmp90_ = _tmp89_;
		_p_size = _tmp90_;
		_p_index = -1;
		while (TRUE) {
			gint _tmp91_;
			gint _tmp92_;
			ValaTypeParameter* p = NULL;
			ValaList* _tmp93_;
			gpointer _tmp94_;
			ValaTypeParameter* _tmp95_;
			_p_index = _p_index + 1;
			_tmp91_ = _p_index;
			_tmp92_ = _p_size;
			if (!(_tmp91_ < _tmp92_)) {
				break;
			}
			_tmp93_ = _p_list;
			_tmp94_ = vala_list_get (_tmp93_, _p_index);
			p = (ValaTypeParameter*) _tmp94_;
			_tmp95_ = p;
			vala_code_node_check ((ValaCodeNode*) _tmp95_, context);
			_vala_code_node_unref0 (p);
		}
	}
	{
		ValaList* _en_list = NULL;
		ValaList* _tmp96_;
		gint _en_size = 0;
		ValaList* _tmp97_;
		gint _tmp98_;
		gint _tmp99_;
		gint _en_index = 0;
		_tmp96_ = vala_object_type_symbol_get_enums ((ValaObjectTypeSymbol*) self);
		_en_list = _tmp96_;
		_tmp97_ = _en_list;
		_tmp98_ = vala_collection_get_size ((ValaCollection*) _tmp97_);
		_tmp99_ = _tmp98_;
		_en_size = _tmp99_;
		_en_index = -1;
		while (TRUE) {
			gint _tmp100_;
			gint _tmp101_;
			ValaEnum* en = NULL;
			ValaList* _tmp102_;
			gpointer _tmp103_;
			ValaEnum* _tmp104_;
			_en_index = _en_index + 1;
			_tmp100_ = _en_index;
			_tmp101_ = _en_size;
			if (!(_tmp100_ < _tmp101_)) {
				break;
			}
			_tmp102_ = _en_list;
			_tmp103_ = vala_list_get (_tmp102_, _en_index);
			en = (ValaEnum*) _tmp103_;
			_tmp104_ = en;
			vala_code_node_check ((ValaCodeNode*) _tmp104_, context);
			_vala_code_node_unref0 (en);
		}
	}
	{
		ValaList* _f_list = NULL;
		ValaList* _tmp105_;
		gint _f_size = 0;
		ValaList* _tmp106_;
		gint _tmp107_;
		gint _tmp108_;
		gint _f_index = 0;
		_tmp105_ = vala_object_type_symbol_get_fields ((ValaObjectTypeSymbol*) self);
		_f_list = _tmp105_;
		_tmp106_ = _f_list;
		_tmp107_ = vala_collection_get_size ((ValaCollection*) _tmp106_);
		_tmp108_ = _tmp107_;
		_f_size = _tmp108_;
		_f_index = -1;
		while (TRUE) {
			gint _tmp109_;
			gint _tmp110_;
			ValaField* f = NULL;
			ValaList* _tmp111_;
			gpointer _tmp112_;
			ValaField* _tmp113_;
			_f_index = _f_index + 1;
			_tmp109_ = _f_index;
			_tmp110_ = _f_size;
			if (!(_tmp109_ < _tmp110_)) {
				break;
			}
			_tmp111_ = _f_list;
			_tmp112_ = vala_list_get (_tmp111_, _f_index);
			f = (ValaField*) _tmp112_;
			_tmp113_ = f;
			vala_code_node_check ((ValaCodeNode*) _tmp113_, context);
			_vala_code_node_unref0 (f);
		}
	}
	{
		ValaList* _c_list = NULL;
		ValaList* _tmp114_;
		gint _c_size = 0;
		ValaList* _tmp115_;
		gint _tmp116_;
		gint _tmp117_;
		gint _c_index = 0;
		_tmp114_ = vala_object_type_symbol_get_constants ((ValaObjectTypeSymbol*) self);
		_c_list = _tmp114_;
		_tmp115_ = _c_list;
		_tmp116_ = vala_collection_get_size ((ValaCollection*) _tmp115_);
		_tmp117_ = _tmp116_;
		_c_size = _tmp117_;
		_c_index = -1;
		while (TRUE) {
			gint _tmp118_;
			gint _tmp119_;
			ValaConstant* c = NULL;
			ValaList* _tmp120_;
			gpointer _tmp121_;
			ValaConstant* _tmp122_;
			_c_index = _c_index + 1;
			_tmp118_ = _c_index;
			_tmp119_ = _c_size;
			if (!(_tmp118_ < _tmp119_)) {
				break;
			}
			_tmp120_ = _c_list;
			_tmp121_ = vala_list_get (_tmp120_, _c_index);
			c = (ValaConstant*) _tmp121_;
			_tmp122_ = c;
			vala_code_node_check ((ValaCodeNode*) _tmp122_, context);
			_vala_code_node_unref0 (c);
		}
	}
	_tmp123_ = vala_code_context_get_abi_stability (context);
	_tmp124_ = _tmp123_;
	if (_tmp124_) {
		{
			ValaList* _s_list = NULL;
			ValaList* _tmp125_;
			gint _s_size = 0;
			ValaList* _tmp126_;
			gint _tmp127_;
			gint _tmp128_;
			gint _s_index = 0;
			_tmp125_ = vala_object_type_symbol_get_members ((ValaObjectTypeSymbol*) self);
			_s_list = _tmp125_;
			_tmp126_ = _s_list;
			_tmp127_ = vala_collection_get_size ((ValaCollection*) _tmp126_);
			_tmp128_ = _tmp127_;
			_s_size = _tmp128_;
			_s_index = -1;
			while (TRUE) {
				gint _tmp129_;
				gint _tmp130_;
				ValaSymbol* s = NULL;
				ValaList* _tmp131_;
				gpointer _tmp132_;
				ValaSymbol* _tmp133_;
				_s_index = _s_index + 1;
				_tmp129_ = _s_index;
				_tmp130_ = _s_size;
				if (!(_tmp129_ < _tmp130_)) {
					break;
				}
				_tmp131_ = _s_list;
				_tmp132_ = vala_list_get (_tmp131_, _s_index);
				s = (ValaSymbol*) _tmp132_;
				_tmp133_ = s;
				if (VALA_IS_METHOD (_tmp133_)) {
					ValaMethod* m = NULL;
					ValaSymbol* _tmp134_;
					ValaMethod* _tmp135_;
					ValaMethod* _tmp136_;
					gboolean _tmp137_ = FALSE;
					ValaMethod* _tmp138_;
					gboolean _tmp139_;
					gboolean _tmp140_;
					_tmp134_ = s;
					_tmp135_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp134_, VALA_TYPE_METHOD, ValaMethod));
					m = _tmp135_;
					_tmp136_ = m;
					vala_code_node_check ((ValaCodeNode*) _tmp136_, context);
					_tmp138_ = m;
					_tmp139_ = vala_method_get_is_virtual (_tmp138_);
					_tmp140_ = _tmp139_;
					if (_tmp140_) {
						_tmp137_ = TRUE;
					} else {
						ValaMethod* _tmp141_;
						gboolean _tmp142_;
						gboolean _tmp143_;
						_tmp141_ = m;
						_tmp142_ = vala_method_get_is_abstract (_tmp141_);
						_tmp143_ = _tmp142_;
						_tmp137_ = _tmp143_;
					}
					if (_tmp137_) {
						ValaList* _tmp144_;
						ValaMethod* _tmp145_;
						_tmp144_ = self->priv->virtuals;
						_tmp145_ = m;
						vala_collection_add ((ValaCollection*) _tmp144_, (ValaSymbol*) _tmp145_);
					}
					_vala_code_node_unref0 (m);
				} else {
					ValaSymbol* _tmp146_;
					_tmp146_ = s;
					if (VALA_IS_SIGNAL (_tmp146_)) {
						ValaSignal* sig = NULL;
						ValaSymbol* _tmp147_;
						ValaSignal* _tmp148_;
						ValaSignal* _tmp149_;
						ValaSignal* _tmp150_;
						gboolean _tmp151_;
						gboolean _tmp152_;
						_tmp147_ = s;
						_tmp148_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp147_, VALA_TYPE_SIGNAL, ValaSignal));
						sig = _tmp148_;
						_tmp149_ = sig;
						vala_code_node_check ((ValaCodeNode*) _tmp149_, context);
						_tmp150_ = sig;
						_tmp151_ = vala_signal_get_is_virtual (_tmp150_);
						_tmp152_ = _tmp151_;
						if (_tmp152_) {
							ValaList* _tmp153_;
							ValaSignal* _tmp154_;
							_tmp153_ = self->priv->virtuals;
							_tmp154_ = sig;
							vala_collection_add ((ValaCollection*) _tmp153_, (ValaSymbol*) _tmp154_);
						}
						_vala_code_node_unref0 (sig);
					} else {
						ValaSymbol* _tmp155_;
						_tmp155_ = s;
						if (VALA_IS_PROPERTY (_tmp155_)) {
							ValaProperty* prop = NULL;
							ValaSymbol* _tmp156_;
							ValaProperty* _tmp157_;
							ValaProperty* _tmp158_;
							gboolean _tmp159_ = FALSE;
							ValaProperty* _tmp160_;
							gboolean _tmp161_;
							gboolean _tmp162_;
							_tmp156_ = s;
							_tmp157_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp156_, VALA_TYPE_PROPERTY, ValaProperty));
							prop = _tmp157_;
							_tmp158_ = prop;
							vala_code_node_check ((ValaCodeNode*) _tmp158_, context);
							_tmp160_ = prop;
							_tmp161_ = vala_property_get_is_virtual (_tmp160_);
							_tmp162_ = _tmp161_;
							if (_tmp162_) {
								_tmp159_ = TRUE;
							} else {
								ValaProperty* _tmp163_;
								gboolean _tmp164_;
								gboolean _tmp165_;
								_tmp163_ = prop;
								_tmp164_ = vala_property_get_is_abstract (_tmp163_);
								_tmp165_ = _tmp164_;
								_tmp159_ = _tmp165_;
							}
							if (_tmp159_) {
								ValaList* _tmp166_;
								ValaProperty* _tmp167_;
								_tmp166_ = self->priv->virtuals;
								_tmp167_ = prop;
								vala_collection_add ((ValaCollection*) _tmp166_, (ValaSymbol*) _tmp167_);
							}
							_vala_code_node_unref0 (prop);
						}
					}
				}
				_vala_code_node_unref0 (s);
			}
		}
	} else {
		{
			ValaList* _m_list = NULL;
			ValaList* _tmp168_;
			gint _m_size = 0;
			ValaList* _tmp169_;
			gint _tmp170_;
			gint _tmp171_;
			gint _m_index = 0;
			_tmp168_ = vala_object_type_symbol_get_methods ((ValaObjectTypeSymbol*) self);
			_m_list = _tmp168_;
			_tmp169_ = _m_list;
			_tmp170_ = vala_collection_get_size ((ValaCollection*) _tmp169_);
			_tmp171_ = _tmp170_;
			_m_size = _tmp171_;
			_m_index = -1;
			while (TRUE) {
				gint _tmp172_;
				gint _tmp173_;
				ValaMethod* m = NULL;
				ValaList* _tmp174_;
				gpointer _tmp175_;
				ValaMethod* _tmp176_;
				gboolean _tmp177_ = FALSE;
				ValaMethod* _tmp178_;
				gboolean _tmp179_;
				gboolean _tmp180_;
				_m_index = _m_index + 1;
				_tmp172_ = _m_index;
				_tmp173_ = _m_size;
				if (!(_tmp172_ < _tmp173_)) {
					break;
				}
				_tmp174_ = _m_list;
				_tmp175_ = vala_list_get (_tmp174_, _m_index);
				m = (ValaMethod*) _tmp175_;
				_tmp176_ = m;
				vala_code_node_check ((ValaCodeNode*) _tmp176_, context);
				_tmp178_ = m;
				_tmp179_ = vala_method_get_is_virtual (_tmp178_);
				_tmp180_ = _tmp179_;
				if (_tmp180_) {
					_tmp177_ = TRUE;
				} else {
					ValaMethod* _tmp181_;
					gboolean _tmp182_;
					gboolean _tmp183_;
					_tmp181_ = m;
					_tmp182_ = vala_method_get_is_abstract (_tmp181_);
					_tmp183_ = _tmp182_;
					_tmp177_ = _tmp183_;
				}
				if (_tmp177_) {
					ValaList* _tmp184_;
					ValaMethod* _tmp185_;
					_tmp184_ = self->priv->virtuals;
					_tmp185_ = m;
					vala_collection_add ((ValaCollection*) _tmp184_, (ValaSymbol*) _tmp185_);
				}
				_vala_code_node_unref0 (m);
			}
		}
		{
			ValaList* _sig_list = NULL;
			ValaList* _tmp186_;
			gint _sig_size = 0;
			ValaList* _tmp187_;
			gint _tmp188_;
			gint _tmp189_;
			gint _sig_index = 0;
			_tmp186_ = vala_object_type_symbol_get_signals ((ValaObjectTypeSymbol*) self);
			_sig_list = _tmp186_;
			_tmp187_ = _sig_list;
			_tmp188_ = vala_collection_get_size ((ValaCollection*) _tmp187_);
			_tmp189_ = _tmp188_;
			_sig_size = _tmp189_;
			_sig_index = -1;
			while (TRUE) {
				gint _tmp190_;
				gint _tmp191_;
				ValaSignal* sig = NULL;
				ValaList* _tmp192_;
				gpointer _tmp193_;
				ValaSignal* _tmp194_;
				ValaSignal* _tmp195_;
				gboolean _tmp196_;
				gboolean _tmp197_;
				_sig_index = _sig_index + 1;
				_tmp190_ = _sig_index;
				_tmp191_ = _sig_size;
				if (!(_tmp190_ < _tmp191_)) {
					break;
				}
				_tmp192_ = _sig_list;
				_tmp193_ = vala_list_get (_tmp192_, _sig_index);
				sig = (ValaSignal*) _tmp193_;
				_tmp194_ = sig;
				vala_code_node_check ((ValaCodeNode*) _tmp194_, context);
				_tmp195_ = sig;
				_tmp196_ = vala_signal_get_is_virtual (_tmp195_);
				_tmp197_ = _tmp196_;
				if (_tmp197_) {
					ValaList* _tmp198_;
					ValaSignal* _tmp199_;
					_tmp198_ = self->priv->virtuals;
					_tmp199_ = sig;
					vala_collection_add ((ValaCollection*) _tmp198_, (ValaSymbol*) _tmp199_);
				}
				_vala_code_node_unref0 (sig);
			}
		}
		{
			ValaList* _prop_list = NULL;
			ValaList* _tmp200_;
			gint _prop_size = 0;
			ValaList* _tmp201_;
			gint _tmp202_;
			gint _tmp203_;
			gint _prop_index = 0;
			_tmp200_ = vala_object_type_symbol_get_properties ((ValaObjectTypeSymbol*) self);
			_prop_list = _tmp200_;
			_tmp201_ = _prop_list;
			_tmp202_ = vala_collection_get_size ((ValaCollection*) _tmp201_);
			_tmp203_ = _tmp202_;
			_prop_size = _tmp203_;
			_prop_index = -1;
			while (TRUE) {
				gint _tmp204_;
				gint _tmp205_;
				ValaProperty* prop = NULL;
				ValaList* _tmp206_;
				gpointer _tmp207_;
				ValaProperty* _tmp208_;
				gboolean _tmp209_ = FALSE;
				ValaProperty* _tmp210_;
				gboolean _tmp211_;
				gboolean _tmp212_;
				_prop_index = _prop_index + 1;
				_tmp204_ = _prop_index;
				_tmp205_ = _prop_size;
				if (!(_tmp204_ < _tmp205_)) {
					break;
				}
				_tmp206_ = _prop_list;
				_tmp207_ = vala_list_get (_tmp206_, _prop_index);
				prop = (ValaProperty*) _tmp207_;
				_tmp208_ = prop;
				vala_code_node_check ((ValaCodeNode*) _tmp208_, context);
				_tmp210_ = prop;
				_tmp211_ = vala_property_get_is_virtual (_tmp210_);
				_tmp212_ = _tmp211_;
				if (_tmp212_) {
					_tmp209_ = TRUE;
				} else {
					ValaProperty* _tmp213_;
					gboolean _tmp214_;
					gboolean _tmp215_;
					_tmp213_ = prop;
					_tmp214_ = vala_property_get_is_abstract (_tmp213_);
					_tmp215_ = _tmp214_;
					_tmp209_ = _tmp215_;
				}
				if (_tmp209_) {
					ValaList* _tmp216_;
					ValaProperty* _tmp217_;
					_tmp216_ = self->priv->virtuals;
					_tmp217_ = prop;
					vala_collection_add ((ValaCollection*) _tmp216_, (ValaSymbol*) _tmp217_);
				}
				_vala_code_node_unref0 (prop);
			}
		}
	}
	{
		ValaList* _cl_list = NULL;
		ValaList* _tmp218_;
		gint _cl_size = 0;
		ValaList* _tmp219_;
		gint _tmp220_;
		gint _tmp221_;
		gint _cl_index = 0;
		_tmp218_ = vala_object_type_symbol_get_classes ((ValaObjectTypeSymbol*) self);
		_cl_list = _tmp218_;
		_tmp219_ = _cl_list;
		_tmp220_ = vala_collection_get_size ((ValaCollection*) _tmp219_);
		_tmp221_ = _tmp220_;
		_cl_size = _tmp221_;
		_cl_index = -1;
		while (TRUE) {
			gint _tmp222_;
			gint _tmp223_;
			ValaClass* cl = NULL;
			ValaList* _tmp224_;
			gpointer _tmp225_;
			ValaClass* _tmp226_;
			_cl_index = _cl_index + 1;
			_tmp222_ = _cl_index;
			_tmp223_ = _cl_size;
			if (!(_tmp222_ < _tmp223_)) {
				break;
			}
			_tmp224_ = _cl_list;
			_tmp225_ = vala_list_get (_tmp224_, _cl_index);
			cl = (ValaClass*) _tmp225_;
			_tmp226_ = cl;
			vala_code_node_check ((ValaCodeNode*) _tmp226_, context);
			_vala_code_node_unref0 (cl);
		}
	}
	{
		ValaList* _iface_list = NULL;
		ValaList* _tmp227_;
		gint _iface_size = 0;
		ValaList* _tmp228_;
		gint _tmp229_;
		gint _tmp230_;
		gint _iface_index = 0;
		_tmp227_ = vala_object_type_symbol_get_interfaces ((ValaObjectTypeSymbol*) self);
		_iface_list = _tmp227_;
		_tmp228_ = _iface_list;
		_tmp229_ = vala_collection_get_size ((ValaCollection*) _tmp228_);
		_tmp230_ = _tmp229_;
		_iface_size = _tmp230_;
		_iface_index = -1;
		while (TRUE) {
			gint _tmp231_;
			gint _tmp232_;
			ValaInterface* iface = NULL;
			ValaList* _tmp233_;
			gpointer _tmp234_;
			ValaInterface* _tmp235_;
			_iface_index = _iface_index + 1;
			_tmp231_ = _iface_index;
			_tmp232_ = _iface_size;
			if (!(_tmp231_ < _tmp232_)) {
				break;
			}
			_tmp233_ = _iface_list;
			_tmp234_ = vala_list_get (_tmp233_, _iface_index);
			iface = (ValaInterface*) _tmp234_;
			_tmp235_ = iface;
			vala_code_node_check ((ValaCodeNode*) _tmp235_, context);
			_vala_code_node_unref0 (iface);
		}
	}
	{
		ValaList* _st_list = NULL;
		ValaList* _tmp236_;
		gint _st_size = 0;
		ValaList* _tmp237_;
		gint _tmp238_;
		gint _tmp239_;
		gint _st_index = 0;
		_tmp236_ = vala_object_type_symbol_get_structs ((ValaObjectTypeSymbol*) self);
		_st_list = _tmp236_;
		_tmp237_ = _st_list;
		_tmp238_ = vala_collection_get_size ((ValaCollection*) _tmp237_);
		_tmp239_ = _tmp238_;
		_st_size = _tmp239_;
		_st_index = -1;
		while (TRUE) {
			gint _tmp240_;
			gint _tmp241_;
			ValaStruct* st = NULL;
			ValaList* _tmp242_;
			gpointer _tmp243_;
			ValaStruct* _tmp244_;
			_st_index = _st_index + 1;
			_tmp240_ = _st_index;
			_tmp241_ = _st_size;
			if (!(_tmp240_ < _tmp241_)) {
				break;
			}
			_tmp242_ = _st_list;
			_tmp243_ = vala_list_get (_tmp242_, _st_index);
			st = (ValaStruct*) _tmp243_;
			_tmp244_ = st;
			vala_code_node_check ((ValaCodeNode*) _tmp244_, context);
			_vala_code_node_unref0 (st);
		}
	}
	{
		ValaList* _d_list = NULL;
		ValaList* _tmp245_;
		gint _d_size = 0;
		ValaList* _tmp246_;
		gint _tmp247_;
		gint _tmp248_;
		gint _d_index = 0;
		_tmp245_ = vala_object_type_symbol_get_delegates ((ValaObjectTypeSymbol*) self);
		_d_list = _tmp245_;
		_tmp246_ = _d_list;
		_tmp247_ = vala_collection_get_size ((ValaCollection*) _tmp246_);
		_tmp248_ = _tmp247_;
		_d_size = _tmp248_;
		_d_index = -1;
		while (TRUE) {
			gint _tmp249_;
			gint _tmp250_;
			ValaDelegate* d = NULL;
			ValaList* _tmp251_;
			gpointer _tmp252_;
			ValaDelegate* _tmp253_;
			_d_index = _d_index + 1;
			_tmp249_ = _d_index;
			_tmp250_ = _d_size;
			if (!(_tmp249_ < _tmp250_)) {
				break;
			}
			_tmp251_ = _d_list;
			_tmp252_ = vala_list_get (_tmp251_, _d_index);
			d = (ValaDelegate*) _tmp252_;
			_tmp253_ = d;
			vala_code_node_check ((ValaCodeNode*) _tmp253_, context);
			_vala_code_node_unref0 (d);
		}
	}
	_tmp254_ = g_direct_hash;
	_tmp255_ = g_direct_equal;
	_tmp256_ = g_direct_equal;
	_tmp257_ = vala_hash_map_new (G_TYPE_INT, NULL, NULL, VALA_TYPE_SYMBOL, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp254_, _tmp255_, _tmp256_);
	positions = (ValaMap*) _tmp257_;
	ordered_seen = FALSE;
	unordered_seen = FALSE;
	{
		ValaList* _sym_list = NULL;
		ValaList* _tmp258_;
		gint _sym_size = 0;
		ValaList* _tmp259_;
		gint _tmp260_;
		gint _tmp261_;
		gint _sym_index = 0;
		_tmp258_ = self->priv->virtuals;
		_sym_list = _tmp258_;
		_tmp259_ = _sym_list;
		_tmp260_ = vala_collection_get_size ((ValaCollection*) _tmp259_);
		_tmp261_ = _tmp260_;
		_sym_size = _tmp261_;
		_sym_index = -1;
		while (TRUE) {
			gint _tmp262_;
			gint _tmp263_;
			ValaSymbol* sym = NULL;
			ValaList* _tmp264_;
			gpointer _tmp265_;
			gint ordering = 0;
			ValaSymbol* _tmp266_;
			gboolean ordered = FALSE;
			gboolean _tmp273_ = FALSE;
			gboolean _tmp274_ = FALSE;
			gboolean _tmp281_ = FALSE;
			gboolean _tmp282_ = FALSE;
			gboolean _tmp283_ = FALSE;
			gboolean _tmp290_ = FALSE;
			gboolean _tmp291_ = FALSE;
			_sym_index = _sym_index + 1;
			_tmp262_ = _sym_index;
			_tmp263_ = _sym_size;
			if (!(_tmp262_ < _tmp263_)) {
				break;
			}
			_tmp264_ = _sym_list;
			_tmp265_ = vala_list_get (_tmp264_, _sym_index);
			sym = (ValaSymbol*) _tmp265_;
			_tmp266_ = sym;
			ordering = vala_code_node_get_attribute_integer ((ValaCodeNode*) _tmp266_, "CCode", "ordering", -1);
			if (ordering < -1) {
				ValaSymbol* _tmp267_;
				ValaSourceReference* _tmp268_;
				ValaSourceReference* _tmp269_;
				ValaSymbol* _tmp270_;
				gchar* _tmp271_;
				gchar* _tmp272_;
				_tmp267_ = sym;
				_tmp268_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp267_);
				_tmp269_ = _tmp268_;
				_tmp270_ = sym;
				_tmp271_ = vala_symbol_get_full_name (_tmp270_);
				_tmp272_ = _tmp271_;
				vala_report_error (_tmp269_, "%s: Invalid ordering", _tmp272_);
				_g_free0 (_tmp272_);
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				ordered_seen = TRUE;
				unordered_seen = TRUE;
				_vala_code_node_unref0 (sym);
				continue;
			}
			ordered = ordering != -1;
			if (ordered) {
				_tmp274_ = unordered_seen;
			} else {
				_tmp274_ = FALSE;
			}
			if (_tmp274_) {
				_tmp273_ = !ordered_seen;
			} else {
				_tmp273_ = FALSE;
			}
			if (_tmp273_) {
				ValaSymbol* _tmp275_;
				ValaSourceReference* _tmp276_;
				ValaSourceReference* _tmp277_;
				ValaSymbol* _tmp278_;
				gchar* _tmp279_;
				gchar* _tmp280_;
				_tmp275_ = sym;
				_tmp276_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp275_);
				_tmp277_ = _tmp276_;
				_tmp278_ = sym;
				_tmp279_ = vala_symbol_get_full_name (_tmp278_);
				_tmp280_ = _tmp279_;
				vala_report_error (_tmp277_, "%s: Cannot mix ordered and unordered virtuals", _tmp280_);
				_g_free0 (_tmp280_);
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			}
			if (ordered_seen) {
				_tmp281_ = TRUE;
			} else {
				_tmp281_ = ordered;
			}
			ordered_seen = _tmp281_;
			if (!ordered) {
				_tmp283_ = !unordered_seen;
			} else {
				_tmp283_ = FALSE;
			}
			if (_tmp283_) {
				_tmp282_ = ordered_seen;
			} else {
				_tmp282_ = FALSE;
			}
			if (_tmp282_) {
				ValaSymbol* _tmp284_;
				ValaSourceReference* _tmp285_;
				ValaSourceReference* _tmp286_;
				ValaSymbol* _tmp287_;
				gchar* _tmp288_;
				gchar* _tmp289_;
				_tmp284_ = sym;
				_tmp285_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp284_);
				_tmp286_ = _tmp285_;
				_tmp287_ = sym;
				_tmp288_ = vala_symbol_get_full_name (_tmp287_);
				_tmp289_ = _tmp288_;
				vala_report_error (_tmp286_, "%s: Cannot mix ordered and unordered virtuals", _tmp289_);
				_g_free0 (_tmp289_);
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
			}
			if (unordered_seen) {
				_tmp290_ = TRUE;
			} else {
				_tmp290_ = !ordered;
			}
			unordered_seen = _tmp290_;
			if (!ordered_seen) {
				_tmp291_ = TRUE;
			} else {
				_tmp291_ = !unordered_seen;
			}
			if (_tmp291_) {
				if (ordered) {
					ValaSymbol* prev = NULL;
					ValaMap* _tmp292_;
					gpointer _tmp293_;
					ValaSymbol* _tmp294_;
					ValaMap* _tmp304_;
					ValaSymbol* _tmp305_;
					_tmp292_ = positions;
					_tmp293_ = vala_map_get (_tmp292_, (gpointer) ((gintptr) ordering));
					prev = (ValaSymbol*) _tmp293_;
					_tmp294_ = prev;
					if (_tmp294_ != NULL) {
						ValaSymbol* _tmp295_;
						ValaSourceReference* _tmp296_;
						ValaSourceReference* _tmp297_;
						ValaSymbol* _tmp298_;
						gchar* _tmp299_;
						gchar* _tmp300_;
						ValaSymbol* _tmp301_;
						const gchar* _tmp302_;
						const gchar* _tmp303_;
						_tmp295_ = sym;
						_tmp296_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp295_);
						_tmp297_ = _tmp296_;
						_tmp298_ = sym;
						_tmp299_ = vala_symbol_get_full_name (_tmp298_);
						_tmp300_ = _tmp299_;
						_tmp301_ = prev;
						_tmp302_ = vala_symbol_get_name (_tmp301_);
						_tmp303_ = _tmp302_;
						vala_report_error (_tmp297_, "%s: Duplicate ordering (previous virtual with the same position is %s)", _tmp300_, _tmp303_);
						_g_free0 (_tmp300_);
						vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					}
					_tmp304_ = positions;
					_tmp305_ = sym;
					vala_map_set (_tmp304_, (gpointer) ((gintptr) ordering), _tmp305_);
					_vala_code_node_unref0 (prev);
				}
			}
			_vala_code_node_unref0 (sym);
		}
	}
	if (ordered_seen) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp306_ = FALSE;
				_tmp306_ = TRUE;
				while (TRUE) {
					ValaList* _tmp308_;
					gint _tmp309_;
					gint _tmp310_;
					ValaSymbol* sym = NULL;
					ValaMap* _tmp311_;
					gpointer _tmp312_;
					ValaSymbol* _tmp313_;
					gboolean _tmp318_;
					gboolean _tmp319_;
					if (!_tmp306_) {
						gint _tmp307_;
						_tmp307_ = i;
						i = _tmp307_ + 1;
					}
					_tmp306_ = FALSE;
					_tmp308_ = self->priv->virtuals;
					_tmp309_ = vala_collection_get_size ((ValaCollection*) _tmp308_);
					_tmp310_ = _tmp309_;
					if (!(i < _tmp310_)) {
						break;
					}
					_tmp311_ = positions;
					_tmp312_ = vala_map_get (_tmp311_, (gpointer) ((gintptr) i));
					sym = (ValaSymbol*) _tmp312_;
					_tmp313_ = sym;
					if (_tmp313_ == NULL) {
						ValaSourceReference* _tmp314_;
						ValaSourceReference* _tmp315_;
						gchar* _tmp316_;
						gchar* _tmp317_;
						_tmp314_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
						_tmp315_ = _tmp314_;
						_tmp316_ = vala_symbol_get_full_name ((ValaSymbol*) self);
						_tmp317_ = _tmp316_;
						vala_report_error (_tmp315_, "%s: Gap in ordering in position %d", _tmp317_, i);
						_g_free0 (_tmp317_);
						vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
					}
					_tmp318_ = vala_code_node_get_error ((ValaCodeNode*) self);
					_tmp319_ = _tmp318_;
					if (!_tmp319_) {
						ValaList* _tmp320_;
						ValaSymbol* _tmp321_;
						_tmp320_ = self->priv->virtuals;
						_tmp321_ = sym;
						vala_list_set (_tmp320_, i, _tmp321_);
					}
					_vala_code_node_unref0 (sym);
				}
			}
		}
	}
	_tmp322_ = vala_code_context_get_analyzer (context);
	_tmp323_ = _tmp322_;
	_tmp324_ = old_source_file;
	vala_semantic_analyzer_set_current_source_file (_tmp323_, _tmp324_);
	_tmp325_ = vala_code_context_get_analyzer (context);
	_tmp326_ = _tmp325_;
	_tmp327_ = old_symbol;
	vala_semantic_analyzer_set_current_symbol (_tmp326_, _tmp327_);
	_tmp328_ = vala_code_node_get_error ((ValaCodeNode*) self);
	_tmp329_ = _tmp328_;
	result = !_tmp329_;
	_vala_map_unref0 (positions);
	_vala_code_node_unref0 (prereq_class);
	_vala_code_node_unref0 (old_symbol);
	_vala_source_file_unref0 (old_source_file);
	return result;
}

static void
vala_interface_class_init (ValaInterfaceClass * klass,
                           gpointer klass_data)
{
	vala_interface_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_interface_finalize;
	g_type_class_adjust_private_offset (klass, &ValaInterface_private_offset);
	((ValaSymbolClass *) klass)->add_method = (void (*) (ValaSymbol*, ValaMethod*)) vala_interface_real_add_method;
	((ValaSymbolClass *) klass)->add_property = (void (*) (ValaSymbol*, ValaProperty*)) vala_interface_real_add_property;
	((ValaInterfaceClass *) klass)->get_virtuals = (ValaList* (*) (ValaInterface*)) vala_interface_real_get_virtuals;
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_interface_real_accept;
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_interface_real_accept_children;
	((ValaTypeSymbolClass *) klass)->is_reference_type = (gboolean (*) (ValaTypeSymbol*)) vala_interface_real_is_reference_type;
	((ValaTypeSymbolClass *) klass)->is_subtype_of = (gboolean (*) (ValaTypeSymbol*, ValaTypeSymbol*)) vala_interface_real_is_subtype_of;
	((ValaCodeNodeClass *) klass)->replace_type = (void (*) (ValaCodeNode*, ValaDataType*, ValaDataType*)) vala_interface_real_replace_type;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode*, ValaCodeContext*)) vala_interface_real_check;
}

static void
vala_interface_instance_init (ValaInterface * self,
                              gpointer klass)
{
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	GEqualFunc _tmp2_;
	ValaArrayList* _tmp3_;
	self->priv = vala_interface_get_instance_private (self);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_DATA_TYPE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp0_);
	self->priv->prerequisites = (ValaList*) _tmp1_;
	_tmp2_ = g_direct_equal;
	_tmp3_ = vala_array_list_new (VALA_TYPE_SYMBOL, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp2_);
	self->priv->virtuals = (ValaList*) _tmp3_;
}

static void
vala_interface_finalize (ValaCodeNode * obj)
{
	ValaInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_INTERFACE, ValaInterface);
	_vala_iterable_unref0 (self->priv->prerequisites);
	_vala_iterable_unref0 (self->priv->virtuals);
	VALA_CODE_NODE_CLASS (vala_interface_parent_class)->finalize (obj);
}

/**
 * Represents an interface declaration in the source code.
 */
static GType
vala_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaInterfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_interface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaInterface), 0, (GInstanceInitFunc) vala_interface_instance_init, NULL };
	GType vala_interface_type_id;
	vala_interface_type_id = g_type_register_static (VALA_TYPE_OBJECT_TYPE_SYMBOL, "ValaInterface", &g_define_type_info, 0);
	ValaInterface_private_offset = g_type_add_instance_private (vala_interface_type_id, sizeof (ValaInterfacePrivate));
	return vala_interface_type_id;
}

GType
vala_interface_get_type (void)
{
	static volatile gsize vala_interface_type_id__volatile = 0;
	if (g_once_init_enter (&vala_interface_type_id__volatile)) {
		GType vala_interface_type_id;
		vala_interface_type_id = vala_interface_get_type_once ();
		g_once_init_leave (&vala_interface_type_id__volatile, vala_interface_type_id);
	}
	return vala_interface_type_id__volatile;
}

